2013-02-09 (r7361) Alexander Chernov  <cher@ejudge.ru>

	* super_html_7.c, filter_expr.y, super-serve.c, super_html.c, ej-import-contest.c, new_server_html_2.c, new_server_html_3.c, super-serve.h, new_server_html_4.c, super_html.h, new_server_html_5.c, teamdb.c, clntutil.c, new-server-cmd.c, users.c, teamdb.h, serve-control.c, new_server_html.c, clntutil.h, filter_tree.c, new-client.c, protocol.h, filter_tree.h, team_extra_xml.c, xml_utils.h, serve_state.h, team_extra.c, filter_eval.c, team_extra.h, new-server.h, contests.c, super_html_2.c, super_html_3.c, super_html_4.c, serve_2.c:
	IPv6 suport is implemented.

2013-02-09 (r7358) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c, new_server_html_4.c, new_server_html_5.c, teamdb.c, userlist-server.c, userlist_clnt.h, super-serve.c, users.c, serve-control.c, userlist_proto.h:
	IPv6 support implementation is in progress...

2013-02-09 (r7356) Alexander Chernov  <cher@ejudge.ru>

	* contests_2.c, uldb_plugin_xml.c, xml_utils.h, new_server_html_3.c, new_server_html_4.c, new_server_html_5.c, super_html.h, userlist_xml.c, edit-userlist.c, users.c, contests.c, new_server_html.c, super_html_2.c, super_html_4.c, super_html_6.c, contests.h, uldb_plugin.h, contest_tmpl.c, userlist-server.c, userlist.h, super_html.c:
	support for IPv6 is in progress...

2013-02-08 (r7355) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c, new_server_html_2.c, new_server_html_4.c, runlog.c, runlog.h:
	support for IPv6 is implemented (partially).

2013-02-08 (r7352) Alexander Chernov  <cher@ejudge.ru>

	* xml_utils.h:
	(xml_parse_ipv6_2) new function prototype;
	(xml_make_ipv6) new function prototype;
	(xml_make_ipv4) new function prototype.

	* clarlog.h:
	IPv6 support is implemented for clars.

	* clarlog.c, new_server_html.c, new_server_html_2.c:
	IPv6 support is implemented for clars.

2013-02-06 (r7343) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	(serve_check_user_quota) off by one bug is fixed;
	(serve_check_clar_quota) off by one bug is fixed.

2013-02-05 (r7339) Alexander Chernov  <cher@ejudge.ru>

	* teamdb.c, new-server-cmd.c, clntutil.c, rldb_plugin_file.c, users.c, teamdb.h, serve-control.c, userlist_proto.h, clntutil.h, filter_tree.c, new-client.c, protocol.h, uldb_plugin.h, filter_tree.h, contest_tmpl.c, userlist.h, cldb_plugin_file.c, contests_2.c, xml_utils.h, ej_types.h, team_extra.c, serve_state.h, edit-userlist.c, team_extra.h, userlist_clnt.h, contests.c, new-server.h, super_html_2.c, super_html_3.c, super_html_4.c, serve_2.c, runlog.c, contests.h, contests_meta.c, runlog.h, contests_meta.h, userlist-server.c, super-serve.c, super_html.c, ej-import-contest.c, clarlog.c, new_server_html_2.c, uldb_plugin_xml.c, super-serve.h, super-serve_meta.c, super_html.h, clarlog.h, super-serve_meta.h:
	copyright notice is updated;
	ej_ip_t -> ej_ip4_t;
	transition to IPv6 support is started.

2013-02-02 (r7334) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	more rejudging tasks are implemented as background jobs.

2013-01-29 (r7325) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	background jobs are being implemented.

2013-01-27 (r7321) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h:
	(serve_rejudge_by_mask) return type is changed;
	'create_job_flag' parameter is added;
	(serve_rejudge_problem) return type is changed;
	'create_job_flag' parameter is added;
	(serve_judge_suspended) return type is changed;
	'create_job_flag' parameter is added.

	* new_server_html.c:
	calls of 'serve_judge_suspended', 'serve_rejudge_by_mask',
	'serve_rejudge_problem' are updated.

	* new_server_html_4.c:
	calls of 'serve_judge_suspended' are updated.

	* serve_2.c:
	(serve_rejudge_by_mask) return type is changed;
	'create_job_flag' parameter is added;
	(serve_rejudge_problem) return type is changed;
	'create_job_flag' parameter is added;
	(serve_judge_suspended) return type is changed;
	'create_job_flag' parameter is added.

	* serve_state.c:
	call of 'serve_judge_suspended' is updated.

2013-01-27 (r7319) Alexander Chernov  <cher@ejudge.ru>

	* server_framework.h:
	(struct server_framework_job_funcs) 'get_status' method is added.

	* new_server_html.c:
	job status is printed.

	* serve_2.c:
	(rejudge_all_get_status) new function.

2013-01-27 (r7317) Alexander Chernov  <cher@ejudge.ru>

	* curtime.h: copyright notice is updated;
	(get_current_time_ms) new function prototype.

	* run_common.c:
	(invoke_nwrun) better support for nwrun timeouts.

2013-01-26 (r7313) Alexander Chernov  <cher@ejudge.ru>

	* server_framework.h:
	<time.h> is included;
	(struct server_framework_job) fields 'start_time', 'title' are added.

	* new_server_html.c:
	(priv_main_page) the list of background jobs is printed.

	* serve_2.c:
	rejudge_all background functions are updated.

2013-01-26 (r7308) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	(ns_add_job) new function prototype;
	(ns_remove_job) new function prototype.

	* serve_state.h:
	(serve_rejudge_all) return type is changed;
	  'create_job_flag' parameter is added.

	* server_framework.h:
	support for background jobs is added.

	* new_server_html.c:
	support for background jobs is added;
	(ns_add_job) new function;
	(ns_remove_job) new function;
	(ns_loop_callback) background jobs are supported;
	(priv_rejudge_all) background rejudge mode is supported;
	(priv_confirmation_page) background rejudge mode is supported.

	* new_server_html_4.c:
	background rejudge mode is supported.

	* serve_2.c:
	"server_framework.h" is included;
	support for background rejudge jobs is partially added.

2013-01-26 (r7306) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c:
	(unpriv_main_page) EOLN type selection dialog fixed.

2013-01-26 (r7304) Alexander Chernov  <cher@ejudge.ru>

	* run_common:
	(run_one_test) added check for strange running time value.

2013-01-25 (r7301) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h: copyright notice is updated;
	(ns_loop_callback) return type changed to int.

	* server_framework.h: copyright notice is updated;
	(struct server_framework_params) 'loop_start' returns int.

	* new_server_html.c:
	(ns_loop_callback) only 100 packets are processed at a time.

	* server_framework.c: copyright notice is updated;
	(nsf_main_loop) responsiveness under high load is improved.

2013-01-25 (r7296) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c:
	NULL pointer check is improved.

2013-01-23 (r7293) Alexander Chernov  <cher@ejudge.ru>

	* lang_config_vis.c: copyright notice is updated;
	'is_dos' configuration option is added.

2013-01-23 (r7290) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of 'is_dos' language configuration variable is supported.

	* serve-control.c, super_html_3.c, super-serve.c, super_proto.c:
	editing of 'is_dos' language configuration variable is supported.

2013-01-23 (r7288) Alexander Chernov  <cher@ejudge.ru>

	* runlog.h:
	(run_add_record) 'eoln_type' parameter is added.

	* new_server_html.c, new_server_html_2.c, new_server_html_4.c:
	selection of desired EOLN type is supported;
	calls of run_add_record are updated.

	* runlog.c:
	(run_add_record) 'eoln_type' parameter is added.

2013-01-23 (r7286) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of 'enable_eoln_select' global configuration variable
	is supported.

	* prepare.h:
	(struct section_global_data) 'enable_eoln_select' field is added.

	* prepare.c, prepare_out.c:
	global configuration variable 'enable_eoln_select' is added.

	* serve-control.c, super-serve.c, super_html_3.c, super_html_4.c, super_proto.c:
	editing of 'enable_eoln_select' global configuration variable
	is supported.

2013-01-23 (r7284) Alexander Chernov  <cher@ejudge.ru>

	* ej_types.h:
	(eoln_type_unparse_html) new function prototype.

	* html.h: copyright notice is updated;
	'RUN_VIEW_EOLN_TYPE' is added.

	* serve_state.h:
	(serve_run_request) 'eoln_type' parameter is added.

	* ej-batch.c: copyright notice is updated;
	call of 'process_compile_packet' is updated.

	* new_server_html.c: copyright notice is updated;
	calls of 'serve_run_request' are updated.

	* new_server_html_2.c: copyright notice is updated;
	(ns_write_priv_all_runs) display of 'eoln_type' column is supported;
	(ns_write_priv_source) display of 'eoln_type' is supported;
	(ns_priv_edit_run_page) display of 'eoln_type' is supported;
	(ns_priv_edit_run_action) editing of 'eoln_type' is supported.

	* new_server_html_4.c: copyright notice is updated;
	calls of 'serve_run_request' are updated.

	* problem_common.c: copyright notice is updated;
	(eoln_type_unparse_html) new function.

	* serve_2.c:
	(serve_run_request) 'eoln_type' parameter is added.

2013-01-23 (r7281) Alexander Chernov  <cher@ejudge.ru>

	* runlog.h: copyright notice is updated;
	'eoln_type' field is added.

	* ej_types.h: copyright notice is updated;
	valid EOLN type enumeration is added.

	* rldb_plugin_file.c: copyright notice is updated;
	'eoln_type' field is added.

	* runlog.c: copyright notice is updated;
	'eoln_type' field is added.

2013-01-22 (r7278) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_language_data) 'is_dos' field is added.

	* serve_state.h: copyright notice is updated;
	(struct compile_run_extra) 'is_dos' field is added.

	* super_run_packet.h: copyright notice is updated;
	(struct super_run_in_global_packet) field 'is_dos' is added.

	* prepare.c, prepare_out.c:
	'is_dos' language configuration variable is added.

	* run_common.c: copyright notice is updated;
	(run_one_test) 'is_dos' global field is handled.

	* serve_2.c: copyright notice is updated;
	language 'is_dos' parameter is passed to run.

	* super_run_packet.c: copyright notice is updated;
	'is_dos' field is handled.

2013-01-20 (r7274) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h: copyright notice is updated;
	(struct section_problem_data) 'score_latest_marked' field is added.

	* problem_config.h: copyright notice is updated;
	(struct problem_config_section) 'score_latest_marked' field is added.

	* super_proto.h: copyright notice is updated;
	editing of 'score_latest_marked' problem configuration variable
	is supported.

	* ej-import-contest.c: copyright notice is updated;
	'score_latest_marked' problem parameter is handled.

	* prepare.c, prepare_out.c: copyright notice is updated;
	'score_latest_marked' problem configuration variable is supported.

	* serve-control.c, super-serve.c, super_html_3.c, super_html_4.c, super_proto.c: copyright notice is updated;
	editing of 'score_latest_marked' problem configuration variable
	is supported.

2013-01-18 (r7270) Alexander Chernov  <cher@ejudge.ru>

	* copyright.c: copyright notice is updated.

2013-01-08 (r7268) Alexander Chernov  <cher@ejudge.ru>

	* master_html.c, html.c:
	skipped tests are excluded from verbose reporting

2012-12-20 (r7259) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h:
	(serve_compile_request) 'variant' parameter is added.

	* new_server_html.c, new_server_html_4.c, ej-batch.c:
	calls to 'serve_compile_request' are updated.

	* serve_2.c:
	(serve_compile_request) 'variant' parameter is added;
	(serve_rejudge_run) call of 'serve_compile_request' is updated.

2012-12-14 (r7248) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_priv_edit_run_action) variant editing is improved.

2012-12-14 (r7246) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'max_user_run_count' field is added.

	* problem_config.h:
	(struct problem_config_section) 'max_user_run_count' field is added.

	* super_proto.h:
	editing of 'max_user_run_count' problem configuration variable
	is supported.

	* ej-import-contest.c:
	'max_user_run_count' problem configuration variable is supported.

	* prepare.c, prepare_out.c:
	'max_user_run_count' problem configuration variable is supported.

	* serve-control.c, super-serve.c, super_html_3.c, super_proto.c:
	editing of 'max_user_run_count' problem configuration variable
	is supported.

2012-12-12 (r7244) Alexander Chernov  <cher@ejudge.ru>

	* build_support.c:
	(is_makefile_rule_needed) new function;
	(do_generate_makefile) rules only for those files, which are
	  marked by 'is_makefile_rule_needed' are generated.

2012-12-11 (r7241) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	'problem_dir' incoming parameter is passed to the valuer.

	* serve_2.c:
	'problem_dir' parameter is passed to ej-super-run.

2012-12-11 (r7239) Alexander Chernov  <cher@ejudge.ru>

	* super_run_packet.h:
	(struct super_run_in_problem_packet) 'problem_dir' field is added.

2012-12-11 (r7237) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	SKIPPED tests are correctly marked HIDDEN.

2012-12-09 (r7233) Alexander Chernov  <cher@ejudge.ru>

	* cgi.c:
	default content_length is 0, not INT_MAX.

2012-12-09 (r7230) Alexander Chernov  <cher@ejudge.ru>

	* run.h:
	(struct testinfo) 'checker_score' is removed.

	* runlog.h:
	RUN_SKIPPED is added.

	* html.c:
	(write_xml_team_testing_report) comment is not printed.

	* run_common.c:
	improvements to the interactive valuer support.

	* runlog_static.c:
	RUN_SKIPPED is added.

2012-12-09 (r7224) Alexander Chernov  <cher@ejudge.ru>

	* ej_process.h:
	(ejudge_timed_write) 'log' parameter is added;
	(ejudge_timed_fdgets) 'log' parameter is added.

	* master_html.c:
	(write_xml_testing_report) 'Note' renamed to 'Testing messages'.

	* run_common.c:
	interative valuer improvements.

2012-12-08 (r7220) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	"ej_process.h" is included;
	(parse_valuer_score) new function;
	(read_log_file) new function;
	(run_tests) initial implementation of interactive valuer support.

2012-12-08 (r7218) Alexander Chernov  <cher@ejudge.ru>

	* ej_process.h:
	(ejudge_timed_write) new function prototype;
	(ejudge_timed_fdgets) new function prototype.

	* run_common.c:
	progress in implementing interactive valuer.

2012-12-05 (r7208) Alexander Chernov  <cher@ejudge.ru>

	* ej-import-contest.c, super_run_packet.c:
	'interactive_valuer', 'disable_pe', 'disable_wtl' configuration
	variables are supported.

	* prepare.c, prepare_out.c, serve_2.c:
	'interactive_valuer', 'disable_pe', 'disable_wtl' problem configuration
	variables are supported.

	* run_common.c:
	'disable_pe', 'disable_wtl' problem configuration variables are handled.

	* serve-control.c, super_html_3.c, super_html_4.c, super_proto.c, super-serve.c:
	editing of 'interactive_valuer', 'disable_pe', 'disable_wtl' problem
	configuration variables is supported.

2012-12-05 (r7206) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) new fields 'interactive_valuer',
	'disable_pe', 'disable_wtl' are added.

	* problem_config.h:
	(struct problem_config_section) new fields 'interactive_valuer',
	'disable_pe', 'disable_wtl' are added.

	* super_proto.h:
	editing of new problem configuration variables 'interactive_valuer',
	'disable_pe', 'disable_wtl' is supported.

	* super_run_packet.h:
	(struct super_run_in_problem_packet) new fields 'interactive_valuer',
	'disable_pe', 'disable_wtl' are added.

2012-12-05 (r7204) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	(serve_read_compile_packet) RUN_COMPILED status change is skipped.

2012-12-05 (r7201) Alexander Chernov  <cher@ejudge.ru>

	* fileutl.h:
	"reuse_xalloc.h" is included;
	(get_file_list) new function prototype.

	* new_server_html.c:
	(ns_loop_callback) all compile and run reply packets are processed
	instead of only one.

2012-12-04 (r7198) Alexander Chernov  <cher@ejudge.ru>

	* compile.c, ej-super-run.c, run.c, run_common.c:
	semaphore-based serialization is commented out.

2012-12-04 (r7196) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	(invoke_valuer) 'EJUDGE_MARKED' environment variable is set to '1' if
	  'valuer_sets_marked' is set;
	  'EJUDGE' environment variable is set to '1';
	(invoke_interactor) 'EJUDGE' environment variable is set to '1';
	(invoke_checker) 'EJUDGE_SCORING_CHECKER' environment variable is set
	  to '1' if 'scoring_checker' is set;
	  'EJUDGE' environment variable is set to '1'.

2012-12-04 (r7194) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(get_accepting_passed_tests) deleted problems are handled better.

2012-12-04 (r7193) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	(dur_to_str) integer overflow is fixed.

2012-11-20 (r7184) Alexander Chernov  <cher@ejudge.ru>

	* contests.c:
	(handle_final_tag) empty elements are allowed.

2012-11-18 (r7180) Alexander Chernov  <cher@ejudge.ru>

	* reuse_exec.h:
	(task_TryProcessGroup) new function prototype;
	(task_KillProcessGroup) new function prototype.

	* run_common.c:
	(run_one_test) new functions from "reuse_exec.h" are used.

2012-11-18 (r7176) Alexander Chernov  <cher@ejudge.ru>

	* build_support.c, ej-import-contest.c, super_html_3.c:
	(do_generate_makefile) 'input_file' and 'output_file' problem
	configuration variables are handled.

2012-11-15 (r7167) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c:
	(set_defaults) missing tester section is allowed.

	* serve_2.c:
	(serve_run_request) missing tester section is handled correctly.

	* super_run_packet.c:
	(super_run_in_packet_free_tester) new function.

2012-11-15 (r7166) Alexander Chernov  <cher@ejudge.ru>

	* super_run_packet.h:
	(super_run_in_packet_free_tester) new function prototype.

2012-11-15 (r7164) Alexander Chernov  <cher@ejudge.ru>

	* ej-import-contest.c:
	support for 'enable_process_group' and 'start_env' problem
	configuration variables is added.

	* prepare.c, prepare_out.c:
	'start_env' problem configuration variable is added.

	* run_common.c:
	'start_env' problem configuration variable is handled.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c, super_proto.c:
	editing of 'start_env' problem configuration variable is supported.

	* serve_2.c:
	(serve_run_request) 'start_env' problem configuration variable is
	passed to the tester.

2012-11-15 (r7163) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'start_env' field is added.

	* problem_config.h:
	(struct problem_config_section) 'start_env' field is added.

	* super_proto.h:
	editing of 'start_env' problem configuration variable is supported.

	* super_run_packet.h:
	(struct super_run_in_problem_packet) 'start_env' field is added.

2012-11-14 (r7161) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c, prepare_out.c:
	'enable_process_group' problem configuration variable is added.

	* run_common.c:
	(run_one_test) 'enable_process_group' is handled.

	* serve-control.c, super_html_3.c, super_html_4.c, super_proto.c, super-serve.c:
	editing of 'enable_process_group' problem configuration variable
	is supported.

	* serve_2.c:
	'enable_process_group' is passed to the tester.

	* super_run_packet.c:
	'enable_process_group' is supported.

2012-11-14 (r7160) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'enable_process_group' field is added.

	* problem_config.h:
	(struct problem_config_section) 'enable_process_group' field is added.

	* super_proto.h:
	editing of 'enable_process_group' parameter is supported.

	* super_run_packet.h:
	(struct super_run_in_problem_packet) 'enable_process_group' is added.

2012-11-14 (r7159) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	(run_tests) 0 tests is ok situation for OLYMPIAD contests in
	accepting mode with tests_to_accept == 0.

2012-11-11 (r7157) Alexander Chernov  <cher@ejudge.ru>

	* execute.c:
	some support for --tgzdir-pattern option is implemented.

2012-11-09 (r7154) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	'ignore_prev_ac' works for OLYMPIAD contests.

2012-11-07 (r7150) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_write_priv_all_runs) bug in form generation for virtual
	start/stop entry removal is fixed.

2012-11-06 (r7147) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	action 'NEW_SRV_ACTION_PRIV_SET_RUN_STYLE_ERR' renamed to
	  'NEW_SRV_ACTION_PRIV_SET_RUN_REJECTED'.

	* runlog.h:
	'RUN_REJECTED' status is added.

	* filter_scan.lex, html.c, master_html.c, new_server_html.c, new_server_html_2.c, new_server_html_4.c, reports.c, runlog.c, runlog_static.c, serve_2.c:
	RUN_REJECTED status is handled.

	* new_server_tables.c: copyright notice is updated;
	action 'NEW_SRV_ACTION_PRIV_SET_RUN_STYLE_ERR' renamed to
	  'NEW_SRV_ACTION_PRIV_SET_RUN_REJECTED'.

2012-11-05 (r7145) Alexander Chernov  <cher@ejudge.ru>

	* ej-super-run.c:
	LC_CTYPE is set to C in all testing configurations.

2012-11-04 (r7143) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	mysql linking options are really needed.

2012-11-04 (r7141) Alexander Chernov  <cher@ejudge.ru>

	* super_run_packet.c:
	(super_run_in_problem_packet_set_default) 'min_tests_to_accept'
	  should not be set to 0 by default.

2012-11-04 (r7137) Alexander Chernov  <cher@ejudge.ru>

	* nwrun_packet.h:
	(nwrun_in_packet_print) new function prototype.

	* filter_tree.c:
	missing <regex.h> is handled (based on CONF_HAS_REGEX).

	* nwrun.c: copyright notice is updated;
	bugfixes.

	* nwrun_packet.c:
	(nwrun_in_packet_print) new function.

2012-11-04 (r7130) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	(invoke_nwrun) 'check_dir' parameter is added;
	cases for invalid or missing 'tst' pointer are properly handled.

	* testing_report_xml.c:
	"tests-passed" attribute is allowed in ACM mode.

2012-11-04 (r7126) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.win32.in: copyright notice is updated;
	-mno-cygwin is removed.

	* config.h.in:
	CONF_HAS_REGEX is added.

	* configure.ac:
	check for <regex.h> is added.

2012-11-03 (r7123) Alexander Chernov  <cher@ejudge.ru>

	* prepare_dflt.h: copyright notice is updated;
	'DFLT_G_REJUDGE_PRIORITY_ADJUSTMENT' is added with value 10.

	* serve_state.h:
	(serve_rejudge_problem) 'priority_adjustment' parameter is added;
	(serve_judge_suspended) 'priority_adjustment' parameter is added;
	(serve_rejudge_all) 'priority_adjustment' parameter is added;
	(serve_judge_virtual_olympiad) the same.

	* new_server_html.c, new_server_html_4.c:
	"prepare_dflt.h" is included;
	calls to 'serve_judge_suspended', 'serve_rejudge_run',
	'serve_rejudge_problem' are updated.

	* new_server_html_2.c:
	calls to 'serve_judge_suspended', 'serve_rejudge_run',
	'serve_rejudge_problem' are updated.

	* serve_2.c:
	(serve_rejudge_problem) 'priority_adjustment' parameter is added;
	(serve_judge_suspended) 'priority_adjustment' parameter is added;
	(serve_rejudge_all) 'priority_adjustment' parameter is added;
	(serve_judge_virtual_olympiad) the same.

	* serve_state.c:
	(serve_state_destroy) call to 'serve_judge_suspended' is updated.

2012-11-01 (r7117) Alexander Chernov  <cher@ejudge.ru>

	* runlog.h:
	(struct run_entry) type of 'passed_mode' is changed to signed char.

	* html.c, master_html.c, new_server_html.c, new_server_html_2.c, new_server_html_4.c, reports.c:
	'passed_mode' field of 'run_entry' is properly handled.

	* rldb_plugin_file.c, runlog_xml.c:
	handling of 'passed_mode' field is improved.

2012-11-01 (r7114) Alexander Chernov  <cher@ejudge.ru>

	* rldb_plugin.h: copyright notice is updated;
	(run_change_status) 'new_passed_mode' parameter is added;
	(run_change_status_2) the same;
	(run_change_status_3) the same.

	* runlog.h:
	(run_change_status) 'newpassedmode' parameter is added;
	(run_change_status_2) the same;
	(run_change_status_3) the same.

	* run_packet.h:
	(struct run_reply_packet) field 'tests_passed' is added.

	* run_packet_priv.h:
	(struct run_reply_bin_packet) field 'tests_passed' is added.

	* new_server_html.c:
	(priv_submit_run_comment) call of 'run_change_status_3' is updated.

	* rldb_plugin_file.c:
	(change_status_func) 'new_passed_mode' parameter is added;
	(change_status_2_func) 'new_passed_mode' parameter is added;
	(change_status_3_func) 'new_passed_mode' parameter is added.

	* run_common.c:
	(generate_xml_report) 'tests-passed' attribute is always generated;
	(check_output_only) 'tests_passed' field is filled up;
	(run_tests) 'tests_passed' field is filled up.

	* runlog.c:
	(run_change_status) 'newpassedmode' parameter is added;
	(run_change_status_2) the same;
	(run_change_status_3) the same.

	* run_packet_4.c: copyright notice is updated;
	(run_reply_packet_read) 'tests_passed' field is processed.

	* run_packet_5.c: copyright notice is updated;
	(run_reply_packet_write) 'tests_passed' field is processed;
	(run_reply_packet_dump) the same.

	* serve_2.c:
	calls of 'run_change_status*' are updated.

2012-11-01 (r7111) Alexander Chernov  <cher@ejudge.ru>

	* rldb_plugin_file.c, runlog.c, runlog_xml.c:
	handling of new field 'passed_mode' is added.

2012-11-01 (r7109) Alexander Chernov  <cher@ejudge.ru>

	* runlog.h:
	(struct run_entry) 'test' field size reduced to 2;
	  new field 'is_passed' is added.

2012-11-01 (r7107) Alexander Chernov  <cher@ejudge.ru>

	* html.c:
	(write_html_run_status) test printing is improved.

2012-10-31 (r7105) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	--disable-rpath is supported for mysql options detection.

2012-10-27 (r7098) Alexander Chernov  <cher@ejudge.ru>

	* userlist-server.c:
	password recovery rules are relaxed.

2012-10-25 (r7090) Alexander Chernov  <cher@ejudge.ru>

	* lang_config_vis.h: copyright notice is updated;
	(lang_configure_screen) 'compile_home_dir' parameter is added;
	(lang_configure_batch) 'compile_home_dir' parameter is added;
	(lang_config_menu) 'compile_home_dir' parameter is added.

	* lang_config_vis.c:
	the scheme of assigning language ids is reworked and improved;
	(struct lang_id_info) field 'fixed' is added;
	(append_lang_id_info) new function;
	(add_to_lang_id_set) new function;
	(process_compile_cfg) new function;
	(process_lang_id_file) new function;
	(parse_lang_id_file) reworked to parse the current 'compile.cfg'
	file and extract language ids from it;
	(assign_lang_ids) reworked to minimize conflicts.
	(reconfigure_all_languages) 'compile_home_dir' parameter is added;
	(lang_configure_screen) 'compile_home_dir' parameter is added;
	(lang_configure_batch) 'compile_home_dir' parameter is added;
	(lang_config_menu) 'compile_home_dir' parameter is added.

	* ejudge-configure-compilers.c:
	(visual_setup) calls of 'lang_configure_screen', 'lang_config_menu'
	are updated;
	(main) call of 'lang_configure_batch' is updated.

	* ejudge-setup.c:
	(do_preview_menu) call of 'lang_configure_screen' is updated;
	(preview_install_script) the same;
	(save_install_script) the same;
	(do_main_menu) call of 'lang_config_menu' is updated.

2012-10-24 (r7088) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	(struct http_request_info) 'plain_text' field is added.

	* new_server_html.c:
	(priv_generic_operation) 'plain_text' mode is supported;
	(ns_handle_http_request) 'plain_text' request parameter is handled.

2012-10-24 (r7086) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'test_score_list' type is changed
	  from char[256] to char*.

	* prepare.c, prepare_out.c, run.c, super_html_3.c, super_html_4.c:
	'test_score_list' type is changed from char[256] to char*.

2012-10-23 (r7082) Alexander Chernov  <cher@ejudge.ru>

	* super_html_6.c:
	(super_serve_op_IMPORT_FROM_POLYGON_PAGE) language priority selection
	dialog is added;
	(super_serve_op_IMPORT_FROM_POLYGON_ACTION) language priority selection
	is handled.

2012-10-23 (r7080) Alexander Chernov  <cher@ejudge.ru>

	* ej-polygon.c:
	(process_polygon_zip) 'language_priority' packet parameter is handled.

2012-10-23 (r7079) Alexander Chernov  <cher@ejudge.ru>

	* polygon_packet.h:
	(struct polygon_packet) field 'language_priority' is added.

2012-10-22 (r7077) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of 'printout_uses_login' global configuration variable
	is supported.

	* prepare.c, prepare_out.c:
	'printout_uses_login' global configuration variable is supported.

	* printing.c:
	(do_print_run) 'printout_uses_login' is honored.

	* run_common.c:
	(is_piped_core_dump) new function;
	(run_tests) warning is issued, if core dumping is setup to use
	a helper program.

	* serve-control.c, super_html_3.c, super_html_4.c, super_proto.c, super-serve.c:
	editing of 'printout_uses_login' global configuration variable
	is supported.

2012-10-22 (r7076) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) field 'printout_uses_login' is added.

2012-10-21 (r7072) Alexander Chernov  <cher@ejudge.ru>

	* printing.c:
	contestant name and location are escaped properly
	before using them as path components.

2012-10-20 (r7070) Alexander Chernov  <cher@ejudge.ru>

	* reuse_exec.h:
	(task_IsRealTimeout) new function prototype.

	* run_common.c:
	(run_one_test) 'RUN_WALL_TIME_LIMIT_ERR' error code is supported.

2012-10-19 (r7067) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	problem configuration variable 'super_run_dir' is supported.

2012-10-19 (r7065) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c, prepare_out.c:
	support for 'super_run_dir' problem configuration variable is added.

2012-10-18 (r7062) Alexander Chernov  <cher@ejudge.ru>

	* ej-polygon.c:
	a couple of bugs is fixed.

2012-10-18 (r7061) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'super_run_dir' field is added.

2012-10-18 (r7059) Alexander Chernov  <cher@ejudge.ru>

	* super_html.h:
	(super_load_cs_languages) 'cs_conf_file_buf',
	  'cs_conf_file_len' parameters are added.

	* super_html_3.c:
	(super_html_edit_languages) call to 'super_load_cs_languages'
	  is updated.

	* super_html_4.c:
	(write_languages_page) call to 'super_load_cs_languages' is updated.

	* super_html_8.c:
	(super_html_read_serve) call to 'super_load_cs_languages' is updated;
	  error reporting is improved;
	(super_load_cs_languages) 'cs_conf_file_buf', 'cs_conf_file_len'
	  parameters are added.

2012-10-18 (r7057) Alexander Chernov  <cher@ejudge.ru>

	* ej-super-run.c:
	added support for variable "super-run" prefix in the program's
	working paths;
	added '-a' option to allow specifying alternate location
	of the log file;
	added '-p' option to allow specifying alternate prefix to the
	working paths.

2012-10-17 (r7055) Alexander Chernov  <cher@ejudge.ru>

	* cpu.h: copyright notice is updated;
	(cpu_get_performance_info) function prototype is added.

	* testing_report_xml.h:
	(struct testing_report_xml) fields 'cpu_model', 'cpu_mhz' are added.

	* master_html.c:
	'cpu_model' and 'cpu_mhz' are reported to judges.

	* run_common.c, run_inverse.c:
	"cpu.h" is included;
	'cpu_model' and 'cpu_mhz' are saved to testing report.

	* testing_report_xml.c:
	elements <cpu_model> and <cpu_mhz> are supported.

2012-10-12 (r7049) Alexander Chernov  <cher@ejudge.ru>

	* super_html_2.c: creation of contests with no problems
	is enabled.

2012-10-12 (r7048) Alexander Chernov  <cher@ejudge.ru>

	* super_html_6.c:
	problem id assignment during Polygon import is improved.

2012-09-16 (r7027) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_4.c, filter_eval.c, reports.c, filter_scan.lex, execute.c, new_server_html.c, html.c, filter_tree.c, serve_2.c, runlog.h, run_common.c, runlog_static.c, ej-batch.c, master_html.c, clean-users.c, new_server_html_2.c:
	new run statuses RUN_WALL_TIME_LIMIT_ERR, RUN_PENDING_REVIEW are added.

2012-08-31 (r7016) Alexander Chernov  <cher@ejudge.ru>

	* super_html_3.c:
	(super_html_lang_activate) invalid assingment of compile_id is fixed.

2012-08-31 (r7014) Alexander Chernov  <cher@ejudge.ru>

	* super_html_8.c:
	(super_html_read_serve) picking up a compile_id for a language
	is improved.

2012-08-31 (r7012) Alexander Chernov  <cher@ejudge.ru>

	* super_html_6.c:
	(super_serve_op_USER_CREATE_MANY_ACTION) name template is set
	to login template by default.

2012-08-28 (r7006) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.c:
	(serve_read_compile_packet) handling of '.txt' files with compilation
	  warnings is improved.

	* serve_2.c:
	missing headers <sys/time.h>, <sys/resource.h> are included.

2012-08-22 (r7003) Alexander Chernov  <cher@ejudge.ru>

	* ejudge-setup.c:
	default user identity is specified.

2012-08-22 (r7001) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	default socket paths are changed.

2012-08-20 (r6990) Alexander Chernov  <cher@ejudge.ru>

	* ej_types.h: copyright notice is updated;
	(ej_ip6_t) new structure to hold IPv4/IPv6 address.

	* xml_utils.h:
	(xml_parse_ip6) new function prototype.

2012-08-13 (r6986) Alexander Chernov  <cher@ejudge.ru>

	* compile.c:
	(main) "-R" option is supported;
	  'start_open_log' is called.

2012-08-13 (r6984) Alexander Chernov  <cher@ejudge.ru>

	* startstop.h:
	(start_open_log) new function prototype.

	* ej-super-run.c:
	(main) "-R" option is supported;
	  'start_open_log' is called.

	* job-server.c: copyright notice is updated;
	(main) "-R" option is supported;
	  'start_open_log' is called.

	* server_framework.c:
	"startstop.h" is included;
	(nsf_prepare) 'start_open_log' is called.

	* super-serve.c:
	(prepare_sockets) 'start_open_log' is called;
	(main) "-R" option is supported.

	* userlist-server.c:
	(main) "-R" option is supported;
	  'start_open_log' is called.

2012-08-13 (r6981) Alexander Chernov  <cher@ejudge.ru>

	* server_framework.h: copyright notice is updated;
	(struct server_framework_params) 'restart_mode_flag' field is added;

	* new-server.c:
	(main) "-R" option is supported for restart.

	* server_framework.c: copyright notice is updated;
	(nsf_prepare) 'restart_mode_flag' is handled.

2012-08-09 (r6976) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h:
	(serve_testing_queue_delete) 'user_login' parameter is added;
	(serve_testing_queue_change_priority) 'user_login' parameter is added;
	(serve_testing_queue_delete_all) 'user_login' parameter is added;
	(serve_testing_queue_change_priority_all) 'user_login' parameter added.

	* new_server_html.c:
	(priv_testing_queue_operation) calls of testing queue functions
	  are updated;
	(priv_whole_testing_queue_operation) calls of testing queue functions
	  are updated.

	* serve_2.c:
	(serve_compile_request) global priority adjustment is handled;
	(serve_run_request) global priority adjustment is handled;
	(testing_queue_unlock_entry) 'user_login' parameter is added;
	  the user permissions are checked if the packet's contest_id
	  is different from the current contest_id;
	(serve_testing_queue_delete) 'user_login' parameter is added;
	(serve_testing_queue_change_priority) 'user_login' parameter is added;
	(serve_testing_queue_delete_all) 'user_login' parameter is added;
	(serve_testing_queue_change_priority_all) 'user_login' parameter added.

2012-07-31 (r6969) Alexander Chernov  <cher@ejudge.ru>

	* ej-polygon.c:
	(process_polygon_zip) the files matching the test file and the answer
	file patterns remaining from the previous package are removed from
	the test directory;
	(process_problem_row) modification time parsing is improved.

2012-07-30 (r6964) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_language_data) 'extid' field is added.

	* super_proto.h:
	editing of 'extid' language configuration variable is supported.

	* prepare.c, prepare_out.c:
	'extid' language configuration variable is handled.

	* run_inverse.c:
	(invoke_test_program) 'extra_suffix' parameter is added;
	extra file is copied to the test directory, if extra_suffix is specified;
	(invoke_sample_program) 'extra_suffix' parameter is added;
	(run_inverse_testing) '.jar' additional file is supported.

	* serve-control.c, super_html_3.c, super-serve.c:
	editing of 'extid' language configuration variable is supported.

	* super_html_8.c:
	"misctext.h" is included;
	(super_load_cs_languages) trailing whitespace is removed from the version string.

2012-07-29 (r6962) Alexander Chernov  <cher@ejudge.ru>

	* contests.c:
	(contests_clear_cache) 'last_update_time' is cleared as well.

	* new_server_html.c:
	(ns_submit_run) p_run_id is properly used.

	* new_server_html_2.c:
	(ns_write_priv_all_runs) form template for change status is generated.

2012-07-27 (r6959) Alexander Chernov  <cher@ejudge.ru>

	* contests.h:
	(contests_clear_cache) new function prototype.

	* contests.c:
	(contests_clear_cache) new function.

	* super_html_6.c:
	(super_serve_op_CREATE_CONTEST_BATCH_ACTION) contests cache is cleared.

2012-07-23 (r6957) Alexander Chernov  <cher@ejudge.ru>

	* super_html.c:
	null pointer dereference in case of XML parse error is fixed.

2012-07-09 (r6955) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	(ns_submit_run) 'enable_user_id', 'enable_status', 'is_hidden' parameters are added.

	* new_server_html.c:
	(ns_submit_run) 'enable_user_id', 'enable_status', 'is_hidden' parameters are added.

2012-07-07 (r6950) Alexander Chernov  <cher@ejudge.ru>

	* super_html.h:
	(super_html_set_cnts_file_perms) new prototype.

	* super_proto.h:
	'CREATE_CONTEST_BATCH_ACTION' is added.

	* super_html_6.c:
	(super_serve_op_CREATE_CONTEST_BATCH_ACTION) new function.

	* super_html_7.c:
	(super_html_set_cnts_file_perms) renamed from 'set_cnts_file_perms'.

	* super_proto.c:
	'CREATE_CONTEST_BATCH_ACTION' is supported.

2012-07-07 (r6949) Alexander Chernov  <cher@ejudge.ru>

	* contests.h:
	(contests_load_file) new function prototype.

	* contests.c:
	(parse_one_contest_xml) 'number' parameter is removed;
	(contests_load_file) new function.

2012-07-06 (r6947) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	new request 'SUBMIT_RUN_BATCH' is added;
	(ns_submit_run) 'enable_uuid' parameter is added.

	* new_server_html.c:
	"ej_uuid.h" is included;
	(priv_submit_run_batch_page) new function;
	(ns_submit_run) 'enable_uuid' parameter is added;
	  uuid is parsed in 'enable_uuid' mode.

2012-07-06 (r6945) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	ej_uuid.[ch] are added.

	* ej_uuid.h: initial revision.

	* new-server.h:
	(ns_submit_run) 'enable_path' parameter is added.

	* ej_uuid.c: initial revision.

	* new_server_html.c:
	(ns_submit_run) 'enable_path' parameter is added;
	  'path' request parameter, which contains the path to the source
	  file is handled in 'enable_path' mode.

	* filter_eval.c, new_server_html_2.c, runlog.c, runlog_xml.c:
	"ej_uuid.h" is used instead of <uuid/uuid.h>.

2012-07-06 (r6943) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	'PING' request is added.

	* new_server_html.c:
	'PING' request is supported.

2012-07-05 (r6941) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	'IMPORT_PROBLEMS_BATCH_ACTION' is added;
	'super_proto_cmd_names' is added.

	* serve-control.c:
	<errno.h> is included;
	(parse_action) new function that supports symbolic
	  names for commands.

	* super_html_4.c:
	(parse_opcode) new function that supports symbolic
	  names for opcodes.

	* super_proto.c:
	array of super-serve commands is added.

2012-07-05 (r6939) Alexander Chernov  <cher@ejudge.ru>

	* super_html.h:
	(super_html_get_contest_header_and_footer) new function prototype.

	* ej-import-contest.c:
	'contest.xml' is updated with the results of import.

	* super_html_2.c:
	(get_contest_header_and_footer) moved to 'super_html_8.c'.

	* super_html_8.c:
	(super_html_get_contest_header_and_footer) moved here from
	'super_html_2.c'.

2012-07-04 (r6937) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	ej_import_packet.[ch] are added.

	* meta.make:
	rules for ej_import_packet_meta.[ch] are added.

	* ej-import-contest.c:
	config file is used instead of command line args.

	* super_html_6.c:
	'IMPORT_PROBLEMS_BATCH_ACTION" handler is added.

2012-07-04 (r6936) Alexander Chernov  <cher@ejudge.ru>

	* ej_import_packet.c, ej_import_packet.h:
	initial revision

2012-07-04 (r6934) Alexander Chernov  <cher@ejudge.ru>

	* contests.h:
	new attrubute "ready" is added;
	new elements <update_time>, <problem_count> are added.

	* contests.c, contests_2.c:
	new attrubute "ready" is supported;
	new elements <update_time>, <problem_count> are supported.

2012-07-04 (r6932) Alexander Chernov  <cher@ejudge.ru>

	* contests.h:
	support for <ext_id> element is added.

	* contests.c:
	support for <ext_id> element is added.

2012-07-04 (r6930) Alexander Chernov  <cher@ejudge.ru>

	* opcaps.h: copyright notice is updated;
	new capability bits 'LOCAL_0' ... 'LOCAL_3' are added.

	* opcaps.c:
	new capability bits 'LOCAL_0' ... 'LOCAL_3' are supported.

2012-07-03 (r6928) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	rules for compilation of 'ej-import-contest' are added.

	* files.make:
	build_support.c, super_html_8.c are added;
	ej-import-contest.c is added;
	build_support.h is added.

	* build_support.h: initial revision.

	* super_html.h:
	(super_html_serve_unparse_serve_cfg) prototype is added.

	* build_support.c: initial revision.

	* ej-import-contest.c: initial revision.

	* ej-polygon.c:
	(main) debugging output is removed.

	* prepare_out.c:
	(prepare_unparse_prob) invalid unparsing of 'stand_hide_time'
	  is fixed.

	* super_html_3.c:
	"build_support.h" is included;
	(super_load_cs_languages) moved to 'super_html_8.c';
	(super_html_create_problem) the same;
	(unparse_serve_cfg) the same;
	(super_html_serve_unparse_serve_cfg) the same;
	(super_html_get_serve_header_and_footer) the same;
	(do_load_file) the same;
	(super_html_read_serve) the same;

	* super_html_7.c:
	"build_support.h" is included;
	(prepare_test_file_names) moved to 'build_support.c'
	  as 'build_prepare_test_file_names';
	(merge_lines) moved to 'build_support.c';
	(extract_makefile_header_footer) moved to 'build_support.c';
	(pattern_to_shell_pattern) moved to 'build_support.c';
	(get_source_suffix) moved to 'build_support.c';
	(find_suffix) moved to 'build_support.c';
	(guess_language_by_cmd) the same;
	(collect_suitable_names) the same;
	(remove_src_suffix) the same;
	(make_exe_suitable_names) the same;
	(free_suitable_names) the same;
	(replace_cmd_suffix) the same;
	(guess_language_by_cmd) the same;
	(get_compiler_script) the same;
	(get_compiler_path) the same;
	(get_compiler_flags) the same;
	(generate_checker_compilation_rule) the same;
	(generate_solution_compilation_rule) the same;
	(generate_makefile) the same;
	(super_serve_generate_makefile) the same.

	* super_html_8.c: initial revision.

2012-07-03 (r6927) Alexander Chernov  <cher@ejudge.ru>

	* problem_config.h:
	(struct problem_config_section) 'tests_to_accept' field type
	is changed to 'int'.

2012-06-28 (r6925) Alexander Chernov  <cher@ejudge.ru>

	* reports.c, ej-polygon.c:
	gcc compilation fixes.

2012-06-28 (r6922) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	libuuid is used where needed.

	* html.h:
	'RUN_VIEW_RUN_UUID' is added.

	* runlog.h:
	(run_add_record) 'uuid' parameter is added.

	* filter_eval.c, filter_expr.y, filter_scan.lex:
	'uuid' primary expression is supported.

	* new_server_html.c, new_server_html_4.c:
	calls of 'run_add_record' are updated.

	* new_server_html_2.c:
	(ns_write_priv_all_runs) 'run_uuid' field is supported;
	(ns_write_priv_source) 'run_uuid' field is supported;
	(ns_priv_edit_run_page) 'run_uuid' field is supported;
	(ns_priv_edit_run_action) 'run_uuid' field is supported;
	(do_add_row) call of 'run_add_record' is updated.

	* runlog.c, runlog_xml.c:
	'run_uuid' field is supported.

2012-06-28 (r6918) Alexander Chernov  <cher@ejudge.ru>

	* config.h.in:
	CONF_HAS_LIBUUID is added.

2012-06-28 (r6917) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	check for libuuid is added.

2012-06-28 (r6916) Alexander Chernov  <cher@ejudge.ru>

	* runlog.h:
	(struct run_entry) 'is_examinable', 'examiners', 'exam_score'
	fields are removed.

	* filter_eval.c: copyright notice is updated;
	predicates on 'is_examinable', 'examiners', 'exam_score' always
	return 0.

	* new_server_html.c:
	(priv_edit_run) 'is_examinable' change is ignored.

	* new_server_html_2.c:
	(ns_write_priv_all_runs) 'is_examinable' is ignored.

	* rldb_plugin_file.c:
	changes to 'is_examinable', 'examiners', 'exam_score' are ignored;
	reading of those fields returns 0.

	* runlog.c:
	changes to 'is_examinable', 'examiners', 'exam_score' are ignored;
	reading of those fields returns 0.

	* runlog_xml.c:
	'is_examinable' field is ignored on reading and writing.

2012-06-27 (r6913) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	run_packet_1.c, run_packet_2.c, run_packet_3.c, run_packet_7.c
	are removed.

	* run_packet_priv.h:
	(struct run_request_bin_packet) removed.

2012-06-27 (r6911) Alexander Chernov  <cher@ejudge.ru>

	* run_packet.h:
	obsolete code is removed.

	* run_packet_1.c, run_packet_2.c, run_packet_3.c:
	obsolete code is removed.

2012-06-21 (r6905) Alexander Chernov  <cher@ejudge.ru>

	* ej-super-run.c:
	linux-shared-32 architecture is supported.

	* prepare_out.c:
	linux-shared-32 architecture is supported.

2012-06-20 (r6902) Alexander Chernov  <cher@ejudge.ru>

	* sformat.c:
	(sformat_message) locale-specific switch changed to 'a' instead of 'L'.

2012-06-18 (r6896) Alexander Chernov  <cher@ejudge.ru>

	* execute.c:
	(run_program) 'task_NewWait' is used instead of 'task_Wait';
	  the memory size, used by process is stored.

	* run_common.c:
	(generate_xml_report) unparsing of 'max_memory_used' is updated;
	(run_one_test) 'task_NewWait' is used;
	  the process max vm size is tracked and stored in 'max_memory_used'
	  field.

2012-06-18 (r6895) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	'xml_utils/attr_ulong.c is added.

	* reuse_exec.h:
	(task_NewWait) new function prototype is added.

	* run.h:
	(struct testinfo) field 'max_memory_used' now has unsigned long type.

	* xml_utils.h: copyright notice is updated;
	(xml_attr_ulong) new function prototype is added.

	* testing_report_xml.h:
	(struct testing_report_test) field 'max_memory_used' now has
	  unsigned long type.

	* master_html.c:
	(write_xml_testing_report) format spec for 'max_memory_used'
	  field is updated.

	* reports.c: copyright notice is updated;
	(write_xml_tex_testing_report) format spec for 'max_memory_used'
	  is updated.

	* testing_report_xml.c:
	(parse_test) "max-memory-used" attribute is parsed to the
	  unsigned long field 'max_memory_used';
	(testing_report_unparse_xml) unparsing of 'max_memory_used'
	  is updated.

2012-06-13 (r6889) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	(ns_submit_run) new function prototype.

	* new_server_html.c:
	(ns_submit_run) new function is implemented.

	* new_server_html_4.c:
	(cmd_submit_run) support for internally judged problems is added.

	* run_common.c:
	(run_tests) check for undefined 'check_cmd' and 'standard_checker'
	is added.

2012-06-08 (r6887) Alexander Chernov  <cher@ejudge.ru>

	* ej-polygon.c:
	(curl_iface_login_action_func) 'CURLOPT_POSTFIELDS' is used instead of
	'CURLOPT_COPYPOSTFIELDS'.

2012-06-06 (r6885) Alexander Chernov  <cher@ejudge.ru>

	* prepare_out.c:
	(generate_abstract_tester) the original values of 'start_env'
	configuration is preserved.

2012-06-06 (r6881) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	"update from polygon" functionality is implemented.

	* prepare_out.c:
	'extid' is properly handled.

	* super_html.c, super_html_6.c, super_proto.c:
	"update from polygon" functionality is implemented.

2012-06-06 (r6879) Alexander Chernov  <cher@ejudge.ru>

	* ej_process.h:
	(ejudge_start_daemon_process) new function prototype.

	* super_html.h:
	(problem_id_to_short_name) new function prototype;
	(super_html_create_problem) new function prototype.

	* super_proto.h:
	"import from Polygon" is implemented.

	* super_html_6.c:
	"import from Polygon" is implemented.

	* ej-polygon.c:
	new state 'ALREADY_EXISTS';
	(struct ProblemInfo) new fields 'ejudge_id', 'ejudge_short_name';
	(process_polygon_zip) 'create_mode' is handled;
	(main) NULL problem_name is handled.

	* parsecfg.c:
	(parse_param) configuration files without "global" section
	are supported.

	* polygon_packet.c:
	(polygon_packet_unparse) new function.

	* super_html_2.c:
	(super_html_commit_contest) "Check contest settings" button is added.

	* super_html_3.c:
	(super_html_edit_problems) "Import from Polygon" link is added;
	(problem_id_to_short_name) new function;
	(super_html_create_problem) new function;
	(super_html_add_problem) 'super_html_create_problem' is used.

	* super_proto.c:
	"import from polygon" is implemented.

	* super-serve.c:
	(update_state_create) new function;
	(update_state_free) new function;
	(sid_state_clear) 'update_state' is freed.

2012-06-04 (r6877) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.h:
	(struct update_state) 'contest_id' field is added.

2012-06-04 (r6876) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.h:
	(struct update_state) 'create_mode' field is added.

2012-06-04 (r6875) Alexander Chernov  <cher@ejudge.ru>

	* polygon_packet.h:
	(struct polygon_packet) new fields 'create_mode', 'ejudge_id',
	  'ejudge_short_name';
	(polygon_packet_alloc) new function prototype;
	(polygon_packet_unparse) new function prototype.

	* problem_config.h:
	(struct problem_config_section) fields 'id', 'short_name' are added.

	* super-serve.h:
	(struct update_state) new structure;
	(struct sid_state) field 'update_state' is added;
	(update_state_create) new function prototype;
	(update_state_free) new function prototype.

2012-06-02 (r6869) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	(run_one_test) 'start_env' parameter is added;
	(merge_env) new function to merge the environment;
	(run_tests) the 'start_env' environment from the tester section of the
	testing packet is merged to the 'start_env' environment of the tester
	section of the configuration file.

2012-06-02 (r6868) Alexander Chernov  <cher@ejudge.ru>

	* polygon_packet.h:
	(struct polygon_packet) 'ids' field is renamed to 'id'.

	* ej-polygon.c:
	minor improvements according to the documentation.

2012-06-01 (r6867) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	LIBZIP is added to ej-normalize.

	* files.make:
	polygon_packet.[ch] are added.

	* meta.make:
	rules for polygon_packet_meta.[ch] are added.

	* polygon_packet.h: initial revision.

	* problem_config.h:
	(struct problem_config_section) new fields 'long_name_en', 'revision'
	  are added.

	* ej-polygon.c: implemented.

	* meta_generic.c:
	(meta_build_automaton) debug output is commented out;
	(meta_unparse_cfg) boolean output is improved.

	* polygon_packet.c: initial revision.

	* problem_config.c:
	(problem_config_section_unparse_cfg) a bug is fixed.

2012-05-28 (r6865) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	ej-polygon compilation rules are added.

	* files.make:
	ej-polygon.c is added.

	* config.h.in:
	CONF_HAS_LIBCURL is added.

	* ej-polygon.c: initial revision.

2012-05-28 (r6864) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac: copyright notice is updated;
	check for libcurl is added.

2012-05-27 (r6862) Alexander Chernov  <cher@ejudge.ru>

	* ej-super-run.c, prepare.c, prepare_out.c, run_common.c:
	'valgrind' arch is supported.

2012-05-26 (r6859) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	memory limit type and secure exec type for valgrind are added.

2012-05-26 (r6857) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	'enable_max_stack_size' packet global parameter is supported.

2012-05-25 (r6855) Alexander Chernov  <cher@ejudge.ru>

	* runlog.h: copyright notice is updated;
	(run_get_max_user_id) new function prototype;
	(run_get_total_users) new function prototype.

	* runlog_state.h: copyright notice is updated;
	(struct runlog_state) new fields 'max_user_id', 'user_count'.

	* html.c, master_html.c, new_server_html_2.c, runlog_xml.c:
	'disable_user_database' mode is supported.

	* new_server_html.c:
	(priv_assign_cyphers_2) no action in 'disable_user_database' mode.

	* prepare_serve.c: copyright notice is updated;
	'disable_user_database' mode is supported.

	* runlog.c: copyright notice is updated;
	'max_user_id', 'user_count' are maintained;
	(run_get_max_user_id) new function;
	(run_get_total_users) new function.

	* serve_2.c:
	'disable_user_database' mode is supported.

	* teamdb_2.c: copyright notice is updated;
	(teamdb_get_user_map) 'disabled' mode is handled.

2012-05-25 (r6853) Alexander Chernov  <cher@ejudge.ru>

	* teamdb.h:
	(teamdb_disable) new function prototype.

	* teamdb_priv.h:
	(struct teamdb_state) 'disabled' field is added.

	* serve_state.c:
	'disable_user_database' global configuration variable is handled.

	* teamdb.c:
	(teamdb_disable) new function;
	'disabled' flag is handled.

2012-05-25 (r6851) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of 'disable_user_database', 'enable_max_stack_size'
	global configuration variables is supported.

	* prepare.c, prepare_out.c:
	'disable_user_database', 'enable_max_stack_size' global configuration
	variables are supported.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of 'disable_user_database', 'enable_max_stack_size'
	global configuration variables is supported.

	* super_run_packet.c:
	'enable_max_stack_size' global parameter is supported.

2012-05-25 (r6850) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) new fields:
	  'disable_user_database', 'enable_max_stack_size'.

	* super_run_packet.h:
	(struct super_run_in_global_packet) new field 'enable_max_stack_size'.

2012-05-23 (r6846) Alexander Chernov  <cher@ejudge.ru>

	* nwrun_packet.h: copyright notice is updated;
	memory limit fields now have 'size_t' type instead of 'int'.

	* execute.c:
	(parse_size) 'maxval' parameter is removed;
	  64-bit memory limits are supported;
	(handle_options) calls to 'parse_size' are updated.

	* nwrun_packet.c: copyright notice is updated;
	64-bit memory limit fixes.

	* prepare.c:
	64-bit memory limit fixes.

	* run_common.c:
	64-bit memory limit fixes.

2012-05-22 (r6844) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	(run_tests) no tests situation is treated as check failed.

2012-05-22 (r6843) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_priv_edit_run_action) REJUDGE status change is supported.

2012-05-21 (r6841) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(scan_run_queue) all packets are shown, not only the current contests';
	(ns_write_testing_queue) super-run testing mode is supported.

	* serve_2.c:
	(serve_testing_queue_delete) super-run testing mode is supported;
	(serve_testing_queue_change_priority) the same as above.
	(collect_run_packets) the same as above.

2012-05-20 (r6839) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	(run_one_test) insecure mode for java is properly supported.

2012-05-20 (r6837) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h:
	(serve_audit_log) new parameters 'command', 'status', 'run_status'
	  are added.

	* new_server_html.c, new_server_html_2.c, new_server_html_4.c, runlog_import.c:
	run audit logging is improved.

	* serve_2.c:
	run audit logging is improved;
	(serve_audit_log) new parameters 'command', 'status', 'run_status'
	  are added.

2012-05-20 (r6835) Alexander Chernov  <cher@ejudge.ru>

	* sformat.c:
	(sformat_message) member serial number is made optional.

2012-05-20 (r6833) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h:
	(serve_report_check_failed) new function prototype.

	* master_html.c:
	(write_xml_testing_report) 'errors' field is reported.

	* new_server_html.c:
	(priv_submit_run) if compile request is failed, the condition is reported
	by 'Check failed' status;
	(unpriv_submit_run) the same.

	* new_server_html_4.c:
	(cmd_submit_run) if compile request is failed, the condition is reported
	by 'Check failed' status.

	* serve_2.c:
	"testing_report_xml.h" is included;
	(serve_report_check_failed) new function;
	(serve_rejudge_run) if compile request is failed, the condition is reported
	by 'Check failed' status.

2012-05-19 (r6831) Alexander Chernov  <cher@ejudge.ru>

	* sformat.c: copyright notice is updated;
	(sformat_message) language format conversions are added.

2012-05-18 (r6829) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c:
	(ns_refresh_page) 'Redirect:' header is fixed for standard compliance;
	(ns_refresh_page_2) the same.

	* new_server_html_5.c:
	'Redirect:' header is fixed for standard compliance.

	* serve-control.c:
	(client_put_refresh_header) the same.

	* super_html_4.c:
	(refresh_page) the same.

	* super_html_6.c:
	(ss_redirect) the same;
	(ss_redirect_2) the same.
	(super_serve_op_EJUDGE_XML_CANCEL_ACTION) the same.

	* super_html_7.c:
	(ss_redirect_2) the same.

2012-05-17 (r6827) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h:
	(serve_remove_status_file) new function prototype.

	* serve_2.c:
	(serve_remove_status_file) new function;
	(serve_reset_contest) status directory is cleared.

2012-05-17 (r6825) Alexander Chernov  <cher@ejudge.ru>

	* rldb_plugin_file.c:
	(close_func) NULL-pointer dereference is fixed.

2012-05-17 (r6823) Alexander Chernov  <cher@ejudge.ru>

	* cgi.c: copyright notice is updated;
	(do_get_char) content_length is used to store the number of bytes to read;
	(cgi_read) CONTENT_LENGTH environment is parsed.

2012-05-15 (r6821) Alexander Chernov  <cher@ejudge.ru>

	* super_html_3.c:
	(super_html_print_problem) redundant check of 'standard_checker' is removed.

2012-05-15 (r6819) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	(run_tests) scoring_checker bug is fixed.

2012-05-12 (r6817) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	minor visual changes in priv source view page.

2012-05-09 (r6815) Alexander Chernov  <cher@ejudge.ru>

	* html.h:
	(write_change_status_dialog) 'cur_value', 'is_disabled' parameters are added.

	* mischtml.h: copyright notice is updated;
	(html_input_text) 'is_disabled' parameter is added;
	(html_checkbox) 'is_disabled' parameter is added.

	* misctext.h: copyright notice is updated;
	(duration_str_2) new function;
	(parse_sha1) new function.

	* new-server.h:
	'PRIV_EDIT_RUN_PAGE', 'PRIV_EDIT_RUN_ACTION' actions are added;
	(ns_priv_edit_run_page) new function prototype;
	(ns_priv_edit_run_action) new function prototype.

	* html_checkbox.c: copyright notice is updated;
	(html_checkbox) 'is_disabled' parameter is added.

	* html_input_text.c: copyright notice is updated;
	(html_input_text) 'is_disabled' parameter is added.

	* master_html.c:
	(write_change_status_dialog) 'cur_value', 'is_disabled' parameters are added.

	* misctext.c:
	(duration_str_2) new function;
	(parse_sha1) new function.

	* new_server_html.c:
	calls to 'html_input_text' are updated;
	(priv_edit_run_page) new function;
	'PRIV_EDIT_RUN_PAGE', 'PRIV_EDIT_RUN_ACTION' requests are handled.

	* new_server_html_2.c:
	calls to 'html_input_text' are updated;
	(ns_write_priv_source) field editing is moved to a separate page;
	(ns_priv_edit_run_page) new function;
	(ns_priv_edit_run_action) new function.

	* new_server_html_5.c, super_html_4.c, super_html_6.c, super_html_7.c:
	calls to 'html_input_text' are updated.

	* runlog_xml.c:
	(parse_sha1) moved to misctext.[ch];
	(process_run_elements) call to 'parse_sha1' is updated.

2012-05-08 (r6812) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_write_priv_all_runs) "CLEAR" should now work for virtual start/stop events.

	* prepare_out.c:
	(prepare_unparse_unhandled_global) 'super_run_dir' is added.

2012-05-06 (r6810) Alexander Chernov  <cher@ejudge.ru>

	* ej-super-run.c:
	"xml_utils.h" is included;
	<sys/types.h>, <sys/stat.h> is included;
	(handle_packet) replative paths are supported in 'reply_report_dir', etc;
	(remove_if_upgrade_needed) new function;
	(main) autoupgrade of 'super-run.cfg' is implemented.

	* serve_2.c:
	(serve_run_request) relative paths are passed in 'reply_report_dir', etc
	  parameters.

2012-05-05 (r6808) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h:
	(serve_build_run_dirs) 'contest_id' parameter is added.

	* serve.c:
	(main) call of 'serve_build_run_dirs' is updated.

	* serve_2.c:
	(serve_build_run_dirs) 'contest_id' parameter is added;
	  'super_run_dir' global configuration variable is supported.

	* serve_state.c:
	(serve_state_load_contest) call of 'serve_build_run_dirs' is updated.

2012-05-05 (r6804) Alexander Chernov  <cher@ejudge.ru>

	* ej-super-run.c:
	(handle_packet) report directories are created.

	* prepare.c:
	'super_run_dir' global configuration variable is supported.

	* serve_2.c:
	(serve_run_request) improvements;
	'super_run_dir' global config variable is supported.

2012-05-05 (r6803) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) field 'super_run_dir' is added.

2012-05-05 (r6801) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	(invoke_init_cmd) new function;
	(invoke_interactor) log file is always opened in APPEND mode;
	(invoke_checker) log file is always opened in APPEND mode;
	(run_one_test) 'init_cmd' command is supported.

2012-05-04 (r6797) Alexander Chernov  <cher@ejudge.ru>

	* super_html_6.c:
	(super_serve_op_USER_SAVE_ACTION) modifying of 'login' and 'email'
	fields is supported.

2012-05-04 (r6793) Alexander Chernov  <cher@ejudge.ru>

	* userlist-server.c:
	Ticket #53 fixed.

2012-05-03 (r6791) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_write_priv_all_runs) 'run_fields' are restored from external storage.

2012-05-03 (r6789) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of 'init_cmd', 'init_env' is supported.

	* prepare.c:
	'init_env', 'init_cmd' problem configuration parameters
	are supported.

	* prepare_out.c: copyright notice is updated;
	'init_env', 'init_cmd' problem configuration parameters
	are supported.

	* problem_config.c:
	'init_env', 'init_cmd' fields are supported.

	* serve_2.c:
	(serve_run_request) 'init_env', 'init_cmd' are passed to invokers.

	* serve-control.c, super_html_3.c, super_html_4.c, super_html_7.c, super_proto.c, super-serve.c:
	editing of 'init_cmd', 'init_env' is supported.

2012-05-03 (r6788) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) field 'init_env' is added.

	* problem_config.h:
	(struct problem_config_section) field 'init_env' is added.

	* super_proto.h:
	editing of 'init_env' problem configuration variable is supported.

	* super_run_packet.h:
	(struct super_run_in_problem_packet) field 'init_env' is added.

2012-05-03 (r6787) Alexander Chernov  <cher@ejudge.ru>

	* problem_config.h:
	(struct problem_config_section) 'init_cmd' field is added.

	* super_proto.h:
	editing of 'init_cmd' problem configuration parameter is supported.

	* super_run_packet.h:
	(struct super_run_in_problem_packet) 'init_cmd' field is added.

2012-05-03 (r6786) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'init_cmd' field is added.

2012-05-01 (r6782) Alexander Chernov  <cher@ejudge.ru>

	* clarlog.h: copyright notice is updated;
	'CLAR_FIELD_*' constants are added;
	(clar_modify_text) new function prototype;
	(clar_modify_record) new function prototype.

	* cldb_plugin.h: copyright notice is updated;
	(struct cldb_plugin_iface) 'modify_text' method is added;
	  'modify_record' method is added.

	* new-server.h:
	new actions NEW_SRV_ACTION_PRIV_EDIT_CLAR_PAGE,
	  NEW_SRV_ACTION_PRIV_EDIT_CLAR_ACTION are added;
	(ns_priv_edit_clar_page) new function prototype;
	(ns_priv_edit_clar_action) new function prototype;
	(ns_cgi_param_int_opt) new function prototype.

	* clarlog.c: copyright notice is updated;
	(clar_modify_text) new function;
	(clar_modify_record) new function.

	* cldb_plugin_file.c: copyright notice is updated;
	(modify_text_func) new function;
	(modify_record_func) new function.

	* new_server_html.c:
	(priv_edit_clar_page) new function.

	* new_server_html_2.c:
	(ns_write_priv_clar) 'Edit' link is added;
	(ns_priv_edit_clar_page) new function;
	(parse_user_field) new static function;
	(ns_priv_edit_clar_action) new function.

	* serve-control.c:
	generated HTML headers and titles are improved.

2012-04-27 (r6779) Alexander Chernov  <cher@ejudge.ru>

	* serve-control.c:
	page title is improved.

2012-04-27 (r6777) Alexander Chernov  <cher@ejudge.ru>

	* html.h:
	"Size", "IP", "User ID" run fields are now shown by default.

	* new_server.h:
	new action CHANGE_RUN_FIELDS.

	* new_server_html.c:
	(priv_change_run_fields) new function.

2012-04-26 (r6774) Alexander Chernov  <cher@ejudge.ru>

	* ej-super-run.c:
	(create_configs) mono settings are improved.

	* run_common.c:
	(make_mono_limits) new function;
	(run_one_test) memory limit type and secure exec type "mono" are added.

2012-04-26 (r6772) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	secure exec type "mono" is added;
	memory limit type "mono" is added.

2012-04-26 (r6770) Alexander Chernov  <cher@ejudge.ru>

	* master_html.c:
	(write_xml_testing_report) formatting changed.

	* run_common.c:
	boolean checks are improved: var -> var > 0; !var -> var <= 0.

2012-04-26 (r6768) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	(run_tests) check for score_tests_val == NULL is added.

2012-04-26 (r6766) Alexander Chernov  <cher@ejudge.ru>

	* html.h:
	(write_html_run_status) 'run_fields' parameter is added;
	run field flags are added.

	* serve_state.h:
	(struct user_filter_info) 'run_fields' field is added.

	* team_extra.h: copyright notice is updated;
	(struct team_extra) field 'run_fields' is added;
	(team_extra_get_run_fields) new function prototype;
	(team_extra_set_run_fields) new function prototype.

	* html.c:
	(write_html_run_status) 'run_fields' parameter is added;
	  fields are printed depending on the 'run_fields' parameter;
	calls to 'write_html_run_status' are updated.

	* new_server_html_2.c:
	(ns_write_priv_all_runs) run_fields field bitmask is handled.

	* team_extra.c: copyright notice is updated;
	(get_entry) 'try_flag' parameter is added;
	(team_extra_get_run_fields) new function;
	(team_extra_set_run_fields) new function.

	* team_extra_xml.c: copyright notice is updated;
	<errno.h> is included;
	<run_fields> element are supported.

2012-04-24 (r6764) Alexander Chernov  <cher@ejudge.ru>

	* ejudge_cfg.h:
	(struct ejudge_cfg) 'caps_node' field is added;
	(ejudge_cfg_free_subtree) new function;
	(ejudge_cfg_refresh_caps_file) 'force_flag' parameter is added;
	(ejudge_cfg_user_map_find_simple) new function prototype;
	(ejudge_cfg_user_map_add) new function prototype;
	(ejudge_cfg_caps_add) new function prototype.

	* super_proto.h:
	editing of the system user map and the global capabilities
	is supported.

	* ejudge_cfg.c:
	(new_node) new function;
	(parse_capabilities) 'caps_node' is stored;
	(ejudge_cfg_free_subtree) new function;
	(ejudge_cfg_refresh_caps_file) 'force_flag' parameter is added;
	(ejudge_cfg_user_map_find_simple) new function;
	(ejudge_cfg_user_map_add) new function;
	(ejudge_cfg_caps_add) new function.

	* super_html_6.c, super_proto.c:
	editing of the system user map and the global capabilities
	is supported.

2012-04-23 (r6762) Alexander Chernov  <cher@ejudge.ru>

	* opcaps_2.c: copyright notice is updated;
	(opcaps_unparse) 'FULL_SET' is supported.

2012-04-23 (r6761) Alexander Chernov  <cher@ejudge.ru>

	* ejudge_cfg.h:
	(struct ejudge_cfg) new field 'ejudge_xml_path'.

	* super_proto.h: new actions.

	* ejudge_cfg.c:
	(node_free) new function;
	(parse_capabilities) 'login' field is handled correctly;
	(ejudge_cfg_do_parse) 'ejudge_xml_path' is used to save the file path.

	* opcaps.c: copyright notice is updated;
	(opcaps_parse) 'FULL_SET' capability set is supported.

	* super_proto.c: new actions.

	* super_html.c:
	"System user mapping" and "Global user capabilities" links are added.

	* super_html_6.c:
	new code is added to support "User map" editing and "Global capabilities"
	editing.

	* super-serve.c:
	(do_loop) 'pfds' is correctly freed.

2012-04-21 (r6758) Alexander Chernov  <cher@ejudge.ru>

	* ejudge_cfg.h:
	<time.h> is included;
	(struct ejudge_cfg_caps_file) new function to store the state of
	the external capabilities file;
	(struct ejudge_cfg) new field 'caps_file';
	  new field 'caps_file_info';
	(ejudge_cfg_create_caps_file) new function prototype;
	(ejudge_cfg_free_caps_file) new function prototype;
	(ejudge_cfg_refresh_caps_file) new function prototype;
	(ejudge_cfg_opcaps_find) new function prototype;
	(ejudge_cfg_user_map_find) new fuction prototype;
	(ejudge_cfg_user_map_find_uid) new function prototype.

	* ejudge_cfg.c:
	<sys/types.h>, <sys/stat.h> are included;
	<caps_file> element is supported;
	(ejudge_cfg_do_parse) new function to just parse the XML file;
	(ejudge_cfg_parse) this function now sets default values;
	(ejudge_cfg_create_caps_file) new function;
	(ejudge_cfg_free_caps_file) new function;
	(ejudge_cfg_refresh_caps_file) new function;
	(ejudge_cfg_opcaps_find) new function;
	(ejudge_cfg_user_map_find) new fuction;
	(ejudge_cfg_user_map_find_uid) new function.

	* new-server.c: copyright notice is updated;
	'ejudge_cfg_user_map_find', 'ejudge_cfg_opcaps_find'
	functions are used.

	* new_server_html.c:
	(privileged_entry_point) 'ejudge_cfg_opcaps_find' is used.

	* new_server_html_4.c:
	'ejudge_cfg_user_map_find' function is used;
	'ejudge_cfg_opcaps_find' function is used.

	* super_html_4.c:
	'ejudge_cfg_opcaps_find' function is used.

	* super_html_6.c: copyright notice is updated;
	'ejudge_cfg_opcaps_find' function is used.

	* super_html_7.:
	'ejudge_cfg_opcaps_find' function is used.

	* userlist-server.c:
	(build_system_uid_map) marked for removal;
	(remove_from_system_uid_map) marked for removal;
	(get_global_uid_caps) new function;
	'ejudge_cfg_opcaps_find', 'ejudge_cfg_user_map_find'
	functions are used.

2012-04-21 (r6756) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_set_stand_filter) old error messages are cleared.

2012-04-20 (r6754) Alexander Chernov  <cher@ejudge.ru>

	* super_html_6.c:
	(is_contest_privileged) NULL-pointer dereference is fixed.

2012-04-18 (r6752) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	libzip library is used in ej-run, ej-nwrun, ej-super-run, ej-contests.

	* archive_paths.h: copyright notice is updated;
	(archive_make_move_path) removed;
	(archive_make_write_path) 'zip_mode' parameter is added.

	* fileutl.h: copyright notice is updated;
	ZIP constant is added.

	* full_archive.h: copyright notice is updated;
	"config.h" is included;
	ZIP archives are supported;
	(full_archive_find_file) 'p_size' parameter is removed;
	  'p_data' is made non-const.

	* archive_paths.c: copyright notice is updated;
	(archive_make_read_path) ZIP files are supported;
	(archive_make_write_path) 'zip_mode' parameter is added;
	  ZIP files are supported;
	(archive_make_move_path) made static;
	  ZIP files are supported;
	(archive_remove) ZIP files are supported.

	* ej-super-run.c:
	(handle_packet) ZIP full archive is default, if libzip is available.

	* new_server_html.c:
	calls of 'archive_make_write_path' are updated.

	* new_server_html_2.c:
	(write_from_archive) ZIP archives are supported;
	  use of 'full_archive_find_file' is updated;
	(ns_write_tests) full archive mode is supported for output-only problems.

	* new_server_html_4.c:
	call of 'archive_make_write_path' is updated.

	* run.c:
	(do_loop) ZIP full archives are default, if libzip is found.

	* run_common.c:
	(run_tests) ZIP full archive is default, if libzip is available.

	* runlog_import.c: copyright notice is updated;
	ZIP files are supported.

	* serve_2.c:
	support for ZIP files in full archive directory is added;
	calls of 'archive_make_write_path' are updated;
	(serve_read_run_packet) ZIP archives are supported.

2012-04-17 (r6749) Alexander Chernov  <cher@ejudge.ru>

	* reuse_exec.h:
	(task_IgnoreSIGPIPE) new function prototype.

	* run_common.c:
	(setup_environment) 'ejudge_prefix_dir_env' param is removed;
	  'force_ejudge_env' param is added;
	  primary ejudge environment vars are set;
	(invoke_valuer) call of 'setup_environment' is updated;
	(invoke_interactor) call of 'setup_environment' is updated;
	  SIGPIPE is ignored for interactor;
	(invoke_checker) call of 'setup_environment' is updated;
	(check_output_only) 'ejudge_prefix_dir_env' param is removed.

2012-04-17 (r6745) Alexander Chernov  <cher@ejudge.ru>

	* run.h:
	(struct testinfo) 'checker_score' field is removed.

	* run_common.c:
	'score' is used instead of 'checker_score' in 'struct testinfo';
	(read_checker_score) 'default_score' parameter is added;
	  if default_score >= 0, score may be missing or invalid;
	(invoke_checker) call of 'read_checker_score' is updated.

2012-04-15 (r6741) Alexander Chernov  <cher@ejudge.ru>

	* run.h:
	(run_inverse_testing) 'run_exe_dir' parameter is added.

	* ej-super-run.c:
	(handle_packet) call of 'run_inverse_testing' is updated.

	* master_html.c:
	(write_xml_tests_report) "Tests" testing report style is improved.

	* run.c:
	(do_loop) call of 'run_inverse_testing' is updated.

	* run_inverse.c:
	(invoke_checker) CF return status is changed to PE;
	(run_inverse_testing) 'run_exe_dir' parameter is added;
	  archive suffix is determined correctly from mime_type.

	* serve_2.c:
	(serve_run_request) "exe suffix" is correct in case of "Tests" problems.

	* super_html_7.c:
	(find_suffix) new function;
	(collect_suitable_names) new function;
	(remove_src_suffix) new function;
	(make_exe_suitable_names) new function;
	(free_suitable_names) new function;
	(generate_solution_compilation_rule) new function;
	(generate_makefile) "Tests" problems are supported.

2012-04-12 (r6739) Alexander Chernov  <cher@ejudge.ru>

	* super_html.c:
	(super_html_main_page) "Edit users" link is displayed to the capable users only.

	* super_html_7.c:
	(super_serve_op_TESTS_TEST_CHECK_ACTION) a bug is fixed.

2012-04-11 (r6737) Alexander Chernov  <cher@ejudge.ru>

	* execute.c: copyright notice is updated;
	--all-tests mode is added.

	* super_html_3.c:
	(super_html_check_tests) 'normalization' variable is handled.

	* super_html_7.c:
	(generate_makefile) --all-tests mode of 'ejudge-execute' is used.

2012-04-10 (r6733) Alexander Chernov  <cher@ejudge.ru>

	* problem_config.h, problem_config.c:
	initial revision

2012-04-10 (r6732) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	META_C_FILES, META_H_FILES, META_O_FILES variables are introduced.

	* files.make:
	problem_config.[ch] is added.

	* meta.make:
	META_C_FILES, META_H_FILES, META_O_FILES are introduced.

	* meta_generic.h:
	(meta_unparse_cfg) 'default_ptr' parameter is added.

	* meta_generic.c:
	(meta_unparse_cfg) 'default_ptr' parameter is added.

	* runlog_xml.c:
	(unparse_runlog_xml) generation of 'board_fog_time', 'board_unfog_time'
	attributes is fixed;
	'score', 'score_adj', 'test' are generated only if have values.

	* super_run_packet.c:
	(super_run_in_packet_unparse_cfg) calls of 'meta_unparse_cfg' are
	updated.

2012-04-09 (r6729) Alexander Chernov  <cher@ejudge.ru>

	* run_common.c:
	(read_valuer_score) 'marked' flag is set correctly.

	* super_html_3.c:
	(super_html_check_tests) more problem variables are updated.

2012-04-04 (r6725) Alexander Chernov  <cher@ejudge.ru>

	* super_html.h:
	(super_html_create_contest_2) 'ssl_flag' parameter is added;
	(contest_tmpl_new) 'ip', 'ssl_flag' parameters are added.

	* contest_tmpl.c: copyright notice is updated;
	(contest_tmpl_new) 'ip', 'ssl_flag' parameters are added;
	  the IP from which the contest has been created is added to
	  the while list for IP-access rules;
	  the system user is given maximum rights.

	* master_html.c: copyright notice is updated.

	* new_server_html_2.c:
	(ns_write_priv_standings) links are added.

	* prepare.c:
	(prepare_new_global_section) 'advanced_layout' is set to 1.

	* serve_state.c: copyright notice is updated.

	* super_html.c:
	(super_html_create_contest_2) 'ssl_flag' parameter is added;
	  call of 'contest_tmpl_new' is updated.

	* super_html_3.c:
	(super_html_check_tests) links are added to the top page;
	  "Check again" button is added if "Check contests settings" failed.

	* super_html_4.c:
	(cmd_op_create_new_contest) call of 'contest_tmpl_new' is updated.

	* super-serve.c:
	(cmd_create_contest) call of 'super_html_create_contest_2' is updated.

2012-04-04 (r6723) Alexander Chernov  <cher@ejudge.ru>

	* run_inverse.c:
	exit codes 1 and 2 are considered as WA and PE for test checkers.

	* super_html_3.c, super_html_7.c:
	-DEJUDGE is added to compilation options for all supported languages.

2012-04-03 (r6721) Alexander Chernov  <cher@ejudge.ru>

	* super_html_7.c:
	support for python solutions, checkers and validators is implemented.

2012-04-03 (r6719) Alexander Chernov  <cher@ejudge.ru>

	* super_html_7.c:
	(get_compiler_script) new function;
	(generate_checker_compilation_rule) java support is improved;
	(generate_makefile) java support is implemented.

2012-04-03 (r6717) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c:
	(prepare) no error is reported in case of missing
	problems, languages, or testers.

2012-04-03 (r6715) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h: copyright notice is updated;
	(ns_html_err_cnts_unavailable) 'messages' parameter is added.

	* new_server_html.c:
	(read_file_range) new function;
	(privileged_entry_point) a snipped of the log file is shown
	in case of unavailable contest.

	* new_server_html_3.c: copyright notice is updated;
	"reuse_xalloc.h" is included;
	(ns_html_err_cnts_unavailable) 'messages' parameter is added.

	* super_html_7.c:
	(generate_makefile) support for DCC and FPC is implemented.

2012-04-02 (r6713) Alexander Chernov  <cher@ejudge.ru>

	* super_html_7.c:
	checkers in java for testlib4j are supported.

2012-04-02 (r6711) Alexander Chernov  <cher@ejudge.ru>

	* super_html_7.c: fpc and dcc are supported in makefile.

2012-04-01 (r6709) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_write_all_clars) NULL pointer output is fixed.

	* run_common.c:
	(invoke_checker) exit codes 1, 2 are accepted for WA and PE;
	(run_one_test) exit codes 1, 2 are accepted for WA and PE for
	interactor.

	* serve_2.c:
	(serve_read_compile_packet) compilation error log is saved even if
	compilation succeeded.

2012-03-30 (r6702) Alexander Chernov  <cher@ejudge.ru>

	* sha.c: gcc 4.7 compilation fix.

2012-03-29 (r6698) Alexander Chernov  <cher@ejudge.ru>

	* html.c:
	(calc_kirov_score) fixed.

	* prepare.c:
	(parse_penalty_expression) fixed.

2012-03-29 (r6696) Alexander Chernov  <cher@ejudge.ru>

	* html.h: copyright notice is updated;
	(calc_kirov_score) 'start_time' parameter is added;
	(write_html_run_status) 'start_time' parameter is added;
	(write_text_run_status) 'start_time' parameter is added.

	* html.c:
	(calc_kirov_score) 'start_time' parameter is added;
	extended support for date_penalty is implemented;
	(write_html_run_status) 'start_time' parameter is added;
	(write_text_run_status) 'start_time' parameter is added;
	calls of 'calc_kirov_score' is added.

	* new_server_html_2.c:
	calls of 'write_html_run_status', 'write_text_run_status',
	'calc_kirov_score' are updated.

	* new_server_html_4.c: copyright notice is updated;
	calls of 'calc_kirov_score' are updated.

	* prepare.c:
	(parse_penalty_expression) new function;
	(parse_deadline_penalties) extended syntax is supported.

2012-03-29 (r6694) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct penalty_info) 'deadline' is renamed to 'date';
	  new fields 'scale', 'decay' are added;
	(struct group_date_info) 'date', 'penalty' are replaced with aggregated
	  'struct penalty_info p';
	(struct pers_dead_info) 'deadline', 'penalty' are replaced with aggregated
	  'struct penalty_info p'.

	* html.c, new_server_html.c, prepare.c, serve_2.c, serve_state.c:
	updated according to the changes in 'prepare.h'.

2012-03-28 (r6686) Alexander Chernov  <cher@ejudge.ru>

	* super_html.h: copyright notice is updated;
	(super_serve_generate_makefile) new function prototype.

	* ej-normalize.c: completed.

	* super_html_3.c:
	(invoke_make) 'check_settings' rule is invoked instead of
	  'ejudge_make_problem';
	(super_html_check_tests) makefiles are generated in
	  advanced_layout contests.

	* super_html_7.c:
	(prepare_test_file_names) 'phr' parameter is removed;
	(get_compiler_flags) 'sstate' parameter is added;
	(generate_makefile) 'php' parameter is removed;
	  'sstate' parameter is added;
	  normalization rule generation is added;
	(super_serve_generate_makefile) new function;
	(super_serve_op_TESTS_MAKEFILE_GENERATE_ACTION) most code
	  is moved to 'super_serve_generate_makefile'.

2012-03-28 (r6684) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in: rule for 'ej-normalize' is added.

	* ej-normalize.c: initial revision.

2012-03-28 (r6682) Alexander Chernov  <cher@ejudge.ru>

	* ej_process.h:
	(ejudge_invoke_process) 'stdin_file' parameter is added.

	* run_inverse.c:
	(invoke_test_checker) test file is passed as redirected
	stdin rather then a command-line parameter.

	* super_html_3.c:
	(invoke_test_checker) test file is passed as redirected
	stdin rather then a command-line parameter.

	* super_html_7.c:
	(get_compiler_path) call of 'ejudge_invoke_process' is updated.

2012-03-27 (r6677) Alexander Chernov  <cher@ejudge.ru>

	* ej_process.h:
	(ejudge_get_host_names) new function prototype.

	* ejudge_cfg.h:
	(struct ejudge_cfg) field 'hosts_options' is added;
	(ejudge_cfg_get_host_option) new function prototype;
	(ejudge_cfg_get_host_option_int) new function prototype.

	* startstop.h:
	(start_find_all_processes) new function prototype.

	* ejudge_cfg.c:
	support for <hosts_options> is added;
	(get_attr_by_name) new static function;
	(ejudge_cfg_get_host_option) new function;
	(ejudge_cfg_get_host_option_int) new function.

	* ej-super-run.c:
	"ej_process.h" is included;
	"parallelism" host option is supported to limit the number of
	parallel instances of ej-super-run.

	* ej-super-run-control.c:
	all instances of ej-super-run are terminated instead of the first.

	* ejudge-control.c:
	"ej_process.h" is included;
	(command_start) 'super_run_parallelism' parameter is added;
	specified number of 'ej-super-run' processes is started;
	(main) "parallelism" host option is handled.

2012-03-24 (r6674) Alexander Chernov  <cher@ejudge.ru>

	* contests.h: copyright notice is updated;
	(struct contest_desc) 'old_run_managed' field is added.

	* super_proto.h:
	editing of "old_run_managed" attribute is supported.

	* serve_state.h:
	(serve_run_request) 'cnts' parameter is added.

	* contests.c, contests_2.c: copyright notice is updated;
	"old_managed" attribute is supported.

	* ej-batch.c:
	calls of 'serve_run_request' are updated.

	* new_server_html.c:
	calls of 'serve_run_request' are updated.

	* new_server_html_4.c:
	calls of 'serve_run_request' are updated.

	* serve_2.c:
	(serve_run_request) 'cnts' parameter is added;
	super-run is supported;
	(serve_testing_queue_delete) super-run is supported;
	(serve_testing_queue_change_priority) super-run is supported;
	(collect_run_packets) super-run is supported.

	* serve-control.c, super_html.c, super_html_2.c, super_html_3.c, super_html_4.c:
	editing of "old_run_managed" attribute is supported.

	* super-serve.c:
	run management mode is renamed as old-run-managed mode.

2012-03-23 (r6670) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	compilation of ej-super-run is added.

	* run.h:
	(run_tests) 'tst' parameter is declared const.

	* startstop.h: copyright notice is updated;
	(start_daemon) new function prototype is added.

	* ejudge-control.c: copyright notice is updated;
	ej-super-run is supported.

	* ej-super-run.c: basically completed.

	* ej-super-run-control.c: initial revision.

	* run_common.c:
	(invoke_nwrun) 'tst' parameter is declared const;
	(run_one_test) 'tst' parameter is declared const.

2012-03-23 (r6668) Alexander Chernov  <cher@ejudge.ru>

	* run_packet.h:
	old run_request_packet stuff is put under INCLUDE_RUN_REQUEST.

	* serve_state.h:
	(serve_send_run_quit) function prototype is removed.

	* ej-super-run.c: progress.

	* new_server_html.c:
	(priv_contest_operation) calls of 'serve_send_run_quit' are eliminated.

	* new_server_html_4.c:
	calls of 'serve_send_run_quit' are removed.

	* run_packet_1.c, run_packet_2.c, run_packet_3.c: copyright notice is updated;
	INCLUDE_RUN_REQUEST is defined.

	* serve_2.c:
	(serve_run_request) old run_request_packet stuff is removed;
	(serve_send_run_quit) function is removed;
	(testing_queue_lock_entry) updated to work with new run request packets
	(serve_testing_queue_delete) the same;
	(serve_testing_queue_change_priority) the same.

2012-03-22 (r6667) Alexander Chernov  <cher@ejudge.ru>

	* testing_report_xml.h: copyright notice is updated;
	(struct testing_report_xml) 'compiler_output' field is added.

	* compile.c:
	compiler and style checker output to stdout and stderr is merged.

	* ej-super-run.c: progress.

	* serve_2.c:
	(serve_read_compile_packet) compiler/style checker output is always saved.

	* testing_report_xml.c:
	<compiler_output> element support is added.

2012-03-21 (r6665) Alexander Chernov  <cher@ejudge.ru>

	* super_html_7.c:
	directory removal bugs fixed.

2012-03-21 (r6663) Alexander Chernov  <cher@ejudge.ru>

	* run_packet.h: copyright notice is updated;
	(run_reply_packet_dump) new function prototype.

	* master_html.c:
	(write_xml_testing_report) CPU time reporting is improved.

	* run_common.c: general improvements and regression fixes.

	* run_packet_5.c: copyright notice is updated;
	(run_reply_packet_dump) new function.

	* serve_2.c:
	(serve_read_run_packet) error reporting is improved.

2012-03-19 (r6659) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	run_common.c is added.

	* prepare.h:
	(prepare_parse_testsets) new function prototype;
	(prepare_free_testsets) new function prototype.

	* reuse_exec.h:
	(task_SetEnv) new function prototype;
	(task_FormatEnv) new function prototype.

	* run.h:
	(struct testinfo) moved here from run.c;
	(run_tests) function prototype is added.

	* ej-super-run.c: progress

	* prepare.c:
	(prepare_free_testsets) renamed from 'free_testsets';
	(prepare_parse_testsets) renamed from 'parse_testsets'.

	* run.c:
	most of code is moved to run_common.c.

	* run_common.c:
	initial revision.

2012-02-16 (r6652) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.c:
	'inotify_init' is used instead of 'inotify_init1'.

2012-02-15 (r6650) Alexander Chernov  <cher@ejudge.ru>

	* testing_report_xml.c: copyright notice is updated;
	(parse_testing_report) value -1 of "tests-passed" is allowed.

2012-02-08 (r6637) Alexander Chernov  <cher@ejudge.ru>

	* ej_process.h:
	(background_process_append_pollfd) function prototype is added.

	* super_html_7.c:
	(super_serve_op_TESTS_MAKE_continuation) NULL output is allowed.

	* super-serve.c:
	(do_loop) 'background_process_append_pollfd' is called.

2012-02-07 (r6634) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c, parsecfg.c, prepare.c, run.c, run_inverse.c, serve_2.c, super_html_3.c, super-serve.c:
	gcc 4.6 warning fix.

	* compile.c, compile-control.c, edit-userlist.c, ej-batch.c, ejudge-configure-compilers.c, filter_scan.lex, filter_tree.c, html.c, lang_config_vis.c, misctext.c, new-server-control.c, new_server_html_2.c, new_server_html_5.c, pathutl.c, rldb_plugin_file.c, runlog_xml.c, super_html_4.c, super_html_7.c, super-serve-control.c, uldb_plugin_xml.c, userlist-server.c, userlist-server-control.c: copyright notice is updated;
	gcc 4.6 warning fix.

2012-01-23 (r6631) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h: copyright notice is updated;
	(serve_state_init) 'contest_id' parameter is added.

	* teamdb.h: copyright notice is updated;
	(teamdb_init) 'contest_id' parameter is added.

	* teamdb_priv.h: copyright notice is updated;
	(struct teamdb_state) 'nref' field is added.

	* fix-db.c: copyright notice is updated;
	(process_contest) call of 'serve_state_init' is updated.

	* serve.c: copyright notice is updated;
	(main) call of 'teamdb_init' is updated.

	* serve_state.c:
	calls of 'teamdb_init' are updated.

	* teamdb.c: copyright notice is updated;
	(teamdb_init) 'contest_id' parameter is added.

2012-01-14 (r6628) Alexander Chernov  <cher@ejudge.ru>

	* ejudge_cfg.h: copyright notice is updated;
	(struct ejudge_cfg) 'serve_path' field is removed.

	* ejudge_cfg.c: copyright notice is updated;
	<serve_path> element is ignored.

	* super_html_2.c:
	(super_html_commit_contest) some local variables renamed.

	* super-serve.c, ejudge-setup.c:
	'serve_path' element is no longer handled.

2012-01-12 (r6624) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_tester_data) fields 'check_cmd', 'checker_env',
	'standard_checker_used' are removed.

	* prepare.c, run.c, super_html_3.c:
	'check_cmd', 'checker_env', 'standard_checker_used' use is removed.

2012-01-11 (r6621) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	"dll32" secure exec type is added.

	* prepare.c:
	"dll32" secure exec type is added.

	* run.c:
	(run_tests) DLL32 secure exec type is supported.

	* serve_2.c:
	(serve_run_request) memory leaks are fixed.

2012-01-11 (r6619) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(prepare_parse_open_tests) new function prototype;
	(prepare_parse_test_score_list) new function prototype.

	* reuse_exec.h: copyright notice is updated;
	(task_SetMaxRealTimeMillis) new function prototype.

	* run.h:
	(run_inverse_testing) 'prob', 'scoring_system' parameters are removed.

	* super_run_packet.h:
	(struct super_run_in_global_packet) 'user_spelling' field is added;
	'score_system_val' field is added;
	(struct super_run_in_problem_packet) 'binary_input', 'binary_output',
	'spelling', 'open_tests', 'type_val' fields are added.

	* prepare.c:
	(prepare_parse_test_score_list) new function.

	* problem_common.c: copyright notice is updated;
	(problem_parse_type) empty string is handled.

	* run.c, run_inverse.c:
	reworked to eliminate use of local problem configuration;
	all problem configuration is received from the server.

	* serve_2.c:
	(serve_run_request) packet generation is improved.

	* super_run_packet.c:
	parsing of 'score_system' and 'type' is added.

2012-01-10 (r6614) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h: copyright notice is updated;
	(prepare_parse_score_system) new function prototype is added.

	* run.h: copyright notice is updated;
	(run_inverse_testing) 'srp' parameter replaced 'req_pkt';
	'scoring_system' parameter is added.

	* super_run_packet.h: progress...

	* meta_generic.h:
	memory leak is fixed.

	* prepare.c:
	(prepare_parse_score_system) new function.

	* run.c: copyright notice is updated;
	'struct super_run_in_packet' is used instead of
	'struct run_request_packet'.

	* run_inverse.c: copyright notice is updated;
	"super_run_packet.h" is included;
	'struct super_run_in_packet' is used instead of
	'struct run_request_packet';
	(run_inverse_testing) 'scoring_system' parameter is added.

	* serve_2.c:
	(serve_run_request) packet is written in text format.

	* super_run_packet.c: progress...

2012-01-09 (r6612) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	super_run_packet.[ch] are added.

	* Makefile.unix.in: copyright notice is updated;
	super_run_packet_meta.[ch] is added.

	* meta.make: copyright notice is updated;
	super_run_packet_meta.[ch] are added.

	* meta_generic.h: copyright notice is updated;
	<stdio.h> is included;
	(meta_parse_string) new function prototype;
	(meta_unparse_cfg) new function prototype.

	* parsecfg.h: copyright notice is updated;
	(struct config_section_info) 'mm' field is added;
	(sarray_copy) new function prototype.

	* reuse_xalloc.h: copyright notice is updated;
	(xstrdup2) new function prototype is added.

	* super_run_packet.h: initial revision.

	* meta_generic.c: copyright notice is updated;
	"misctext.h", "xml_utils.h", "charsets.h" are included;
	(meta_destroy_fields) field type support is improved;
	(meta_unparse_cfg) new function;
	(meta_parse_string) new function.

	* parsecfg.c: copyright notice is updated;
	"meta_generic.h" is included;
	(copy_param) metainfo is supported;
	(sarray_copy) new function prototype.

	* prepare.c: copyright notice is updated;
	(prepare_tester_free) new function;
	(prepare_unparse_memory_limit_type) new function;
	(prepare_unparse_secure_exec_type) new function;
	(set_defaults) most of PREPARE_RUN specific settings are now done
	in PREPARE_SERVE mode as well;
	(prepare_tester_refinement) 'memory_limit_type', 'secure_exec_type'
	are copied.

	* serve_2.c: copyright notice is updated;
	"super_run_packet.h" is included;
	"prepare_dflt.h" is included;
	(find_lang_specific_value) new function;
	(serve_run_request) super run packet is created.

	* super_run_packet.c: initial revision.

2012-01-01 (r6609) Alexander Chernov  <cher@ejudge.ru>

	* copyright.c: copyright notice is updated.

2012-01-01 (r6607) Alexander Chernov  <cher@ejudge.ru>

	* files.make: copyright notice is updated;
	pollfds module is added.

	* ej_process.h: copyright notice is updated;
	(background_process_close_fds) new function prototype.

	* pollfds.h: initial revision.

	* super_proto.h: copyright notice is updated;
	unused commands are removed.

	* super-serve.h: copyright notice is updated;
	(struct contest_extra) unused fields are removed.

	* ejudge-setup.c: copyright notice is updated;
	(generate_contest_xml) minor fix.

	* new_server_html.c: copyright notice is updated;
	(unpriv_load_html_style) buffer size is fixed.

	* serve-control.c: copyright notice is updated;
	unused code is removed.

	* super_html.c: copyright notice is updated;
	unused code is removed.

	* super_html_2.c: copyright notice is updated;
	unused code is removed.

	* super_html_3.c: copyright notice is updated;
	(invoke_make) buffer size is fixed.

	* super-serve.c: copyright notice is updated;
	reworked to resove scalability issues;
	inotify is used.

2011-12-28 (r6600) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.c:
	(do_loop) 'select' syscall error handling is improved.

2011-12-24 (r6597) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.c, serve-control.c, super_html.c, new_server_html.c, super_html_2.c, super_html_3.c, super_html_4.c, super_proto.h:
	Ticket #52 is done.

	* super_proto.h:
	editing of 'open_time', 'close_time' contest fields is supported.

	* new_server_html.c:
	(unpriv_print_status) open_time and close_time is respected
	for virtual contests;
	(unpriv_command) the same as above.

	* serve-control.c, super_html.c, super_html_2.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of 'open_time', 'close_time' contest fields is supported.

2011-12-24 (r6595) Alexander Chernov  <cher@ejudge.ru>

	* new-server-cmd.c, userlist-server.c, new-server.h, userlist_proto.h, new_server_html.c, new_server_html_4.c:
	Ticket #66 is done.

	* new-server.h:
	NEW_SRV_ACTION_RELOAD_SERVER_2 request is added;
	(ns_try_contest_extra) function prototype is added.

	* userlist_proto.h:
	ULS_PRIV_CHECK_PASSWORD is added.

	* new-server-cmd.c:
	(prepare_unload_2) new function.

	* new_server_html.c:
	(ns_try_contest_extra) renamed from 'try_contest_extra'.

	* new_server_html_4.c:
	"ejudge_cfg.h" is included;
	"errlog.h" is included;
	<sys/types.h> is included;
	<pwd.h> is included;
	(cmd_reload_server_2) new function;
	(new_server_cmd_handler) 'cmd_reload_server_2' is called for
	the corresponding request.

	* userlist-server.c:
	(cmd_priv_check_password) new request handled.

2011-12-23 (r6593) Alexander Chernov  <cher@ejudge.ru>

	* html_checkbox.c, contests.c, contests_2.c, new_server_html.c, mischtml.h, new_server_html_5.c:
	Ticket #57 is done.

	* mischtml.h:
	(html_checkbox) 'value' parameter is added.

	* contests.c:
	elements <open_time>, <close_time> are supported;
	attribute "checkbox" is supported.

	* contests_2.c:
	(unparse_field) 'separator', 'checkbox', 'options' attributes
	are unparsed;
	(contests_unparse) 'open_time', 'close_time' elements are unparsed.

	* html_checkbox.c: copyright notice is updated;
	(html_checkbox) parameter 'value' is added.

	* new_server_html.c:
	(priv_upsolving_configuration_1) calls of 'html_checkbox' are updated.

	* new_server_html_5.c:
	(edit_general_form) checkbox fields are supported.

2011-12-23 (r6592) Alexander Chernov  <cher@ejudge.ru>

	* opcaps.h: copyright notice is updated;
	OPCAP_UNLOAD_CONTEST capability is added.

	* opcaps.c:
	OPCAP_UNLOAD_CONTEST capability is added.

2011-12-23 (r6591) Alexander Chernov  <cher@ejudge.ru>

	* contests.h:
	(struct contest_field) 'checkbox' field is added;
	(struct contest_desc) 'open_time', 'close_time' fields are added.

2011-12-23 (r6589) Alexander Chernov  <cher@ejudge.ru>

	* html.h, new_server_html.c, html.c, new_server_html_2.c:
	Ticket #70 is done.

	* html.h:
	(write_html_run_status) 'enable_js_status_menu' parameter is added.

	* html.c:
	(write_html_run_status) 'enable_js_status_menu' parameter is added;
	javascript-based status change href is implemented.

	* new_server_html.c:
	(priv_main_page) some javascript is generated to the page.

	* new_server_html_2.c:
	(ns_write_priv_all_runs) call of 'write_html_run_status' is updated.

2011-12-21 (r6586) Alexander Chernov  <cher@ejudge.ru>

	* testinfo.c, run.c, serve_2.c:
	Ticket #64 is implemented.

	* run.c:
	'disable_stderr' option of testing is supported.

	* serve_2.c:
	(serve_run_request) 'disable_stderr' flag is passed to run.

	* testinfo.c:
	(testinfo_parse) default value of 'disable_stderr' is set to -1.

2011-12-21 (r6585) Alexander Chernov  <cher@ejudge.ru>

	* run_packet.h, run_packet_priv.h:
	support for 'disable_stderr' flag is added.

	* run_packet_1.c, run_packet_2.c:
	support for 'disable_stderr' flag is added.

2011-12-21 (r6584) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of 'disable_stderr' problem configuration parameter
	is supported.

	* testinfo.h:
	'disable_stderr' parameter is added.

	* prepare.c, prepare_out.c:
	'disable_stderr' problem configuration parameter is suppored.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of 'disable_stderr' problem configuration parameter
	is supported.

	* testinfo.c:
	'disable_stderr' parameter is added.

2011-12-21 (r6583) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'disable_stderr' field is added.

2011-12-20 (r6581) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c, super-serve.c, serve-control.c, new_server_html.c, super_html_3.c, prepare_out.c, super_html_4.c, new_server_html_4.c, super_proto.h:
	Ticket #54 is implemented.

	* super_proto.h:
	editing of 'ignore_bom' global configuration variable is supported.

	* new_server_html.c:
	(priv_submit_run) 'ignore_bom' global configuration variable
	  is supported;
	(unpriv_submit_run) the same.

	* new_server_html_4.c:
	(cmd_submit_run) 'ignore_bom' global configuration variable
	  is supported.

	* prepare.c, prepare_out.c:
	'ignore_bom' global configuration variable is supported.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of 'ignore_bom' global configuration variable is supported.

2011-12-20 (r6580) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) 'ignore_bom' field is added.

2011-12-19 (r6578) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_5.c:
	(edit_general_form) "submit" and "cancel" buttons are swapped;
	(edit_member_form) "submit" and "cancel" buttons are swapped.

2011-12-19 (r6576) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of <register_subject>, <register_subject_en> elements
	of contest.xml file is supported.

	* contests.c, contests_2.c, contest_tmpl.c:
	support for <register_subject>, <register_subject_en>
	elements is added.

	* userlist-server.c:
	(send_registation_email) register_subject, register_subject_en
	elements are supported;
	(cmd_register_new_2) the same.

	* serve-control.c, super_html.c, super_html_2.c, super_html_4.c, super-serve.c:
	editing of <register_subject>, <register_subject_en> elements
	of contest.xml file is supported.

2011-12-19 (r6575) Alexander Chernov  <cher@ejudge.ru>

	* contests.h:
	(struct contest_desc) fields 'register_subject',
	  'register_subject_en' are added.

2011-12-18 (r6573) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h, new_server_proto.c, new_server_html.c, serve_2.c, new_server_proto.h:
	Ticket #58 is fixed.

	* new_server_proto.h:
	new error codes are added.

	* serve_state.h:
	error codes are added;
	(serve_compile_request) 'warn_unused_result' attribute is added;
	(serve_err_str) new function prototype.

	* new_server_html.c:
	(serve_err_to_new_srv_err) new function;
	(priv_submit_run) return value of 'serve_compile_request' is checked;
	(unpriv_submit_run) return value of 'serve_compile_request' is checked.

	* new_server_proto.c:
	new error codes are added.

	* serve_2.c:
	(serve_compile_request) error code is returned in case of error;
	(serve_rejudge_run) return value of 'serve_compile_request' is checked;
	(serve_err_str) new function.

2011-12-18 (r6571) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h, super-serve.c, new_server_html.c, serve_state.c, serve_2.c, new_server_html_4.c, super_html_7.c:
	Ticket #68 is fixed.
	
	The global ejudge configuration is passed to many
	functions.

2011-12-17 (r6566) Alexander Chernov  <cher@ejudge.ru>

	* ej_process.h: copyright notice is updated;
	new functions to handle background processes are added.

	* super_proto.h: in progress...

	* html.c:
	(new_write_user_runs) invalid problems are better handled.

	* super_html_4.c:
	framework for background processes is implemented.

	* super_html_7.c:
	make running is implemented.

	* super_proto.c: progress...

	* super-serve.c:
	a framework for background processes is implemented.

2011-12-17 (r6565) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.h:
	(struct super_http_request_info) 'continuation' field is added.

2011-12-17 (r6564) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.h:
	(super_serve_find_process) function prototype is added.

2011-12-17 (r6563) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.h:
	(struct super_http_request_info) output stream fields 'out_f', 'out_t',
	  'out_z', 'log_f', 'log_t', 'log_z' are added.

2011-12-17 (r6562) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.h:
	(struct super_http_request_info) field 'suspend_context' is added.

2011-12-17 (r6561) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.h:
	(struct super_http_request_info) 'suspend_reply' field is added.

2011-12-17 (r6559) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.h:
	(struct super_http_request_info) 'data' field is added.

2011-12-16 (r6558) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.h:
	(super_serve_register_process) new function prototype is added.

2011-12-14 (r6555) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c:
	(priv_download_source) actual file type (.tar.gz, .tar.bz2, etc)
	is guessed for .tar files and reported to the browser.

2011-12-13 (r6552) Alexander Chernov  <cher@ejudge.ru>

	* run.c:
	Ticket #55 fixed.

2011-12-09 (r6544) Alexander Chernov  <cher@ejudge.ru>

	* edit-userlist.c:
	Ticket #61 is fixed.

2011-12-09 (r6540) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.c, super_proto.h, super_html_7.c:
	super_proto.h: in progress...
	
	super_html_7.c, super_proto.c: in progress...

2011-12-08 (r6537) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_write_user_problems_summary) Ticket #49 fixed.

2011-12-08 (r6533) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c: copyright notice is updated;
	(ns_write_priv_all_runs) PR #50 is fixed.

2011-11-24 (r6525) Alexander Chernov  <cher@ejudge.ru>

	* userlist-server.c:
	some allocas are replaced with callocs.

2011-11-17 (r6523) Alexander Chernov  <cher@ejudge.ru>

	* diff.c:
	"mime_type.h" include is added;
	(compare_runs) output-only problems are supported.

2011-11-16 (r6521) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_write_priv_all_runs) run status change control is removed.

2011-11-13 (r6519) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h: progress...

	* filter_scan.lex: copyright notice is updated;
	any mix of lowercase and uppercase letter is allowed in run statuses,
	for example, OK, Ok or ok.

	* super_html_7.c, super_proto.c: progress...

2011-11-06 (r6517) Alexander Chernov  <cher@ejudge.ru>

	* filter_eval.c:
	(do_eval) checks for invalid lang_id and prob_id are strengthened.

2011-11-05 (r6515) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	(serve_read_run_packet) 'ignore_prev_ac' problem configuration
	variable is supported.

2011-11-05 (r6513) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c, prepare_out.c:
	'ignore_prev_ac' problem configuration variable is supported.

	* serve-control.c, super-serve.c, super_html_3.c, super_html_4.c:
	editing of 'ignore_prev_ac' problem configuration variable is supported.

2011-11-05 (r6512) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'ignore_prev_ac' field is added.

	* super_proto.h:
	editing of 'ignore_prev_ac' problem variable is added.

2011-11-03 (r6508) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	source header/footer and solution editing is implemented.

	* super_proto.c, super_html_7.c:
	source header/footer and solution editing is implemented.

2011-11-02 (r6506) Alexander Chernov  <cher@ejudge.ru>

	* misctext.h:
	(csv_armored_memlen) new function prototype is added;
	(csv_armored_strlen) new function prototype is added;
	(csv_armor_needed) new function prototype is added;
	(csv_armor_buf) new function prototype is added.

	* misctext.c:
	(csv_armored_memlen) new function is added;
	(csv_armored_strlen) new function is added;
	(csv_armor_needed) new function is added;
	(csv_armor_string) new function is added;
	(csv_armor_buf) new function is added.

	* userlist-server.c:
	(do_get_database) header row is fixed;
	CSV escaping is implemented.

2011-11-01 (r6504) Alexander Chernov  <cher@ejudge.ru>

	* html.c:
	(do_write_kirov_standings) RUN_WRONG_ANSWER_ERR is handled correctly.

2011-11-01 (r6502) Alexander Chernov  <cher@ejudge.ru>

	* run.c:
	(run_tests) scores of scoring checker are not parsed in case of PE.

2011-10-29 (r6500) Alexander Chernov  <cher@ejudge.ru>

	* expat_iface.c:
	(xml_parse_text) new function prototype.

	* problem_xml.h:
	(problem_xml_delete_test) new function prototype;
	(problem_xml_parse_text) new function prototype;
	(problem_xml_free_text) new function prototype;
	(problem_xml_create) new function prototype;
	(problem_xml_create_statement) new function prototype;
	(problem_xml_attach_title) new function prototype;
	(problem_xml_attach_description) new function prototype;
	(problem_xml_attach_input_format) new function prototype;
	(problem_xml_attach_output_format) new function prototype;
	(problem_xml_attach_notes) new function prototype;
	(problem_xml_add_example) new function prototype.

	* super_proto.h:
	progress.

	* expat_iface.c:
	(xml_parse_text) new function.

	* problem_xml.c:
	(problem_xml_delete_test) new function;
	(problem_xml_parse_text) new function;
	(problem_xml_free_text) new function;
	(problem_xml_create) new function;
	(problem_xml_create_statement) new function;
	(problem_xml_attach_title) new function;
	(problem_xml_attach_description) new function;
	(problem_xml_attach_input_format) new function;
	(problem_xml_attach_output_format) new function;
	(problem_xml_attach_notes) new function;
	(problem_xml_add_example) new function.

	* super_html_7.c:
	statement editing is implemented.

	* super_proto.c:
	progress.

2011-10-27 (r6498) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	problem_xml_2.c is added.

	* expat_iface.h:
	(xml_unparse_raw_tree_subst) renamed from 'xml_unparse_raw_tree';
	(xml_unparse_raw_tree) new function prototype.

	* problem_xml.h:
	(problem_xml_unparse) new function prototype;
	(problem_xml_get_parse_spec) new function prototype.

	* super_proto.h:
	progress...

	* expat_iface.c:
	(xml_unparse_raw_tree_subst) renamed from 'xml_unparse_raw_tree';
	(xml_unparse_raw_tree) new function (unparsing without substitions).

	* problem_xml.c:
	(problem_xml_get_parse_spec) new function;
	(problem_xml_unparse_elem) 'xml_unparse_raw_tree_subst' is used
	instead of 'xml_unparse_raw_tree';
	(problem_xml_unparse_node) the same as above.

	* problem_xml_2.c: initial revision.

	* super_html_7.c, super_proto.c:
	progress...

2011-10-24 (r6496) Alexander Chernov  <cher@ejudge.ru>

	* prepare_out.c:
	(prepare_unparse_testers) std io/file io special modes are ignored.

2011-10-21 (r6493) Alexander Chernov  <cher@ejudge.ru>

	* expat_iface.h: copyright notice is updated;
	(xml_build_tree) 'log_f' parameter is added;
	(xml_build_tree_str) 'log_f' parameter is added;
	(xml_build_tree_file) 'log_f' parameter is added.

	* parsecfg.c:
	(copy_param) call of 'xml_parse_date' is updated.

	* problem_xml.h:
	(problem_xml_parse) 'log_f' parameter is added;
	(problem_xml_parse_safe) 'log_f' parameter is added;
	(problem_xml_parse_string) 'log_f' parameter is added;
	(problem_xml_parse_stream) 'log_f' parameter is added.

	* super_proto.h:
	SSERV_OP_TESTS_STATEMENT_EDIT_ACTION is added.

	* xml_utils.h: copyright notice is updated;
	(xml_parse_ip) 'log_f' parameter is added;
	(xml_parse_date) 'log_f' parameter is added;
	(xml_parse_int) 'log_f' parameter is added;
	(xml_parse_ip_mask) 'log_f' parameter is added;
	(xml_parse_bool) 'log_f' parameter is added;
	'xml_err_file' global variable is added.

	* cldb_plugin_file.c:
	(clar_read_entry) call of 'xml_parse_ip' is updated.

	* contests.c:
	(parse_access) call of 'xml_parse_ip_mask' is updated;
	(parse_contest) call of 'xml_parse_date' is updated;
	(parse_one_contest_xml) call of 'xml_build_tree' is updated.

	* edit-userlist.c:
	(do_display_user) call of 'xml_parse_bool' is updated.

	* ejudge_cfg.c:
	(ejudge_cfg_parse) call of 'xml_build_tree' is updated.

	* expat_iface.c:
	<stdlib.h> is included;
	(struct parser_data) new field 'log_f' is added;
	(parse_err) new function for use instead of 'err';
	(xml_build_tree) 'log_f' parameter is added;
	(xml_build_tree_str) 'log_f' parameter is added;
	(xml_build_tree_file) 'log_f' parameter is added.

	* filter_tree.c:
	(filter_tree_eval_node) call of 'xml_parse_date' is updated.

	* new-client.c:
	(check_access_rules) call of 'xml_parse_ip_mask' is updated.

	* new-server-cmd.c:
	(main) call of 'xml_parse_ip' is updated.

	* new_server_html.c:
	(do_schedule) call of 'xml_parse_date' is updated;
	(do_change_finish_time) call of 'xml_parse_date' is updated;
	(ns_handle_http_request) call of 'xml_parse_ip' is updated.

	* new_server_html_4.c:
	(do_schedule) call of 'xml_parse_date' is updated.

	* prepare.c:
	calls of 'xml_parse_date', 'problem_xml_parse_safe'
	are updated.

	* problem_xml.c:
	(problem_xml_parse) 'log_f' parameter is added;
	(problem_xml_parse_safe) 'log_f' parameter is added;
	(problem_xml_parse_string) 'log_f' parameter is added;
	(problem_xml_parse_stream) 'log_f' parameter is added.

	* rldb_plugin_file.c:
	(run_read_entry_v0) call of 'xml_parse_ip' is updated.

	* runlog_xml.c:
	(process_run_elements) call of 'xml_parse_ip' is updated;
	(parse_runlog_xml) call of 'xml_build_tree_str' is updated.

	* serve-control.c:
	calls of 'xml_build_tree_str', 'xml_build_tree' are updated.

	* serve_state.c:
	(parse_group_dates) call of 'xml_parse_date' is updated.

	* super_html_2.c:
	calls of 'xml_parse_ip_mask', 'xml_parse_date' are updated.

	* super_html_3.c:
	calls of 'xml_parse_date' are updated.

	* super_html_4.c:
	calls of 'xml_parse_ip_mask' are updated.

	* super_html_7.c, super_proto.c:
	progress.

	* t3_packets.c:
	(t3_in_packet_parse_str) call of 'xml_build_tree_str' is updated.

	* team_extra_xml.c:
	calls of 'xml_parse_int', 'xml_parse_ip', 'xml_parse_date',
	'xml_build_tree' are updated.

	* testing_report_xml.c:
	(testing_report_parse_xml) call of 'xml_build_tree_str'
	is updated.

	* userlist.c:
	(userlist_set_member_field_str) call of 'xml_parse_date' is updated;
	(userlist_set_info_field_str) call of 'xml_parse_date' is updated;
	(userlist_is_equal_user_field) call of 'xml_parse_date' is updated;
	(userlist_set_user_field) call of 'xml_parse_date' is updated.

	* userlist_xml.c:
	calls of 'xml_parse_ip', 'xml_parse_date', 'xml_parse_int',
	'xml_build_tree_str', 'xml_build_tree' are updated.

	* users.c:
	(parse_config) calls of 'xml_build_tree', 'xml_build_tree_str',
	'xml_parse_ip_mask' are updated.

2011-10-19 (r6485) Alexander Chernov  <cher@ejudge.ru>

	* super_html_7.c:
	makefile generation is much improved.

2011-10-14 (r6471) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of 'lang_compiler_env' problem configuration parameter
	is supported.

	* prepare.c, prepare_out.c:
	'lang_compiler_env' problem configuration variable is supported.

	* serve_2.c:
	(filter_lang_environ) new function is implemented;
	(serve_compile_request) support for 'lang_compiler_env' problem
	configuration parameter is added.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of 'lang_compiler_env' problem configuration parameter
	is supported.

2011-10-14 (r6470) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'lang_compiler_env' field is added.

2011-10-13 (r6465) Alexander Chernov  <cher@ejudge.ru>

	* super_html_7.c:
	makefile generation is basically implemented.

2011-10-09 (r6461) Alexander Chernov  <cher@ejudge.ru>

	* problem_xml.h: copyright notice is updated;
	(problem_xml_parse_safe) new function prototype is added.

	* execute.c:
	(run_program) test number guessing is added if both '--test_pattern' and
	'--test_file' are specified.

	* prepare.c:
	(set_defaults) 'problem_xml_parse_safe' is used.

	* problem_xml.c:
	(problem_xml_parse_safe) new function is added.

	* super_html_7.c:
	progress...

2011-10-04 (r6455) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.c, super_proto.h, super_html_7.c:
	test deletion is implemented.

2011-10-04 (r6452) Alexander Chernov  <cher@ejudge.ru>

	* super_html_7.c, super_proto.c:
	test insertion is functional.

2011-10-01 (r6445) Alexander Chernov  <cher@ejudge.ru>

	* testinfo.h:
	(struct testinfo_struct) new fields 'env_u', 'env_v' are added;
	(testinfo_unparse_environ) new function prototype.

	* execute.c:
	"--input", "--output", "--error" options are renamed to
	"--stdin", "--stdout", "--stderr";
	new options: "--use-stdin", "--use-stdout", "--test-file",
	"--corr-file", "--info-file", "--input-file", "--output-file",
	"--mode", "--group".

	* run.c:
	(setup_environment) 'pt' parameter is added;
	custom environment in info files is supported.

	* testinfo.c:
	(unparse_str_array) new function;
	(testinfo_unparse_environ) new function.

2011-09-30 (r6441) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) fields 'tgzdir_sfx', 'tgzdir_pat'
	are added;
	(struct section_problem_data) fields 'tgzdir_sfx', 'tgzdir_pat'
	are added.

	* prepare_dflt.h: copyright notice is updated;
	default tgzdir suffix is added.

	* super_proto.h:
	editing of 'tgz_sfx', 'tgz_pat', 'tgzdir_sfx', 'tgzdir_pat'
	problem configuration variables is supported.

	* prepare.c, prepare_out.c:
	'tgzdir_sfx', 'tgzdir_pat' problem configuration variables are added.

	* run.c:
	(run_tests) 'tgzdir_sfx' problem configuration variable is handled.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of 'tgz_sfx', 'tgz_pat', 'tgzdir_sfx', 'tgzdir_pat'
	problem configuration variables is supported.

2011-09-29 (r6439) Alexander Chernov  <cher@ejudge.ru>

	* ej_types.h:
	TEST_NORM_DEFAULT is added.

	* super_proto.h: progress...

	* prepare.c, prepare_out.c:
	'normalization' problem configuration variable is supported.

	* problem_common.c:
	(test_normalization_parse) new function;
	(test_normalization_unparse) new function.

	* serve-control.c, super_html_3.c, super-serve.c:
	editing of 'normalization' problem configuration variable
	is supported.

	* super_html_7.c: progress...

	* super_proto.c: progress...

2011-09-28 (r6437) Alexander Chernov  <cher@ejudge.ru>

	* ej_types.h: test normalization modes are added.

	* super_html_7.c:
	test normalization mode constants are moved to ej_types.h.

2011-09-28 (r6436) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'normalization' field is added;
	'normalization_val' private field is added.

2011-09-27 (r6434) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	'solution_src', 'solution_cmd' problem configuration parameters
	are supported.

	* super_proto.h:
	editing of 'solution_src', 'solution_cmd' program configuration
	parameters is supported.

	* prepare.c, prepare_out.c:
	'solution_src', 'solution_cmd' problem configuration parameters
	are supported.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of 'solution_src', 'solution_cmd' program configuration
	parameters is supported.

2011-09-11 (r6420) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	progress.

	* userlist.h: copyright notice is updated;
	(userlist_lookup_csv_field_name) new function prototype;
	(userlist_get_csv_field_name) new function prototype.

	* super_html_6.c:
	<errno.h> is included;
	(super_serve_op_USER_BROWSE_PAGE) link to "import CSV data" is added;
	(super_serve_op_USER_CREATE_FROM_CSV_PAGE) operation code is fixed;
	(super_serve_op_USER_IMPORT_CSV_PAGE) new function;
	(super_serve_op_USER_IMPORT_CSV_ACTION) new function.

	* super_html_7.c:
	progress.

	* super_proto.c:
	progress.

	* userlist.c:
	(userlist_lookup_csv_field_name) new function;
	(userlist_get_csv_field_name) new function.

2011-09-07 (r6419) Alexander Chernov  <cher@ejudge.ru>

	* reuse_osdeps.h:
	(os_MakeDirPath2) new function prototype is added.

	* ejudge-setup.c:
	(generate_serve_cfg) 'compile_max_vm_size' increased to 512M.

2011-07-22 (r6414) Alexander Chernov  <cher@ejudge.ru>

	* super_html.h:
	(super_html_get_standard_checker_description) new function prototype.

	* super_proto.h:
	new operation codes.

	* prepare.c:
	(set_defaults) more is done in PREPARE_SERVE mode.

	* prepare_out.c:
	(prepare_unparse_actual_prob) new function.

	* serve_state.c:
	(serve_state_load_contest_config) fix.

	* super_html_3.c:
	(super_html_get_standard_checker_description) new function.

	* super_html_7.c: progess...

	* super_proto.c:
	new operation codes.

	* super-serve.c:
	(sid_state_clear) test editing data is destroyed.

2011-07-22 (r6413) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(prepare_unparse_actual_prob) prototype is added.

2011-07-17 (r6412) Alexander Chernov  <cher@ejudge.ru>

	* clarlog.h: copyright notice is updated;
	(clar_open) 'const' is added to 'config' parameter.

	* common_plugin.h: copyright notice is updated;
	(struct common_plugin_iface) 'const' is added to 'config' parameter
	of 'prepare' method.

	* ejudge_cfg.h: copyright notice is updated;
	(ejudge_cfg_get_plugin_config) 'const' is added to 'cfg' parameter.

	* runlog.h:
	(run_open) 'const' is added to 'config' parameter.

	* serve_state.h:
	(struct serve_state) new fields 'timestamp', 'last_check_time'
	are added;
	(serve_state_load_contest_config) new function prototype.

	* super_proto.h: progress.

	* clarlog.c:
	(clar_open) 'const' is added to 'config' parameter.

	* cldb_plugin_file.c:
	(prepare_func) 'const' is added to 'cfg' parameter.

	* common_plugin.c:
	(plugin_register_builtin) 'const' is added to 'config' parameter;
	(plugin_load_external) 'const' is added to 'config' parameter.

	* ejudge_cfg.c:
	(ejudge_cfg_get_plugin_config) 'const' is added to 'cfg' parameter.

	* rldb_plugin_file.c:
	(prepare_func) 'const' is added to 'cfg' parameter.

	* runlog.c:
	(run_open) 'const' is added to 'config' parameter.

	* serve_state.c:
	(serve_state_load_contest_config) new function.

	* super_html_7.c: progress...

	* uldb_plugin_xml.c:
	(prepare_func) 'const' is added to 'cfg' parameter.

2011-07-15 (r6406) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h:
	(struct serve_state) field 'contest_id' is added.

	* meta_generic.c:
	(meta_destroy_fields) fixed.

	* super_html_7.c, super_proto.c: progress...

	* super-serve.c:
	(sid_state_find) parameter 'remote_addr' is added.

2011-07-15 (r6405) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.h:
	(struct sid_state) field 'remote_addr' is added;
	  field 'te_state' is added.

2011-07-13 (r6403) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	'super_html_7.c' is added.

	* super_html.h:
	operation error codes are moved to 'super_proto.h'.

	* super_proto.h:
	operation error codes moved here;
	extern declaration of 'super_proto_op_names', etc are added.

	* super_html.c:
	'Test details' link is added.

	* super_html_4.c:
	'op_names', 'op_redirect', 'error_messages' are moved to super_proto.c.

	* super_html_7.c: initial revision.

	* super_proto.c:
	'super_proto_op_names', 'super_proto_op_redirect',
	'super_proto_op_error_messages' are moved here from super_html_4.c.

2011-07-04 (r6393) Alexander Chernov  <cher@ejudge.ru>

	* compile.c:
	style checker output to the standard output is stored in a separate file.

	* new_server_html_2.c:
	(ns_write_priv_source) style checker output is shown in all cases.

	* serve_2.c:
	(serve_read_compile_packet) style checker report file is supported.

2011-06-30 (r6387) Alexander Chernov  <cher@ejudge.ru>

	* lang_config_vis.c:
	(lang_config_generate_compile_cfg) support for "binary" configuration parameter
	is added.

2011-06-25 (r6381) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	new commands are added:
	NEW_SRV_ACTION_DUMP_LANGUAGES, NEW_SRV_ACTION_GET_CONTEST_STATUS,
	NEW_SRV_ACTION_GET_CONTEST_SCHED, NEW_SRV_ACTION_GET_CONTEST_DURATION,
	NEW_SRV_ACTION_GET_CONTEST_DURATION;
	according to a patch from germanilyin@gmail.com.

	* new_server_html.c, new_server_html_4.c, new-server-cmd.c:
	new commands are added:
	NEW_SRV_ACTION_DUMP_LANGUAGES, NEW_SRV_ACTION_GET_CONTEST_STATUS,
	NEW_SRV_ACTION_GET_CONTEST_SCHED, NEW_SRV_ACTION_GET_CONTEST_DURATION,
	NEW_SRV_ACTION_GET_CONTEST_DURATION;
	according to a patch from germanilyin@gmail.com.

2011-06-19 (r6377) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h: progress.

	* userlist_proto.h:
	'ULS_GET_GROUP_INFO' is added.

	* super_html_4.c, super_html_6.c: progress.

	* userlist-server.c:
	'ULS_GET_GROUP_INFO' request is implemented.

2011-06-18 (r6370) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	SSERV_OP_USER_JUMP_CONTEST_ACTION is added.

	* super_html_4.c, super_html_6.c:
	jumping to another contest is implemented.

2011-06-18 (r6368) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	(serve_read_compile_packet) check for user name is removed.

	* userlist-server.c:
	userlist updating is improved.

2011-06-12 (r6363) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h: progress.

	* userlist_proto.h:
	'ULS_LIST_ALL_USERS_4' is added.

	* super_html_4.c, super_html_6.c: progress.

	* userlist-server.c:
	'ULS_LIST_ALL_USERS_4' is implemented.

2011-06-11 (r6361) Alexander Chernov  <cher@ejudge.ru>

	* super_html_4.c, super_html_6.c: progress.

2011-06-10 (r6359) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	SSERV_OP_USER_SEL_CANCEL_ACTION is added.

	* super-serve.h:
	"bitset.h" is included;
	(struct sid_state) 'marked' field is added.

	* userlist_proto.h:
	ULS_LIST_ALL_USERS_3 command is added.

	* super_html_4.c, super_html_6.c: progress

	* super-serve.c:
	(sid_state_clear) 'marked' field is freed.

	* userlist-server.c:
	"bitset.h" is included;
	(cmd_list_all_users_3) new command is implemented.

2011-06-05 (r6356) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	bitset.[ch] are added.

	* super_proto.h: progress...

	* super_html_4.c, super_html_6.c: progress...

2011-06-05 (r6355) Alexander Chernov  <cher@ejudge.ru>

	* bitset.c, bitset.h:
	initial revision

2011-05-28 (r6353) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	(ns_header) 'cnts' parameter is added;
	(ns_separator) new function prototype.

	* new_server_html.c, new_server_html_2.c, new_server_html_5.c:
	calls of 'ns_header' are updated;
	calls of 'ns_separator' are added instead of fprintfs.

	* new_server_html_3.c: copyright notice is updated;
	header and separator templated are changed to use substitutions;
	(process_template) 'logo_url', 'css_url' parameters are added;
	  '%O' (logo) and '%Y' (css) substitutions are supported;
	(ns_header) 'cnts' parameter is added;
	(ns_separator) new function;
	(ns_footer) call of 'process_template' is updated;
	calls of 'ns_header' are updated;
	calls of 'ns_separator' are added.

2011-05-24 (r6351) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of new contest elements <logo_url>, <css_url> is supported.

	* serve-control.c, super_html.c, super_html_2.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of new contest elements <logo_url>, <css_url> is supported.

2011-05-24 (r6349) Alexander Chernov  <cher@ejudge.ru>

	* contests.h: copyright notice is updated;
	(struct contest_desc) new fields 'logo_url', 'css_url' are added.

	* contests.c, contest_tmpl.c:
	new elements <logo_url>, <css_url> are handled.

2011-05-23 (r6347) Alexander Chernov  <cher@ejudge.ru>

	* misctext.h: copyright notice is updated;
	(is_valid_email_address) new function prototype.

	* super_html.h:
	new error code 'S_ERR_INV_EMAIL' is added.

	* ejudge-setup.c, job-server.c, new_server_html_5.c, super_html_2.c, super_html_4.c, super_html_6.c:
	email address is validated using 'is_valid_email_address' function.

	* misctext.c:
	(is_valid_email_address) new function.

2011-05-23 (r6345) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c:
	(set_defaults) '%' is considered as a special substitution character
	when handling style_checker_cmd.

	* sformat.c:
	(sformat_message) %Gr substitution is supported.

2011-05-22 (r6343) Alexander Chernov  <cher@ejudge.ru>

	* html.h:
	(write_xml_team_testing_report) new parameters are added:
	  'sid', 'self_url', 'extra_args', 'action_vec'.

	* mischtml.h:
	(html_hyperref_attr) new function prototype.

	* html.c:
	(html_make_title) new function;
	(write_xml_team_testing_report) new parameters are added:
	  'sid', 'self_url', 'extra_args', 'action_vec';
	full archive storage is supported.

	* html_hyperref.c: copyright notice is updated;
	(html_hyperref_attr) new function.

	* new_server_html.c:
	(unpriv_view_test) test visibility settings are supported;
	(unpriv_view_report) call of 'write_xml_team_testing_report' updated.

	* new_server_html_2.c:
	(ns_write_priv_report) call of 'write_xml_team_testing_report' updated.

2011-05-22 (r6341) Alexander Chernov  <cher@ejudge.ru>

	* html.h:
	(do_write_kirov_standings) 'user_id' parameter is added.

	* html.c:
	(do_write_kirov_standings) 'user_id' parameter is added;
	  standings freezing in user mode is supported correctly;
	(write_standings) call of 'do_write_kirov_standings' is updated.

	* new_server_html.c, new_server_html_2.c:
	calls of 'do_write_kirov_standings' are updated.

2011-05-14 (r6333) Alexander Chernov  <cher@ejudge.ru>

	* meta.make: progress...

	* super_html_6.h, super_proto.h: progress...

	* super_html_6.c: progress...

	* uldb_plugin_xml.c:
	(set_reg_flags_func) copy command (4) is supported.

	* userlist-server.c:
	(cmd_edit_registration) copy command (4) is supported.

2011-05-09 (r6326) Alexander Chernov  <cher@ejudge.ru>

	* super_html.h:
	'S_ERR_TOO_MANY_MEMBERS' error code is added.

	* Makefile.unix.in:
	generation and installation of default 'ejudge-install.sh' is added.

	* super_html_4.c:
	'S_ERR_TOO_MANY_MEMBERS' error code is added.

	* super_html_6.c:
	(super_serve_op_USER_CREATE_MEMBER_ACTION) new function.

2011-05-09 (r6325) Alexander Chernov  <cher@ejudge.ru>

	* lang_config_vis.h: copyright notice is updated;
	(lang_configure_screen) 'batch_mode' parameter is added.

	* ejudge-configure-compilers.c:
	(visual_setup) call of 'lang_configure_screen' is updated.

	* ejudge-setup.c:
	(make_sha1_passwd) new function;
	(do_identity_menu) 'make_sha1_passwd' is called;
	(initialize_setting_var) mysql plugin is not enabled by default;
	workdisk is disabled by default;
	(do_preview_menu) call of 'lang_configure_screen' is updated;
	(generate_install_script) warning is added to the generated script;
	check for user is added to the generated script;
	(preview_install_script) call of 'lang_configure_screen' is updated;
	(save_install_script) 'batch_mode', 'output_name' parameters are added;
	(do_main_menu) call of 'save_install_script' is updated;
	(main) batch mode (-b) option is supported.

	* lang_config_vis.c:
	(lang_configure_screen) 'batch_mode' parameter is added.

2011-05-08 (r6323) Alexander Chernov  <cher@ejudge.ru>

	* mischtml.h: copyright notice is updated;
	(html_input_text_js) new function prototype.

	* compile.c:
	default log file name is changed to 'ej-compile.log'.

	* ejudge-setup.c:
	default log file names are changed to 'ej-users.log'
	and 'ej-super-server.log' for the respective programs.

	* html_input_text.c: copyright notice is updated;
	(html_input_text_js) new function.

	* job-server.c:
	default log file name is changed to 'ej-jobs.log'.

	* new-server.c:
	default log file name is changed to 'ej-contests.log'.

	* super_html.c:
	some obsoleted code is removed;
	default ej-run log file name is changed to 'ej-run-messages.log'.

	* super_html_6.c: progress...

	* super-serve.c:
	default ej-run log file name is changed to 'ej-run-messages.log'.

2011-05-08 (r6316) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	'userlist_clnt/get_prev_user_id.c' is added.

	* userlist_clnt.h:
	(userlist_clnt_get_prev_user_id) new function prototype.

2011-05-08 (r6314) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h: progress...

	* uldb_plugin.h:
	(struct uldb_plugin_iface) new member functions: 'get_prev_user_id',
	  'get_next_user_id'.

	* userlist_proto.h:
	new commands added: ULS_PREV_USER, ULS_NEXT_USER;
	(struct userlist_pk_list_users_2) 'user_id' field is added.

	* super_html_4.c, super_html_6.c: progress...

	* uldb_plugin_xml.c:
	(get_prev_user_id_func) new function;
	(get_next_user_id_func) new function.

	* userlist.c:
	more prime numbers are added.

	* userlist-server.c:
	(cmd_next_user) new function;
	ULS_PREV_USER, ULS_NEXT_USER requests are handled.

2011-05-04 (r6302) Alexander Chernov  <cher@ejudge.ru>

	* meta.make:
	metainfo for ss_op_param_USER_CREATE_MANY_ACTION is generated.

	* ej_types.h:
	'ej_int_opt_m1_t' is added.

	* super_html.h:
	new error codes are added.

	* super_html_6.h:
	(struct ss_op_param_USER_CREATE_MANY_ACTION) new structure added.

	* super_html_4.c, super_html_6.c: progress...

2011-05-02 (r6294) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	check for -m32 and -m64 options is added.

2011-05-01 (r6290) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	userlist_clnt/create_user_2.c is added.

	* super_html.h: new error codes are added.

	* uldb_plugin.h:
	(struct uldb_plugin_iface::new_user) the following new parameters
	are added:
	'passwd_method', 'is_privileged', 'is_invisible', 'is_banned',
	'is_locked', 'show_login', 'show_email', 'read_only',
	'never_clean';
	(struct uldb_plugin_iface::register_contest) new parameter 'flags'
	is added.

	* userlist_clnt.h:
	(userlist_clnt_create_user_2) new function prototype.

	* userlist_proto.h:
	new command 'ULS_CREATE_USER_2' is added;
	(struct userlist_pk_create_user_2) new packet structure.

	* super_html_4.c: new error codes are added.

	* super_html_6.c: progress...

	* uldb_plugin_xml.c:
	(new_user_func) many parameters are added;
	(register_contest_func) parameter 'flags' is added.

	* userlist-server.c:
	(check_pk_create_user_2) new function;
	(send_registration_email) new function;
	use of 'new_user' DB method is changed;
	use of 'register_contest' DB method is changed;
	(cmd_create_user_2) new function.

2011-04-30 (r6286) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	'super_html_6_meta' is added;
	metainfo generation is moved to a separater 'meta.make' file.

	* meta.make: initial revision.

	* ej_types.h:
	new typedef for CGI param parsing generator are added.

	* meta_generic.h: copyright notice is updated;
	(struct meta_methods) new fields 'last_tag', 'size' are added;
	(meta_destroy_fields) new function prototype.

	* super_html.h: error codes are renamed.

	* super_html_6.h: initial revision

	* meta_generic.c:
	(meta_destroy_fields) new function.

	* super_html_4.c, super_html_6.c: progress...

2011-04-30 (r6284) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	'install_ej_super_server' rule is added;
	'-rdynamic' options is added for ej-super-server.

	* super_html.h:
	'super_serve_op_*' function prototypes are removed as they are
	linked dynamically.

	* super_proto.h:
	some operations are renamed.

	* userlist_proto.h:
	new commands are added:
	ULS_PRIV_SET_REG_PASSWD_PLAIN,
	ULS_PRIV_SET_REG_PASSWD_SHA1,
	ULS_PRIV_SET_CNTS_PASSWD_PLAIN,
	ULS_PRIV_SET_CNTS_PASSWD_SHA1.

	* super_html.c:
	some operations are renamed.

	* super_html_4.c:
	(do_http_request) dynamic symbol lookup is implemented instead of
	static function table.

	* super_html_6.c: progress...

	* userlist-server.c:
	(cmd_priv_set_passwd_2) new function to handle the new commands.

2011-04-28 (r6273) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	rules for generation of the contest-1 archive file are added.

	* ejudge-setup.c:
	(generate_serve_cfg) 'advanced_layout' is enabled;
	statement file name is 'statement.xml';
	checker file name is 'checker';
	(generate_contest_xml) default access permissions
	are changed to "enable from all";
	the uuencoded contest-1 archive is taken from an external file.

2011-04-27 (r6271) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	style/sprintf.js is added.

	* super_html.h:
	(super_serve_op_user_create_one_page) new function prototype;
	(super_serve_op_user_create_many_page) new function prototype;
	(super_serve_op_user_create_from_csv_page) new function prototype.

	* super_proto.h:
	new operations are added:
	SSERV_OP_USER_CREATE_ONE_ACTION,
	SSERV_OP_USER_CREATE_MANY_ACTION,
	SSERV_OP_USER_CREATE_FROM_CSV_PAGE,
	SSERV_OP_USER_CREATE_FROM_CSV_ACTION.

	* super_html_4.c, super_html_6.c: in progress...

2011-04-25 (r6267) Alexander Chernov  <cher@ejudge.ru>

	* super_html.h:
	(super_serve_op_user_password_page) new function prototype;
	(super_serve_op_user_cnts_password_page) new function prototype;
	(super_serve_op_user_create_reg_page) new function prototype;
	(super_serve_op_user_edit_reg_page) new function prototype;
	(super_serve_op_user_delete_reg_page) new function prototype.

	* super_proto.h:
	new operations are added:
	SSERV_OP_USER_CREATE_ONE_PAGE,
	SSERV_OP_USER_CREATE_MANY_PAGE,
	SSERV_OP_USER_CHANGE_PASSWORD_ACTION,
	SSERV_OP_USER_CNTS_PASSWORD_PAGE,
	SSERV_OP_USER_CHANGE_CNTS_PASSWORD_ACTION,
	SSERV_OP_USER_CREATE_REG_ACTION,
	SSERV_OP_USER_EDIT_REG_ACTION,
	SSERV_OP_USER_DELETE_REG_ACTION.

	* super_html_4.c, super_html_6.c: progress...

2011-04-24 (r6265) Alexander Chernov  <cher@ejudge.ru>

	* super_html.h:
	(ss_cgi_param_int_opt) new function prototype;
	(super_serve_op_user_detail_page) new function prototype.

	* super_proto.h: new operations are added.

	* super_html.c, super_html_4.c, super_html_6.c: progress...

2011-04-22 (r6263) Alexander Chernov  <cher@ejudge.ru>

	* super_html.h:
	(super_serve_op_browse_groups) new function prototype;
	(super_serve_op_set_group_filter) new function prototype.

	* super_proto.h:
	new operations are added.

	* super-serve.h:
	(struct sid_state) new fields are added.

	* uldb_plugin.h:
	(get_brief_list_iterator_2) 'group_id' parameter is added;
	(get_user_count) 'group_id' parameter is added;
	(get_group_iterator_2) new method;
	(get_group_count) new method.

	* userlist_clnt.h:
	(userlist_clnt_list_users_2) 'group_id' parameter is added;
	(userlist_clnt_get_count) 'group_id' parameter is added.

	* userlist_proto.h:
	new requests 'ULS_LIST_ALL_GROUPS_2', 'ULS_GET_GROUP_COUNT'
	are added;
	(struct userlist_pk_list_users_2) 'group_id' field is added.

	* super_html.c:
	"Group editor" link is added to the main page.

	* super_html_4.c, super_html_6.c: in progress...

	* uldb_plugin_xml.c:
	(get_brief_list_iterator_2_func) 'group_id' parameter is added;
	(get_user_count_func) 'group_id' parameter is added;
	(get_group_iterator_2_func) new function;
	(get_group_count_func) new function.

	* userlist.c:
	protection against cpu_frequency == 0 is added.

	* userlist-server.c:
	protection against cpu_frequency == 0 is added;
	(cmd_list_all_users_2) 'group_id' field is handled;
	(cmd_get_user_count) 'group_id' field is handled;
	(cmd_list_all_groups_2) new function;
	(cmd_get_group_count) new function.

2011-04-21 (r6256) Alexander Chernov  <cher@ejudge.ru>

	* super_html.h:
	(ss_cgi_param_int) function prototype is added.

	* super_html_4.c:
	(ss_cgi_param_int) the function is made non-static.

	* super_html_6.c: in progress...

	* userlist-server.c:
	(cmd_get_user_count) the count is logged.

2011-04-20 (r6255) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	'userlist_clnt/get_count.c' is added.

	* super_html.h:
	(super_serve_op_set_user_filter) new function prototype.

	* uldb_plugin.h:
	(struct uldb_plugin_iface) new member function 'get_user_count'
	is added.

	* userlist_clnt.h:
	(userlist_clnt_get_count) new function prototype.

	* userlist_proto.h:
	'ULS_GET_USER_COUNT' request code is added;
	'ULS_COUNT' reply code is added;
	(struct userlist_pk_count) new reply packet.

	* super_html_4.c: new opcodes are added;
	(do_http_request) 'op_'-prefixed opcodes are handled.

	* super_html_6.c: ...progress...

	* uldb_plugin_xml.c:
	(get_user_count_func) new function.

	* userlist-server.c:
	(cmd_get_user_count) new function;
	'ULS_GET_USER_COUNT' request is handled.

2011-04-19 (r6251) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	userlist_clnt/list_users_2.c is added;
	super_html_6.c is added.

	* super_html.h: copyright notice is updated;
	(super_serve_op_browse_users) new function prototype.

	* super_proto.h: new operations are added:
	SSERV_OP_BROWSE_USERS, SSERV_OP_CHANGE_USER_FILTER,
	SSERV_OP_USER_FILTER_FIRST_PAGE, SSERV_OP_USER_FILTER_PREV_PAGE,
	SSERV_OP_USER_FILTER_NEXT_PAGE, SSERV_OP_USER_FILTER_LAST_PAGE.

	* super-serve.h: copyright notice is updated;
	(struct sid_state) new fields 'user_filter_set', 'user_filter',
	'user_offset', 'user_count' are added;
	(struct http_request_info) field 'userlist_clnt' is added.

	* uldb_plugin.h: copyright notice is updated;
	(struct uldb_plugin_iface) 'get_brief_list_iterator_2' member
	function is added.

	* userlist_clnt.h: copyright notice is added;
	(userlist_clnt_list_users_2) new function prototype.

	* userlist_proto.h: copyright notice is updated;
	'ULS_LIST_ALL_USERS_2' command is added;
	(struct userlist_pk_list_users_2) new struct is added.

	* super_html.c:
	(super_html_main_page) "User editor" link is added.

	* super_html_4.c:
	SSERV_OP_BROWSE_USERS request is handled.

	* super_html_6.c: initial revision.

	* super-serve.c:
	(sid_state_clear) 'user_filter' is freed;
	(cmd_http_request) 'userlist_clnt' is added to the request structure.

	* uldb_plugin_xml.c:
	(get_brief_list_iterator_2_func) new function.

	* userlist-server.c:
	(check_pk_list_users_2) new function;
	(cmd_list_all_users_2) new function.

2011-04-15 (r6247) Alexander Chernov  <cher@ejudge.ru>

	* super_html_3.c:
	(super_html_lang_cmd) 'size_str_to_size_t' is used;
	(num_suffix) function is removed.

2011-04-15 (r6246) Alexander Chernov  <cher@ejudge.ru>

	* misctext.h:
	(size_str_to_num) new function prototype;
	(size_str_to_size_t) new function prototype.

	* misctext.c:
	<errno.h> is included;
	(size_str_to_num) new function;
	(size_str_to_size_t) new function.

	* parsecfg.c:
	"misctext.h" is included;
	(num_suffix) function is removed;
	(copy_param) 'size_str_to_num', 'size_str_to_size_t' are used.

	* prepare_out.c:
	(num_to_size) function is removed;
	(size_t_to_size) function is removed;
	'num_to_size_str' is used instead of 'num_to_size';
	'size_t_to_size_str' is used instead of 'size_t_to_size'.

	* super_html_3.c:
	(super_html_global_param) 'size_str_to_size_t' is used;
	(super_html_prob_param) 'size_str_to_size_t' is used;

2011-04-10 (r6242) Alexander Chernov  <cher@ejudge.ru>

	* super_html.c:
	(super_html_main_page) serve status reporting column is removed.

2011-04-09 (r6240) Alexander Chernov  <cher@ejudge.ru>

	* super_html.c, super_html_3.c:
	Help links to the wiki pages are added.

2011-04-08 (r6238) Alexander Chernov  <cher@ejudge.ru>

	* run.c:
	x86_64 fixes

2011-04-08 (r6237) Alexander Chernov  <cher@ejudge.ru>

	* misctext.c:
	x86_64 fixes

2011-04-08 (r6236) Alexander Chernov  <cher@ejudge.ru>

	* fix-db.c:
	x86_64 fixes

2011-04-08 (r6235) Alexander Chernov  <cher@ejudge.ru>

	* super_html_4.c:
	x86_64 fixes

2011-04-07 (r6231) Alexander Chernov  <cher@ejudge.ru>

	* misctext.c:
	(html_print_by_line) incorrect UTF8 validity check is fixed.

2011-04-07 (r6229) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c:
	(set_defaults)
	if language-specific 'style_checker_cmd' is not an absolute path
	and does not start with '@', global standard checker directory
	path is prepended to it.

	* serve_2.c:
	(serve_compile_request) language-specified 'style_checker_cmd'
	is properly expanded.

2011-04-04 (r6226) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.win32.in:
	reuse library dependency is removed;
	libcommon.a is linked twice, if necessary.

2011-04-01 (r6214) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) new fields 'compile_max_vm_size',
	'compile_max_stack_size', 'compile_max_file_size' are added.

	* super_proto.h:
	editing of the 'compile_max_vm_size', 'compile_max_stack_size',
	'compile_max_file_size' global configuration variables
	is supported.

	* compile.c:
	(do_loop) global configuration variables
	'compile_max_vm_size', 'compile_max_stack_size',
	'compile_max_file_size' are handled.

	* html.c:
	(write_xml_team_testing_report) valuer comments are printed.

	* prepare.c:
	 new global configuration variables
	'compile_max_vm_size', 'compile_max_stack_size',
	'compile_max_file_size' are added.

	* prepare_out.c:
	(prepare_unparse_global) new global configuration variables
	'compile_max_vm_size', 'compile_max_stack_size',
	'compile_max_file_size' are supported;
	(prob_instr) xml_file path computation is improved.

	* serve_2.c:
	(serve_compile_request) global configuration variables
	'compile_max_vm_size', 'compile_max_stack_size',
	'compile_max_file_size' are handled.

	* serve-control.c, super_html_3.c, super-serve.c:
	editing of the 'compile_max_vm_size', 'compile_max_stack_size',
	'compile_max_file_size' global configuration variables
	is supported.

2011-03-31 (r6211) Alexander Chernov  <cher@ejudge.ru>

	* compile_packet.h:
	(struct compile_request_packet) 'max_file_size' field is added.

	* compile_packet_priv.h:
	(struct compile_request_bin_packet) 'max_file_size' field is added.

	* prepare.h:
	(struct section_problem_data) new fields 'max_file_size',
	'max_open_file_count', 'max_process_count' are added;
	(struct section_language_data) new field 'max_file_size'
	is added.

	* super_proto.h:
	editing of 'max_file_size' language configuration variable is supported
	editing of 'max_file_size', 'max_open_file_count', 'max_process_count'
	problem configuration variables is supported.

	* compile.c:
	'max_file_size' language configuration variable is supported.

	* compile_packet_1.c:
	(compile_request_packet_read) 'max_file_size' field is handled.

	* compile_packet_2.c:
	(compile_request_packet_write) 'max_file_size' field is handled.

	* prepare.c, prepare_out.c:
	'max_file_size' language configuration variable is supported;
	'max_file_size', 'max_open_file_count', 'max_process_count'
	problem configuration variables are supported.

	* run.c:
	(run_tests) 'max_file_size', 'max_open_file_count',
	'max_process_count' problem configuration variables are handled.

	* serve_2.c:
	(serve_compile_request) 'max_file_size' language configuration
	variable is handled.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of 'max_file_size' language configuration variable is supported
	editing of 'max_file_size', 'max_open_file_count', 'max_process_count'
	problem configuration variables is supported.

2011-03-31 (r6209) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'max_core_size' field is added.

	* super_proto.h:
	editing of the 'max_core_size' problem configuration variable
	is supported.

	* prepare.c, prepare_out.c:
	'max_core_size' problem configuration variable is added.

	* run.c:
	(run_tests) 'max_core_size' problem configuration variable is handled.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of the 'max_core_size' problem configuration variable
	is supported.

2011-03-30 (r6207) Alexander Chernov  <cher@ejudge.ru>

	* reuse_exec.h:
	(task_SetMaxProcCount) prototype is removed;
	(task_SetMaxCoreSize) new function prototype;
	(task_SetMaxFileSize) new function prototype;
	(task_SetMaxLockedMemorySize) new function prototype;
	(task_SetMaxMessageQueueSize) new function prototype;
	(task_SetMaxNiceValue) new function prototype;
	(task_SetMaxOpenFileCount) new function prototype;
	(task_SetMaxProcessCount) new function prototype;
	(task_SetMaxPrioValue) new function prototype;
	(task_SetMaxPendingCount) new function prototype.

	* nwrun.c:
	(run_program) 'task_SetMaxProcCount' is renamed
	to 'task_SetMaxProcessCount'.

2011-03-30 (r6204) Alexander Chernov  <cher@ejudge.ru>

	* run_packet_1.c:
	(run_request_packet_read) packet version is not checked for
	the QUIT packet.

2011-03-29 (r6200) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c:
	(ns_check_contest_events) 'finish_time' sanity checks are added.

	* serve.c:
	(main) 'finish_time' sanity checks are added.

	* serve_2.c:
	(serve_update_status_file) 'finish_time' sanity checks are added;
	(serve_reset_contest) the same.

	* serve_state.c:
	(serve_state_load_contest) 'finish_time' sanity checks are added.

	* super_html_3.c:
	(super_html_print_problem) "valuer_cmd" editing is improved.

2011-03-27 (r6195) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	(serve_compile_request) 'max_vm_size', 'max_stack_size' are passed to
	the compilation server.

2011-03-27 (r6194) Alexander Chernov  <cher@ejudge.ru>

	* compile_packet.h: copyright notice is updated;
	(struct compile_request_packet) new fields 'max_vm_size',
	'max_stack_size' are added.

	* compile_packet_priv.h:
	(struct compile_request_bin_packet) 'max_vm_size',
	'max_stack_size' fields are added.

	* prepare.h:
	(struct section_language_data) 'max_vm_size', 'max_stack_size'
	fields are added.

	* reuse_exec.h:
	(task_EnableProcessGroup) new function prototype.

	* super_proto.h:
	editing of the new 'max_vm_size', 'max_stack_size' language
	configuration variables is supported.

	* compile.c:
	compilation processes are started in separate process groups;
	'max_vm_size', 'max_stack_size' language configuration variables
	are supported.

	* compile_packet_1.c:
	(compile_request_packet_read) 'max_vm_size', 'max_stack_size'
	are read.

	* compile_packet_2.c:
	(compile_request_packet_write) 'max_vm_size', 'max_stack_size'
	are written.

	* prepare_out.c:
	(prepare_unparse_lang) new language configuration variables
	'max_vm_size', 'max_stack_size' are supported.

	* serve-control.c, super_html_3.c, super-serve.c:
	editing of the new 'max_vm_size', 'max_stack_size' language
	configuration variables is supported.

2011-03-27 (r6189) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	Reuse checking is removed.

2011-03-27 (r6187) Alexander Chernov  <cher@ejudge.ru>

	* config.h.in:
	reuse-specific feature macros are removed.

	* compile.c, execute.c, run.c:
	conditional compilation depending on the version of
	the reuse library is removed.

2011-03-27 (r6185) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in: dependencies from the reuse library are removed.

	* files.make:
	more reuse files are added.

	* filter_eval.c:
	"reuse_mempage.h" is included instead of <reuse/MemPage.h>.

	* filter_tree.c:
	"reuse_mempage.h" is included instead of <reuse/MemPage.h>.

	* serve.c:
	<reuse/number_io.h> is no longer included;
	<reuse/format_io.h> is no longer included.

	* sformat.c:
	<reuse/number_io.h> is no longer included;
	<reuse/format_io.h> is no longer included.
	'snprintf' is used instead of 'os_snprintf'.

	* run.c:
	<reuse/number_io.h> is no longer included;
	<reuse/format_io.h> is no longer included;
	'snprintf' is used instead of 'os_snprintf'.

	* tex_dom_parse.c:
	"reuse_hash.h" is insluded instead of <reuse/hash.h>.

	* userlist-server-control.c: copyright notice is updated;
	"reuse_osdeps.h" is included instead of <reuse/osdeps.h>.

2011-03-27 (r6184) Alexander Chernov  <cher@ejudge.ru>

	* reuse_hash.h, reuse_hash_priv.h, reuse_exec.h, reuse_mempage.h:
	Initial revision. Copied from the reuse library.

2011-03-27 (r6180) Alexander Chernov  <cher@ejudge.ru>

	* printing.c:
	copyright notice is updated;
	"reuse_exec.h" is included instead of <reuse/exec.h>.

2011-03-27 (r6179) Alexander Chernov  <cher@ejudge.ru>

	* serve.c:
	"reuse_exec.h" is included instead of <reuse/exec.h>.

2011-03-27 (r6178) Alexander Chernov  <cher@ejudge.ru>

	* nwrun.c, reports.c, run_inverse.c, ejudge-control.c, execute.c, run.c, serve_2.c, compile.c, diff.c:
	"reuse_exec.h" is included instead of <reuse/exec.h>.

2011-03-27 (r6176) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	more reuse files are added.

2011-03-27 (r6175) Alexander Chernov  <cher@ejudge.ru>

	* reuse_integral.h:
	Initial revision. Copied from the reuse library.

2011-03-27 (r6174) Alexander Chernov  <cher@ejudge.ru>

	* config.h.in, configure.ac:
	reuse features merged in.

2011-03-27 (r6173) Alexander Chernov  <cher@ejudge.ru>

	* compile_packet_priv.h, full_archive.h:
	copyright notice is updated;
	"reuse_integral.h" is included instead of <reuse/integral.h>.

2011-03-27 (r6172) Alexander Chernov  <cher@ejudge.ru>

	* sha.c, run_packet_1.c, run_packet_2.c, run_packet_3.c, run_packet_4.c, run_packet_5.c, run_packet_6.c, sha.h, ej_types.h, compile_packet_1.c, run_packet_priv.h, compile_packet_2.c, compile_packet_3.c, compile_packet_4.c, compile_packet_5.c, compile_packet_6.c, run.c:
	"reuse_integral.h" is included instead of <reuse/integral.h>.

2011-03-27 (r6167) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	more reuse files are added.

2011-03-27 (r6164) Alexander Chernov  <cher@ejudge.ru>

	* reuse_osdeps.h:
	Initial revision. Copied from the reuse library.

2011-03-27 (r6163) Alexander Chernov  <cher@ejudge.ru>

	* super-serve-control.c, mime_type.c:
	copyright notice is updated;
	"reuse_osdeps.h" is included instead of <reuse/osdeps.h>.

2011-03-27 (r6162) Alexander Chernov  <cher@ejudge.ru>

	* nwrun.c, contest_tmpl.c, userlist-server.c, super-serve.c, random.c, clean-users.c, cldb_plugin_file.c, ejudge-control.c, convert-clars.c, clarlog.c, contests_2.c, server_framework.c, uldb_plugin_xml.c, serve.c, new_server_html_2.c, nsdb_plugin_files.c, ej-ncheck.c, compile.c, team_extra.c, new-server.c, reports.c, users.c, serve-control.c, contests.c, new_server_html.c, super_html_2.c, super_html_3.c, convert-runs.c, compile-control.c, super_html_5.c, runlog.c, fix-db.c, new-server-control.c, ej-batch.c, job-server.c, master_html.c, archive_paths.c, pathutl.c, super_html.c, ejudge_cfg.c, serve_state.c, opcaps.c, prepare_out.c, vcs.c, job-server-control.c, teamdb.c, edit-userlist.c, prepare.c, new-server-cmd.c, clntutil.c, run_inverse.c, runlog_import.c, nwrun_packet.c, rldb_plugin_file.c, ejudge-setup.c, ncurses_utils.c, run.c, html.c, serve_2.c, new-client.c:
	"reuse_osdeps.h" is included instead of <reuse/osdeps.h>.

2011-03-26 (r6151) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in: copyright notice is updated;
	rule for libplatform.a updated.

	* files.make:
	PLATFORM_CFILES definition is added;
	reuse_logger.c is added.

2011-03-26 (r6148) Alexander Chernov  <cher@ejudge.ru>

	* reuse_logger.h:
	initial revision: copies from the reuse library

2011-03-26 (r6147) Alexander Chernov  <cher@ejudge.ru>

	* filter_expr.y, filter_eval.c, job-server-control.c, files.make, digest_1.c, archive_paths.c, digest_2.c, random.c, digest_3.c, ejudge-control.c, digest_4.c, digest_5.c, base64.c, html_start_form.c, userlist_check.c:
	copyright notice is updated;
	"reuse_logger.h" is used instead of <reuse/logger.h>.

2011-03-26 (r6146) Alexander Chernov  <cher@ejudge.ru>

	* team_extra_xml.c, userlist.c, contest_tmpl.c, run_packet_2.c, run_packet_4.c, run_packet_6.c, super-serve.c, clarlog.c, contests_2.c, uldb_plugin_xml.c, serve.c, new_server_html_2.c, nsdb_plugin_files.c, new_server_html_4.c, team_extra.c, compile_packet_1.c, compile_packet_3.c, serve-control.c, compile_packet_5.c, new_server_html.c, super_html_3.c, t3m_dir_listener.c, charsets.c, ej-batch.c, pathutl.c, super_html.c, meta_generic.c, tex_dom_doc.c, serve_state.c, prepare_out.c, testing_report_xml.c, tex_dom_parse.c, errlog.c, tex_dom_render.c, prepare.c, rldb_plugin_file.c, runlog_import.c, ejudge-setup.c, ncurses_utils.c, serve_2.c, t3m_submits.c, run_packet_1.c, run_packet_3.c, userlist-server.c, run_packet_5.c, cldb_plugin_file.c, server_framework.c, filehash.c, runlog_xml.c, new_server_html_5.c, compile.c, parsecfg.c, tex_dom.c, compile_packet_2.c, misctext.c, users.c, contests.c, compile_packet_4.c, dos2unix_str.c, super_html_2.c, filter_tree.c, compile_packet_6.c, super_html_4.c, runlog.c, compile-control.c, problem_common.c, expat_iface.c, varsubst.c, fix-db.c, job-server.c, master_html.c, ejudge_cfg.c, opcaps.c, lang_config_vis.c, userlist_xml.c, vcs.c, teamdb.c, edit-userlist.c, new-server-cmd.c, clntutil.c, run_inverse.c, protocol.c, run.c, html.c, new-client.c:
	"reuse_logger.h" is used instead of <reuse/logger.h>.

2011-03-26 (r6137) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	"reuse_xalloc.h" is included instead of <reuse/xalloc.h>.

2011-03-26 (r6136) Alexander Chernov  <cher@ejudge.ru>

	* run_packet_1.c, run_packet_2.c, run_packet_4.c, run_packet_5.c, super-serve.c, serve_state.c, new_server_html_2.c, prepare_out.c, new_server_html_4.c, testing_report_xml.c, prepare.c, run_inverse.c, rldb_plugin_file.c, serve-control.c, new_server_html.c, super_html_3.c, html.c, run.c, super_html_4.c, runlog.c, copyright.c:
	"reuse_xalloc.h" is included instead of <reuse/xalloc.h>.

2011-03-26 (r6135) Alexander Chernov  <cher@ejudge.ru>

	* team_extra_xml.c, nwrun.c, userlist.c, send_job_packet.c, contest_tmpl.c, run_packet_6.c, problem_xml.c, clean-users.c, allowed_list.c, clarlog.c, contests_2.c, serve.c, uldb_plugin_xml.c, nsdb_plugin_files.c, team_extra.c, new-server.c, compile_packet_1.c, compile_packet_3.c, execute.c, compile_packet_5.c, convert-runs.c, t3m_dir_listener.c, super_html_5.c, new-server-control.c, charsets.c, ej-batch.c, watched_file.c, super_proto.c, pathutl.c, super_html.c, ncheck_packet.c, zip_utils.c, meta_generic.c, tex_dom_doc.c, tex_dom_parse.c, errlog.c, csv.c, collect-emails.c, tex_dom_render.c, plugin.c, runlog_import.c, ejudge-setup.c, prepare_serve.c, ncurses_utils.c, problem_plugin_impl.h, diff.c, t3m_submits.c, ejudge-configure-compilers.c, run_packet_3.c, userlist-server.c, shellcfg_parse.c, run_packet_7.c, cldb_plugin_file.c, stringset.c, convert-clars.c, filehash.c, server_framework.c, runlog_xml.c, ej-ncheck.c, new_server_html_5.c, compile.c, parsecfg.c, reports.c, tex_dom.c, compile_packet_2.c, misctext.c, t3m_zip_packet_class.c, users.c, contests.c, compile_packet_4.c, cgi.c, super_html_2.c, dos2unix_str.c, compile_packet_6.c, filter_tree.c, compile-control.c, slice-userlist.c, expat_iface.c, varsubst.c, fix-db.c, sformat.c, job-server.c, master_html.c, ejudge_cfg.c, opcaps.c, lang_config_vis.c, userlist_xml.c, vcs.c, teamdb.c, edit-userlist.c, new-server-cmd.c, clntutil.c, t3_packets.c, nwrun_packet.c, protocol.c, new-client.c, common_plugin.c:
	copyright notice is updated;
	"reuse_xalloc.h" is included instead of <reuse/xalloc.h>.

2011-03-26 (r6124) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	some files copied from the reuse library are added.

2011-03-26 (r6123) Alexander Chernov  <cher@ejudge.ru>

	* reuse_xalloc.h:
	initial revision: copied from the reuse library

2011-03-24 (r6119) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_write_priv_all_runs) crash in case of removed problems is fixed.

2011-03-17 (r6116) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h: copyright notice is updated;
	new actions 'ADMIN_CONTEST_SETTINGS',
	'ADMIN_CHANGE_ONLINE_VIEW_SOURCE',
	'ADMIN_CHANGE_ONLINE_VIEW_REPORT',
	'ADMIN_CHANGE_ONLINE_VIEW_JUDGE_SCORE',
	'ADMIN_CHANGE_ONLINE_FINAL_VISIBILITY'
	are added;
	(ns_write_admin_contest_settings) new function prototype.

	* protocol.h:
	(struct prot_serve_status_v2) new fields 'online_view_source',
	'online_view_report', 'online_view_judge_score',
	'online_final_visibility' are added.

	* serve_state.h:
	(struct serve_state) new fields 'online_view_source',
	'online_view_report', 'online_view_judge_score',
	'online_final_visibility' are added.

	* html.c:
	(write_html_run_status) 'online_view_judge_score' is handled;
	(write_text_run_status) the same as above;
	(new_write_user_runs) 'online_view_report', 'online_view_source',
	'online_view_judge_score' are handled;
	(do_write_kirov_standings) the same as above;
	(do_write_public_log) the same as above;
	(write_xml_team_testing_report) 'online_view_judge_score',
	'online_final_visibility' are supported.

	* new_server_html.c:
	(priv_contest_operation) new commands 'ADMIN_CHANGE_ONLINE_VIEW_SOURCE'
	'ADMIN_CHANGE_ONLINE_VIEW_REPORT',
	'ADMIN_CHANGE_ONLINE_VIEW_JUDGE_SCORE',
	'ADMIN_CHANGE_ONLINE_FINAL_VISIBILITY' are handled;
	(priv_clear_run) 'team_enable_rep_view', 'enable_full_archive'
	global configuration variables are disregarded;
	(priv_admin_contest_settings) new function to display the
	"Contest settings" page;
	(priv_main_page) link to "Contest settings" page is added;
	online option values are shown;
	(unpriv_view_source) 'online_view_source' is supported;
	(unpriv_view_test) 'online_view_report' is supported;
	(unpriv_view_report) 'online_view_report' is supported.

	* new_server_html_2.c:
	(ns_write_olympiads_user_runs) 'online_view_source',
	'online_view_report' are supported;
	(ns_get_user_problems_summary) 'online_view_judge_score'
	is supported;
	(ns_write_user_problems_summary) the same as above;
	(ns_write_admin_contest_settings) new function to generate
	the "Contest settings" page.

	* new_server_tables.c: copyright notice is updated;
	actions 'ADMIN_CHANGE_ONLINE_VIEW_SOURCE'
	'ADMIN_CHANGE_ONLINE_VIEW_REPORT',
	'ADMIN_CHANGE_ONLINE_VIEW_JUDGE_SCORE',
	'ADMIN_CHANGE_ONLINE_FINAL_VISIBILITY'
	are supported.

	* serve_2.c:
	(serve_update_status_file) new fields 'online_view_source',
	'online_view_report', 'online_view_judge_score',
	'online_final_visibility' are saved;
	(serve_load_status_file) new fields (see above) are restored;
	(serve_move_files_to_insert_run) 'team_enable_rep_view',
	'enable_full_archive' global configuration variables are
	disregarded;
	(serve_squeeze_runs) the same as above;
	(serve_clear_by_mask) the same as above;
	(serve_ignore_by_mask) the same as above.

2011-03-15 (r6115) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'final_open_tests' field is added;
	final_open_tests_count, final_open_tests_val fields are added;
	(cntsprob_get_test_visibility) 'final_mode' parameter is added.

	* super_proto.h:
	editing of 'final_open_tests' is supported.

	* html.c:
	(write_xml_team_testing_report) call of 'cntsprob_get_test_visibility'
	are updated.

	* prepare.c:
	'final_open_tests' problem configuration variable is added;
	(cntsprob_get_test_visibility) 'final_mode' parameter is added.

	* prepare_out.c:
	(prepare_unparse_prob) 'final_open_tests' is handled.

	* run.c:
	(run_tests) call of 'cntsprob_get_test_visibility' updated.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of 'final_open_tests' is supported.

2011-03-15 (r6113) Alexander Chernov  <cher@ejudge.ru>

	* protocol.h, serve_state.h:
	fields are renamed: 'upsolving_' prefix is added to 'freeze_standings',
	'view_source', 'view_protocol', 'full_protocol', 'disable_clars'.

	* new_server_html.c, serve_2.c, serve_state.c:
	fields are renamed: 'upsolving_' prefix is added to 'freeze_standings',
	'view_source', 'view_protocol', 'full_protocol', 'disable_clars'.

2011-03-14 (r6111) Alexander Chernov  <cher@ejudge.ru>

	* html.h:
	(write_xml_team_testing_report) 'is_marked' parameter is added.

	* super_proto.h:
	editing of 'score_latest_or_unmarked' problem configuration variable
	is implemented.

	* html.c:
	(do_write_kirov_standings) 'score_latest_or_unmarked' problem
	configuration variable is handled;
	(do_write_public_log) the same as above;
	(write_xml_team_testing_report) visibility "fullifmarked"
	is supported.

	* new_server_html.c:
	(unpriv_view_report) call of 'write_xml_team_testing_report' updated.

	* prepare_out.c:
	(prepare_unparse_global) 'separate_user_score' is unparsed;
	(prepare_unparse_prob) 'score_latest_or_unmarked' is unparsed;
	(generate_abstract_tester) 'skip_testing' is unparsed.

	* problem_common.c:
	"fullifmarked" visibility is added.

	* run.c:
	(invoke_valuer) visibility is not printed to the valuer input stream;
	(do_loop) 'skip_testing' configuration variable is handled correctly
	for 'any' testers;
	(check_config) 'skip_arch' option is handled;
	(main) '-s ARCH' option is added to specify architectures which are
	to be skipped in this instance of 'ej-run' program.

	* serve_2.c:
	(serve_read_run_packet) 'user_tests_passed' are adjusted for storing
	to the database.

	* super-serve.c:
	editing of 'score_latest_or_unmarked' problem configuration variable
	is implemented.

2011-03-05 (r6109) Alexander Chernov  <cher@ejudge.ru>

	* testing_report_xml.h:
	(struct testing_report_xml) 'user_run_tests' field is added.

	* html.c:
	(write_xml_team_testing_report) separate_user_score mode
	is supported.

	* run.c:
	(generate_xml_report) 'user_max_score', 'user_run_tests'
	parameters are added.
	(run_tests) 'user_run_tests' is supported.

	* serve_2.c:
	(serve_run_request) 'separate_user_score' is passed.

	* testing_report_xml.c:
	"user_run_tests" attribute is handled.

2011-03-04 (r6107) Alexander Chernov  <cher@ejudge.ru>

	* html.h: copyright notice is updated;
	(write_standings) 'user_mode' parameter is added;
	(write_public_log) 'user_mode' parameter is added;
	(do_write_kirov_standings) 'user_mode' parameter is added;
	(calc_kirov_score) 'separate_user_score' parameter is added;
	'user_mode' parameter is added;
	(write_html_run_status) 'user_mode' parameter is added;
	(write_text_run_status) 'user_mode' parameter is added.

	* html.c:
	(calc_kirov_score) 'separate_user_score' mode is supported;
	(write_html_run_status) 'separate_user_score' mode is supported;
	(write_text_run_status) 'separate_user_score' mode is supported;
	(new_write_user_runs) 'separate_user_score' mode is supported;
	(do_write_kirov_standings) 'separate_user_score' mode is supported;
	(write_standings) 'separate_user_score' mode is supported;
	(do_write_public_log) 'separate_user_score' mode is supported;
	(write_public_log) 'separate_user_score' mode is supported.

	* new_server_html.c:
	(unpriv_view_standings) 'separate_user_score' mode is supported.

	* new_server_html_2.c:
	(ns_write_priv_all_runs) call of 'write_html_run_status' updated;
	(ns_write_priv_standings) call of 'do_write_kirov_standings' updated;
	(ns_write_user_run_status) call of 'write_text_run_status' updated;
	(ns_get_user_problems_summary) separate_user_score mode supported.

	* new_server_html_4.c:
	(do_dump_master_runs) 'calc_kirov_score' call is updated.

	* serve_2.c:
	(serve_update_standings_file) 'separate_user_score' mode
	is supported;
	(serve_update_public_log_file) 'separate_user_score' mode
	is supported.

2011-03-04 (r6106) Alexander Chernov  <cher@ejudge.ru>

	* prepare_out.c:
	missed \n is added.

2011-03-01 (r6103) Alexander Chernov  <cher@ejudge.ru>

	* rldb_plugin.h:
	(struct rldb_plugin_iface) 'change_status_4' field is added.

	* runlog.h: copyright notice is updated;
	(run_change_status_3) new function prototype;
	(run_change_status_4) new function prototype.

	* run_packet.h:
	(struct run_reply_packet) 'has_user_score' field is added.

	* run_packet_priv.h:
	FLAGS_HAS_USER_SCORE is added.

	* new_server_html.c: copyright notice is updated;
	separate_user_score mode is supported.

	* new_server_html_4.c: copyright notice is updated;
	separate_user_score mode is supported.

	* rldb_plugin_file.c:
	(change_status_4_func) new function.

	* runlog.c:
	(run_change_status_3) new function;
	(run_change_status_4) new function.

	* run_packet_4.c:
	(run_reply_packet_read) 'has_user_score' is supported.

	* run_packet_5.c:
	(run_reply_packet_write) 'has_user_score' is supported.

	* serve_2.c: copyright notice is updated;
	separate_user_score mode is supported.

2011-02-28 (r6100) Alexander Chernov  <cher@ejudge.ru>

	* rldb_plugin.h: copyright notice is updated;
	(struct rldb_plugin_iface) new member 'change_status_3' is added.

	* rldb_plugin_file.c: copyright notice is updated;
	(change_status_3_func) new member function is implemented.

	* run.c:
	(read_valuer_score) 'p_user_tests_passed' parameter is added;
	'user_tests_passed' is read from the valuer output;
	(invoke_valuer) 'p_user_tests_passed' parameter is added;
	(run_tests) full_user_score is handled in separate_user_score mode;
	user_tests_passed is received from the valuer output.

2011-02-27 (r6097) Alexander Chernov  <cher@ejudge.ru>

	* testing_report_xml.h:
	"user-failed-test" attribute is removed.

	* run_packet.h:
	(struct run_reply_packet) 'user_failed_test'->'user_tests_passed'.

	* run_packet_priv.h:
	(struct run_reply_bin_packet) 'user_failed_test'->'user_tests_passed'.

	* run.c:
	basic support for separate user scoring is implemented.

	* run_packet_4.c, run_packet_5.c, run_inverse.c:
	'user_failed_test'->'user_tests_passed'.

	* testing_report_xml.c:
	"user-failed-test" attribute is removed.

2011-02-27 (r6093) Alexander Chernov  <cher@ejudge.ru>

	* ej_types.h:
	(test_visibility_unparse) new function prototype.

	* problem_common.c:
	(test_visibility_unparse) new function.

	* run.c:
	(struct testinfo) 'visibility' field is added;
	(generate_xml_report) 'visibility' is unparsed;
	(run_tests) 'visibility' is initialized.

2011-02-27 (r6091) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c:
	'full_user_score' problem variable is added.

	* prepare_out.c: copyright notice is updated;
	(prepare_unparse_prob) 'full_user_score' is handled.

	* serve-control.c, super_html_3.c, super-serve.c:
	editing of the new 'full_user_score' problem variable is supported.

2011-02-27 (r6089) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) new field 'full_user_score'.

	* super_proto.h:
	editing of the new 'full_user_score' problem variable is supported.

2011-02-27 (r6086) Alexander Chernov  <cher@ejudge.ru>

	* runlog.c: copyright notice is updated;
	(run_get_attempts) RUN_STYLE_ERR is not counted as an attempt.

2011-02-27 (r6082) Alexander Chernov  <cher@ejudge.ru>

	* html.c:
	(write_xml_team_testing_report) 'cntsprob_get_test_visibility'
	function is used.

	* prepare.c:
	(cntsprob_get_test_visibility) new function.

2011-02-27 (r6081) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(cntsprob_get_test_visibility) new function prototype.

2011-02-27 (r6079) Alexander Chernov  <cher@ejudge.ru>

	* ej_types.h:
	(test_visibility_parse_mem) new function prototype.

	* html.c: copyright notice is updated;
	(write_xml_team_testing_report) new visibility conception is supported.

	* prepare.c: copyright notice is updated;
	'separate_user_score' global variable is added;
	(prepare_parse_open_tests) rewritten to support visibility concept.

	* problem_common.c:
	(test_visibility_parse_mem) new function.

	* run.c: copyright notice is updated;
	(do_loop) user scores in the reply packet are filled up with the
	default values.

	* run_inverse.c: copyright notice is updated;
	(run_inverse_testing) user scores in the reply packet are filled up
	with the default values.

2011-02-27 (r6078) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h: copyright notice is updated;
	(struct section_global_data) 'separate_user_score' field is added.

2011-02-24 (r6077) Alexander Chernov  <cher@ejudge.ru>

	* run_packet.h: copyright notice is updated;
	(struct run_request_packet) 'separate_user_score' field is added;
	(struct run_reply_packet) 'user_status', 'user_failed_test',
	'user_score' fields are added.

	* run_packet_priv.h: copyright notice is updated;
	FLAGS_SEPARATE_USER_SCORE is added;
	(struct run_reply_bin_packet) new fields 'user_status',
	'user_failed_test', 'user_score' are added.

	* run_packet_1.c, run_packet_2.c: copyright notice is updated;
	'separate_user_score' field is supported.

	* run_packet_4.c, run_packet_5.c: copyright notice is updated;
	'user_status', 'user_failed_test', 'user_score' fields
	are supported.

2011-02-24 (r6076) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h: copyright notice is updated;
	editing of 'separate_user_score' global configuration variable is
	supported.

	* serve-control.c, super_html_3.c, super-serve.c: copyright notice is updated;
	editing of 'separate_user_score' global configuration variable is
	supported.

2011-02-24 (r6075) Alexander Chernov  <cher@ejudge.ru>

	* copyright.c: copyright notice is updated.

2011-02-23 (r6073) Alexander Chernov  <cher@ejudge.ru>

	* files.make: copyright notice is updated;
	'style_c.c' is added.

	* style_c.c: new file.

2011-02-23 (r6072) Alexander Chernov  <cher@ejudge.ru>

	* ej_types.h: copyright notice is updated;
	(enum test_visibility) new enumerated constants;
	(test_visibility_parse) new function prototype.

	* testing_report_xml.h: copyright notice is updated;
	new attribute "visibility" of the test description element <test>
	is supported;
	new attributes "user-status", "user-failed-test", "user-tests-passed",
	"user-score", "user-max-score" of the report element <testing-report>
	are supported.

	* problem_common.c: copyright notice is updated;
	"ej_types.h" is included;
	(test_visibility_parse) new function.

	* testing_report_xml.c: copyright notice is updated;
	new attribute "visibility" of the test description element <test>
	is supported;
	new attributes "user-status", "user-failed-test", "user-tests-passed",
	"user-score", "user-max-score" of the report element <testing-report>
	are supported.

2010-12-01 (r6063) Alexander Chernov  <cher@ejudge.ru>

	* t3m_submits.c, t3m_submits.h, zip_utils.c, zip_utils.h:
	initial revision

2010-12-01 (r6062) Alexander Chernov  <cher@ejudge.ru>

	* files.make: new files added: 't3m_submits.[ch]', 'zip_utils.[ch]'.

	* serve_state.h:
	(serve_compile_request) 'no_db_flag' is added;
	(serve_run_request) 'contest_id', 'no_db_flag' are added.

	* expat_iface.c:
	(encoding_hnd) '@' is used instead of '?' for unknown characters
	  due to some weirdness of expat.

	* misctext.c:
	(html_print_by_line) do not allow characters not fitting UCS2 due to
	  weirdness of expat.

	* new_server_html.c, new_server_html_4.c:
	calls of 'serve_compile_request', 'serve_run_request' are updated.

	* serve_2.c:
	(serve_compile_request) 'no_db_flag' parameter is added;
	(serve_run_request) 'contest_id', 'no_db_flag' parameters added;

2010-11-29 (r6059) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	't3m_dir_listener.[ch]', 't3m_packet_class.h',
	't3m_zip_packet_class.c' are added.

	* expat_iface.c: copyright notice is updated;
	(encoding_hnd) fixing for Windows-1251 support.

	* misctext.c:
	(ucs2_to_utf8) conversion heuristic is relaxed a bit.

	* serve_state.c:
	(serve_state_load_contest) 'no_users_flag' is supported.

2010-11-22 (r6056) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	rules for ej-t3-mediator are changed.

	* serve_state.h:
	(serve_state_load_contest) 'no_users_flag' parameter is added.

	* new_server_html.c, new_server_html_4.c:
	calls of 'serve_compile_request' are updated.

	* serve_2.c:
	(serve_compile_request) 'contest_id' parameter is added;
	calls of 'serve_compile_request' are updated.

	* serve_state.c:
	(serve_state_load_contest) 'no_users_flag' parameter is added.

	* run.c:
	'scoring_checker' and 'valuer_cmd' works together;
	full_score check is relaxed if valuer_cmd is set.

2010-11-18 (r6053) Alexander Chernov  <cher@ejudge.ru>

	* runlog_static.c:
	(run_fix_runlog_time) time skew fixing is relaxed.

2010-11-18 (r6051) Alexander Chernov  <cher@ejudge.ru>

	* t3_packets.h:
	(struct t3_in_submit) 'prob_extid' field is added;
	  'mime_type' field is removed;
	  'gzipped' field is added.

	* ej-t3-mediator.c:
	protection if libzip is missing is added.

	* prepare.c:
	'extid' problem configuration variable is added.

	* prepare_out.c:
	(prepare_unparse_unhandled_prob) 'extid' problem configuration
	  variable is handled.

	* run.c:
	security violation detection and memory limit detection are enabled
	only if general security restrictions are enabled.

	* t3_packets.c:
	"contenttype" attribute is removed;
	"q_extid", "gzipped" attributes are added.

2010-11-18 (r6050) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'extid' field is added.

2010-11-18 (r6048) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c:
	(priv_get_file) 'advanced_layout' is supported;
	(unpriv_get_file) 'advanced_layout' is supported.

2010-11-18 (r6043) Alexander Chernov  <cher@ejudge.ru>

	* files.make: new files added: ej-t3-mediator.c, t3_packets.[ch].

	* ej-t3-mediator.c, t3_packets.h, t3_packets.c: initial revision.

2010-11-18 (r6042) Alexander Chernov  <cher@ejudge.ru>

	* misctext.h:
	(ucs2_to_utf8) new function prototype.

	* ejudge-setup.c:
	(generate_serve_cfg) 'secure' languages are supported.

	* lang_config_vis.c:
	(lang_config_generate_compile_cfg) 'secure' languages are supported.

	* misctext.c:
	(ucs2_to_utf8) new function.

	* new_server_html.c:
	(priv_submit_run) auto-conversion from ucs-2 to utf-8 is supported;
	(unpriv_submit_run) the same.

2010-11-15 (r6040) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in: rules for ej-t3-generator are added.

2010-11-15 (r6038) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac: libzip check is added.

	* config.h.in: libzip check is added.

2010-11-14 (r6037) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in: rule for ej-ncheck is added.

	* files.make: new files are added.

	* ej-ncheck.c, ncheck_packet.c, ncheck_packet.h: initial revision.

2010-11-03 (r6029) Alexander Chernov  <cher@ejudge.ru>

	* edit-userlist.c, job-server.c, lang_config_vis.c:
	Fedora 13 compilation fixes.

2010-11-03 (r6027) Alexander Chernov  <cher@ejudge.ru>

	* runlog.h:
	(run_fix_runlog_time) prototype is added.

	* rldb_plugin_file.c:
	(check_func) implemented.

	* runlog_static.c:
	(run_fix_runlog_time) most of code is moved from rldb_mysql.

2010-11-02 (r6022) Alexander Chernov  <cher@ejudge.ru>

	* rldb_plugin.h:
	(struct rldb_plugin_iface) 'check' function is added.

	* runlog.c:
	(run_open) the plugin's 'check' function is invoked.

	* rldb_plugin_file.c:
	(check_func) new function to check the consistency of the log and
	  fix it if necessary.

2010-11-01 (r6017) Alexander Chernov  <cher@ejudge.ru>

	* new_server_clnt.h:
	(new_server_clnt_close) the result type is changed to
	  'new_server_conn_t'.

2010-10-23 (r6012) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of 'interactor_time_limit' problem is supported.

	* prepare.c, prepare_out.c:
	'interactor_time_limit' problem variable is supported.

	* run.c:
	(run_tests) 'interactor_time_limit' problem variable is supported.

	* super-serve.c, super_html_3.c, super_html_4.c, serve-control.c:
	editing of 'interactor_time_limit' problem is supported.

2010-10-23 (r6010) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) 'interactor_time_limit' is added.

2010-10-16 (r6008) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	PR #47:
	(write_from_contest_dir) 'advanced_layout' mode is correctly
	supported.

2010-10-15 (r6006) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	'config' global variable is renamed to 'ejudge_config'.

	* new-server.c, new_server_html.c, new_server_html_4.c:
	'config' global variable is renamed to 'ejudge_config'.

2010-10-05 (r6004) Alexander Chernov  <cher@ejudge.ru>

	* file_perms.h: copyright notice is updated;
	(file_perms_set) new parameters 'old_group', 'old_mode' are added;
	(file_perms_get) new function prototype.

	* super_html_2.c:
	(rename_files) old file group and permissions are preserved if
	  possible;
	(super_html_commit_contest) old file group and permissions are
	  preserved if possible.

	* super_html_3.c:
	(check_test_file) old file group and permissions are preserved
	  if possible.

2010-10-05 (r6000) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c:
	(find_tester) arch == NULL now means any architecture.

	* run.c:
	(do_loop) arbitrary tester architecture now fits for output-only
	  problems, not only the default architecture.

	* serve_2.c:
	(serve_run_request) arbitrary tester architecture now fits for
	  output-only problems, not only the default architecture.

2010-10-03 (r5998) Alexander Chernov  <cher@ejudge.ru>

	* prepare_out.c:
	(prepare_unparse_prob) `internal_name' and `stand_column' are unparsed.

2010-10-03 (r5996) Alexander Chernov  <cher@ejudge.ru>

	* html.c:
	(do_write_standings) incorrect setting of cur_time for unlimited ACM
	contests is fixed.

2010-09-26 (r5994) Alexander Chernov  <cher@ejudge.ru>

	* super_html_3.c:
	(super_html_edit_languages) situation, when no contest is edited
	  is properly handled.

2010-09-17 (r5992) Alexander Chernov  <cher@ejudge.ru>

	* opcaps.h: copyright notice is updated;
	`COMMENT_RUN' capability bit is added.

	* ejudge-setup.c:
	(generate_contest_xml) `MASTER_SET' capability set is used.

	* new_server_html.c:
	(priv_set_run_style_error_status) `COMMENT_RUN' capability bit is
	  required;
	(priv_simple_change_status) `COMMENT_RUN' capability bit is required.

	* opcaps.c: copyright notice is updated;
	`COMMENT_RUN' capability bit is added.

	* serve-control.c, super_html.c:
	`COMMENT_RUN' capability bit is added.

2010-09-11 (r5990) Alexander Chernov  <cher@ejudge.ru>

	* teamdb_2.c:
	(teamdb_get_user_map) fatal crash is fixed.

2010-09-05 (r5988) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c:
	PR #38 is fixed.

	* prepare.c:
	(cntsprob_copy_and_set_default) NULL pointer dereference fixed.

2010-09-05 (r5985) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac, Makefile.unix.in:
	Fixed PRs #39, #40.

2010-08-10 (r5980) Alexander Chernov  <cher@ejudge.ru>

	* super_html_3.c:
	Ticket #37.
	(super_html_check_tests) bug is fixed.

2010-08-10 (r5979) Alexander Chernov  <cher@ejudge.ru>

	* run_inverse.c:
	Ticket #36.
	(run_inverse_testing) the log file size is limited.

2010-08-08 (r5977) Alexander Chernov  <cher@ejudge.ru>

	* run_inverse.c:
	(run_inverse_testing) most archive errors are reported as presentation
	  errors instead of check failed errors.

2010-08-03 (r5973) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c, super_html_3.c, super_html_4.c:
	Ticket #32.

	* new_server_html.c, super_html_3.c, super_html_4.c:
	'enable_text_form' is supported for STANDARD problems.

2010-08-03 (r5971) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) new field 'enable_textarea_submit'
	  is added.

2010-07-31 (r5967) Alexander Chernov  <cher@ejudge.ru>

	* clntutil.h: copyright notice is updated;
	(client_not_configured) 'messages' parameter is added.

	* new_server_clnt.h: copyright notice is updated;
	stdio.h is included;
	(new_server_clnt_http_request) 'log_f' parameter is added.

	* clntutil.c: copyright notice is updated;
	(client_not_configured) 'messages' parameter is added.

	* new-client.c: copyright notice is updated;
	calls of 'client_not_configured' are updated;
	logging of http_request errors is improved.

	* new-server-cmd.c: copyright notice is updated;
	calls of 'client_not_configured' are updated.

	* serve-control.c:
	calls of 'client_not_configured' are updated.

	* users.c: copyright notice is updated;
	calls of 'client_not_configured' are updated.

2010-07-25 (r5964) Alexander Chernov  <cher@ejudge.ru>

	* mime_type.h:
	7-zip files are supported.

	* mime_type.c:
	7-zip files are supported.

	* run_inverse.c:
	(invoke_sample_program) some information about started programs
	is printed.

2010-07-23 (r5961) Alexander Chernov  <cher@ejudge.ru>

	* run_inverse.c:
	(invoke_checker) 'log_path' is opened in the appending mode.

2010-07-23 (r5959) Alexander Chernov  <cher@ejudge.ru>

	* misctext.c:
	(text_read_file) reserve bytes are allocated properly;
	(text_is_binary) return value is inverted;
	(text_normalize_buf) non-increment bug is fixed.

	* run_inverse.c:
	(normalize_file) out_f is closed instead of log_f.

2010-07-23 (r5957) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c:
	(prepare_copy_problem) all fields that must be cleared in the
	  destination problem structure are now cleared.

2010-07-21 (r5955) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h, prepare.c, new_server_html.c, new_server_html_2.c, serve_state.c, super_html_3.c, prepare_out.c, serve_2.c, super_html_4.c, new_server_html_4.c:
	Ticket #25.

	* serve_state.h:
	(serve_is_problem_started) new function prototype;
	(serve_is_problem_deadlined) new function prototype;
	(serve_is_problem_started_2) new function prototype;
	(serve_is_problem_deadlined_2) new function prototype.

	* new_server_html.c:
	(unpriv_submit_run) 'serve_is_problem_started',
	  'serve_is_problem_deadlined' functions are used;
	(unpriv_command) 'serve_is_problem_started' function is used;
	(is_problem_deadlined) moved to 'serve_2.c';
	(html_problem_selection) 'serve_is_problem_started',
	  'serve_is_problem_deadlined' functions are used;
	(html_problem_selection_2) the same;
	(get_problem_status) the same;
	(unpriv_main_page) the same;
	(unpriv_xml_update_answer) the same;
	(unpriv_get_file) the same.

	* new_server_html_2.c:
	(ns_write_user_problems_summary) 'serve_is_problem_started' is used.

	* new_server_html_4.c:
	(cmd_submit_run) 'serve_is_problem_started',
	  'serve_is_problem_deadlined' functions are used.

	* prepare.c:
	support for 'group_start_date', 'group_deadline' problem
	configuration variables is added;
	(prepare_free_group_dates) new function.

	* prepare_out.c:
	'group_start_date', 'group_deadline' are added to the unhandled
	problem variables.

	* serve_2.c:
	(serve_is_problem_started) new function;
	(serve_is_problem_started_2) new function;
	(serve_is_problem_deadlined) new function;
	(serve_is_problem_deadlined_2) new function.

	* serve_state.c:
	"xml_utils.h" is included;
	<ctype.h> is included;
	(parse_group_dates) new function;
	(serve_parse_group_dates) new function;
	(serve_state_load_contest) 'serve_parse_group_dates' is used.

2010-07-19 (r5952) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct group_date_info) new structure;
	(struct group_dates) new structure;
	(struct section_problem_data) fields 'gsd', 'gdl' are added.

2010-07-16 (r5950) Alexander Chernov  <cher@ejudge.ru>

	* html.h, new_server_tables.c, serve_state.h, teamdb.c, files.make, teamdb_2.c, teamdb.h, teamdb_priv.h, new-server.h, new_server_html.c, html.c, new_server_html_2.c, serve_state.c:
	Ticket #26.

	* files.make:
	teamdb_priv.h, teamdb_2.c are added.

	* html.h:
	(do_write_kirov_standings) 'user_filter' parameter is added;
	(do_write_standings) the same;
	(do_write_moscow_standings) the same.

	* new-server.h:
	new commands 'SET_STAND_FILTER', 'RESET_STAND_FILTER' are added;
	(ns_write_priv_standings) 'phr' parameter is added;
	(ns_set_stand_filter) new function prototype;
	(ns_reset_stand_filter) new function prototype.

	* serve_state.h:
	(struct user_filter_info) new fields for standings filter are added:
	  'stand_user_expr', 'stand_user_tree', 'stand_prob_expr',
	  'stand_prob_tree', 'stand_run_expr', 'stand_run_tree',
	  'stand_mem', 'stand_error_msgs';
	(serve_state_destroy_stand_expr) new function prototype.

	* teamdb.h:
	(teamdb_get_user_map) 'teamdb_state_t state' parameter is replaced
	  with 'serve_state_t cs';
	  'cur_time' parameter is added;
	  'filter' parameter is added.

	* teamdb_priv.h: initial revision.

	* html.c:
	"filter_eval.h" is included;
	(get_problem_map) new function to collect problems for standings;
	(do_write_kirov_standings) 'user_filter' parameter is added;
	  call of 'teamdb_get_user_map' is updated;
	  'get_problem_map' is called;
	  run filtering is supported;
	(do_write_moscow_standings) the same as above;
	(do_write_standings) the same as above;
	(write_standings) calls of 'do_write_kirov_standings',
	  'do_write_moscow_standings', 'do_write_standings' are updated.

	* new_server_html.c:
	(priv_standings) call of 'ns_write_priv_standings' is updated;
	(priv_stand_filter_operation) new function to handle
	  'SET_STAND_FILTER' and 'RESET_STAND_FILTER' requests;
	(unpriv_view_standings) call of 'do_write_standings' is updated;
	  call of 'do_write_kirov_standings' is updated;
	  call of 'do_write_moscow_standings' is updated.

	* new_server_html_2.c:
	(stand_parse_error_func) new function to collect errors during
	  filter expression parsing;
	(ns_set_stand_filter) new function;
	(ns_reset_stand_filter) new function;
	(ns_write_priv_standings) 'phr' parameter is added;
	  standings filter input form is generated;
	  calls of 'do_write_kirov_standings', 'do_write_moscow_standings',
	  'do_write_standings' are updated.

	* new_server_tables.c:
	'SET_STAND_FILTER', 'RESET_STAND_FILTER' commands are supported.

	* serve_state.c:
	(serve_state_destroy_stand_expr) new function;
	(serve_state_destroy) the above function is called.

	* teamdb.c:
	"teamdb_priv.h" is included;
	structure definitions are moved to teamdb_priv.h;
	(teamdb_get_user_map) moved to teamdb_2.c.

	* teamdb_2.c: initial revision.

2010-07-15 (r5948) Alexander Chernov  <cher@ejudge.ru>

	* filter_tree.h, filter_expr.y, userlist-server.c, super-serve.c, serve_state.c, prepare_out.c, super_proto.h, serve_state.h, filter_eval.c, files.make, prepare.c, filter_scan.lex, userlist_clnt.h, serve-control.c, userlist_proto.h, filter_tree.c, super_html_3.c, super_html_4.c:
	Ticket #27.

	* files.make:
	'get_xml_by_text.c' file is added.

	* filter_tree.h: copyright notice is updated;
	'FILTER_ERR_INV_USERGROUP' error code is added.

	* serve_state.h:
	(struct serve_user_group) new structure;
	(struct serve_group_member) new structure;
	(struct serve_state) new fields: 'user_group_count',
	  'user_group_map_size', 'user_groups', 'user_group_map',
	  'group_member_count', 'group_member_map_size', 'group_members',
	  'group_member_map'.

	* super_proto.h:
	editing of 'load_user_group' global configuration variable
	is supported.

	* userlist_clnt.h:
	(userlist_clnt_get_xml_by_text) new function prototype.

	* userlist_proto.h:
	'ULS_GET_GROUPS' request code is added.

	* filter_eval.c:
	(find_user_group) new function;
	(check_user_group) new function;
	(do_eval) "inusergroup" primary expression is supported.

	* filter_expr.y:
	"inusergroup" primary expression is supported.

	* filter_scan.lex:
	"inusergroup" token is supported.

	* filter_tree.c:
	error message for the new error code is added.

	* prepare.c, prepare_out.c:
	'load_user_group' global configuration variable is supported.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of 'load_user_group' global configuration variable
	is supported.

	* serve_state.c:
	(serve_state_destroy) user group info is destroyed;
	(serve_load_user_groups) new function to load the user group info;
	(serve_state_load_contest) user group info is loaded.

	* userlist-server.c:
	minor bugs are fixed;
	(check_pk_set_user_info) new function;
	(cmd_get_groups) new function to handle 'ULS_GET_GROUPS' request.

2010-07-10 (r5944) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c:
	Ticket #15.
	(do_json_user_state) 'need_reload_check' parameter is added;
	(unpriv_load_html_style) js generation is slightly changed;
	(unpriv_page_header) page generation is changed.

2010-07-09 (r5942) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) 'load_user_group' field is added;
	(struct section_problem_data) new fields 'group_start_date',
	  `group_deadline' are added.

2010-07-09 (r5940) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c:
	Ticket #14.
	(unpriv_main_page) generation of the top and the bottom problem
	  naviagation bars is changed to implement proper js-free tabs.

2010-07-08 (r5937) Alexander Chernov  <cher@ejudge.ru>

	* userlist-server.c:
	Ticket #4 completed;
	(check_pk_set_password) new function;
	(cmd_set_passwd) 'check_pk_set_password' is called by the framework,
	  so the packet checking code is removed;
	(cmd_team_set_passwd) the same as above;
	(cmd_priv_set_passwd) the same as above;
	  shared contest users are supported properly.

2010-07-07 (r5933) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h:
	(serve_invoke_stop_script) new function prototype.

	* super_proto.h:
	editing of 'contest_stop_cmd' global configuration variable
	is supported.

	* new_server_html.c:
	(ns_check_contest_events) stop script is invoked;
	(priv_contest_operation) stop script is invoked;
	(priv_upsolving_operation) stop script is invoked.

	* new_server_html_4.c:
	(cmd_operation) stop script is invoked.

	* prepare.c, prepare_out.c:
	'contest_stop_cmd' global configuration variable is supported.

	* serve_2.c:
	(serve_invoke_stop_script) new function.

	* serve-control.c, super_html.c, super_html_2.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of 'contest_stop_cmd' is supported.

2010-07-07 (r5932) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) 'contest_stop_cmd' field is added.

	* super-serve.h:
	(struct sid_state) 'contest_stop_cmd_text' field is added.

	* struct-sizes.c: copyright notice is updated;
	"super-serve.h" is included;
	(main) size of struct sid_state is printed.

2010-07-07 (r5930) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	ICONV variable is used instead of plain iconv.

2010-07-07 (r5929) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac: copyright notice is updated;
	Ticket #1 is fixed.
	check for programs which gawk grep sed make rm cp ln ar cat chmod
	  mkdir tar gzip bzip2 is added;
	check for iconv program is added.

2010-07-06 (r5927) Alexander Chernov  <cher@ejudge.ru>

	* run_inverse.c: Ticket #29.
	(invoke_zip) new function;
	(run_inverse_testing) ZIP archives are supported.

2010-06-30 (r5922) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of `binary' problem configuration variable is supported.

	* new_server_html.c:
	(priv_submit_run) `binary' problem configuration variable is supported;
	(priv_new_run) the same as above;
	(unpriv_submit_run) the same as above.

	* new_server_html_4.c:
	(cmd_submit_run) `binary' problem configuration variable is supported.

	* prepare.c, prepare_out.c:
	`binary' problem configuration variable is supported.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of `binary' problem configuration variable is supported.

2010-06-30 (r5920) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) `binary' field is added.

2010-06-29 (r5918) Alexander Chernov  <cher@ejudge.ru>

	* html.h:
	(write_xml_tests_report) new function prototype;
	(write_xml_team_tests_report) new function prototype.

	* html.c:
	(write_xml_team_tests_report) new function.

	* master_html.c:
	(write_xml_tests_report) new function.

	* new_server_html.c:
	(unpriv_view_report) reports for testing problems are supported.

	* new_server_html_2.c:
	(ns_write_priv_report) reports for testing problems are supported.

	* run_inverse.c:
	(run_inverse_testing) content-type is written to the XML report.

	* testing_report_xml.c:
	(parse_testing_report) "failed_test" attribute is allowed to be unset;
	  "tt_row_count", "tt_column_count" may be unset;
	(testing_report_unparse_xml) "failed_test" is unparsed only if set.

2010-06-29 (r5916) Alexander Chernov  <cher@ejudge.ru>

	* run_inverse.c:
	progress...

2010-06-24 (r5907) Alexander Chernov  <cher@ejudge.ru>

	* testing_report_xml.h:
	(struct testing_report_row) `id' field is renamed to `row';
	  `nominal_score', `score' fields are added.

	* run.c:
	(do_loop) bugs in inverse testing are fixed;
	(check_config) inverse testing is supported.

	* run_inverse.c:
	bugs are fixed.

	* runlog_static.c:
	"problem_common.h" is included;
	(run_status_str) `PROB_TYPE_TESTS' problems are supported.

	* super_html_3.c:
	(super_html_check_tests) `PROB_TYPE_TESTS' problems are supported.

	* testing_report_xml.c:
	"id" attribute is renamed to "row" in <ttrow> element;
	"nominal-score", "score" attributes are supported in <ttrow>.

2010-06-23 (r5904) Alexander Chernov  <cher@ejudge.ru>

	* misctext.h:
	(html_print_by_line) new function prototype.

	* misctext.c:
	(html_print_by_line) new function (moved here from run.c).

	* testing_report_xml.h:
	<stdio.h> is included;
	(struct testing_report_test) fields `input_size', `output_size',
	  `correct_size', `error_size', `checker_size' are added;
	(struct testing_report_row) new structure;
	(struct testing_report_cell) new structure;
	(struct testing_report_xml) fields `tests_mode', `tt_row_count',
	  `tt_column_count', `tt_rows', `tt_cells' are added;
	(testing_report_alloc) new function prototype;
	(testing_report_unparse_xml) new function prototype.

	* run.c:
	(html_print_by_line) moved to misctext.[ch];
	(generate_xml_report) uses of `html_print_by_line' are updated;
	  `global' is used instead of `serve_state.global';
	(do_loop) `global' is used instead of `serve_state.global';
	  inverse testing handling is completed.

	* run_inverse.c:
	completed.

	* testing_report_xml.c:
	"misctext.h" is included;
	support for <ttrows>, <ttrow>, <ttcells>, <ttcell> elements is added;
	support for "tests_mode", "tt_row_count", "tt_column_count", "id",
	  "name", "must_fail", "row", "column" elements is added;
	(testing_report_alloc) new function;
	(unparse_scoring_system) new static function;
	(unparse_bool_attr) new static function;
	(unparse_bool_attr2) new static function;
	(unparse_string_elem) new static function;
	(unparse_string_attr) new static function;
	(unparse_file_contents) new static function;
	(testing_report_unparse_xml) new function.

2010-06-18 (r5901) Alexander Chernov  <cher@ejudge.ru>

	* fileutl.h:
	(write_tmp_file) new function prototype.

	* mime_type.c:
	"fileutl.h" is included;
	file is ported to MinGW;
	(mime_type_guess) `write_tmp_file' is used.

	* run_inverse.c:
	in progress.

2010-06-18 (r5895) Alexander Chernov  <cher@ejudge.ru>

	* fileutl.h:
	(scan_executable_file) function prototype is added.

	* misctext.h:
	(text_read_file) new function prototype;
	(text_is_valid_char) new function prototype;
	(text_is_binary) new function prototype;
	(text_normalize_buf) new function prototype;
	(text_normalize_dup) new function prototype.

	* run.h:
	(run_inverse_testing) function prototype is added.

	* testing_report_xml.h:
	(struct testing_report_xml) `errors' field is added.

	* misctext.c:
	(text_read_file) new function;
	(text_is_valid_char) new function;
	(text_is_binary) new function;
	(text_normalize_buf) new function;
	(text_normalize_dup) new function.

	* run.c:
	"run.h" is included;
	(do_loop) inverse testing is invoked.

	* run_inverse.c:
	in progress.

	* testing_report_xml.c:
	support for <errors> element is added.

2010-06-17 (r5893) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	run.h, run_inverse.c are added.

	* run.h: initial revision.

	* run_inverse.c: initial revision.

2010-06-16 (r5891) Alexander Chernov  <cher@ejudge.ru>

	* run_packet.h:
	(struct run_request_packet) field `mime_type' is added.

	* run_packet_priv.h:
	the packet version is defined as a constant;
	(struct run_request_bin_packet) field `mime_type' is added.

	* serve_state.h:
	(serve_run_request) `mime_type' parameter is added.

	* new_server_html.c, new_server_html_4.c:
	calls of `serve_run_request' are updated.

	* run_packet_1.c, run_packet_2.c:
	`mime_type' field is supported.

	* serve_2.c:
	(serve_run_request) `mime_type' parameter is added;
	  `mime_type' is passed to the `run' program;
	(serve_read_compile_packet) use of `serve_run_request' is updated;
	(serve_rejudge_run) use of `serve_run_request' is updated.

2010-06-16 (r5889) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c:
	(prepare) contests with no languages defined are allowed.

	* super_html_2.c:
	(super_html_commit_contest) contests with no languages are allowed.

2010-06-16 (r5887) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c:
	(prepare_problem_free) new function.

	* prepare_out.c:
	"sformat.h" is included;
	"varsubst.h" is included;
	(prepare_unparse_testers) `prepare_problem_free' use is updated;
	(print_files) output in HTML is generated;
	(report_directory) new function;
	(report_file) new function;
	(handle_file) new function;
	(handle_directory) new function;
	(prob_instr) reworked;
	(prepare_further_instructions) HTML output is generated.

	* super_html_2.c:
	(super_html_commit_contest) output of `prepare_further_instructions'
	  is already in HTML.

	* super_html_3.c:
	use of `prepare_problem_free' is updated.

2010-06-16 (r5886) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(prepare_global_free_func) prototype is removed;
	(prepare_language_free_func) prototype is removed;
	(prepare_problem_free_func) prototype is removed;
	(prepare_tester_free_func) prototype is removed;
	(prepare_global_free) prototype is added;
	(prepare_language_free) prototype is added;
	(prepare_problem_free) prototype is added;
	(prepare_tester_free) prototype is added.

2010-06-14 (r5884) Alexander Chernov  <cher@ejudge.ru>

	* problem_common.h: copyright notice is updated;
	problem type `tests' is added.

	* problem_common.c: copyright notice is updated;
	problem type `tests' is added.

	* new_server_html.c, new_server_html_2.c, new_server_html_4.c:
	initial support for new problem type `tests' is added.

2010-06-14 (r5882) Alexander Chernov  <cher@ejudge.ru>

	* compile.c:
	(check_style_only) completed;
	(do_loop) style checkers are supported.

	* new_server_html.c:
	(priv_submit_run) style checkers are supported for output-only
	  problems;
	(unpriv_submit_run) style checkers are supported for output-only
	  problems.

	* new_server_html_2.c:
	(ns_write_priv_source) textual description of binary archive
	  is displayed.

	* new_server_html_4.c:
	(cmd_submit_run) style checkers are supported for output-only
	  problems.

	* serve_2.c:
	"mime_type.h" is included;
	(serve_compile_request) lang == NULL is supported;
	(serve_read_compile_packet) result of style checker is supported
	  for output-only problems;
	(serve_rejudge_run) style checkers are supported for output-only
	  problems.

2010-06-14 (r5881) Alexander Chernov  <cher@ejudge.ru>

	* compile_packet.h:
	(struct compile_request_packet) field `src_sfx' is added.

	* compile_packet_priv.h:
	compile packet version is boosted to 4;
	(struct compile_request_bin_packet) field `src_sfx_len' is added.

	* compile_packet_1.c:
	(compile_request_packet_read) `src_sfx' is handled.

	* compile_packet_2.c:
	(compile_request_packet_write) `src_sfx' is handled.

	* compile_packet_3.c:
	(compile_request_packet_free) `src_sfx' is handled.

2010-06-14 (r5880) Alexander Chernov  <cher@ejudge.ru>

	* compile_packet.h:
	"serve_state.h" is no longer included;
	(compile_request_packet_read) serve_state_t argument is removed.

	* compile.c:
	(check_style) new function is added;
	(do_loop) minor improvements;
	  call of `compile_request_packet_read' is updated.

	* compile_packet_1.c:
	"serve_state.h" is no longer included;
	(compile_request_packet_read) `state' argument is removed;
	  lang_id check is removed.

2010-06-12 (r5878) Alexander Chernov  <cher@ejudge.ru>

	* ej_process.h: copyright notice is updated;
	(ejudge_invoke_process) new function prototype.

	* super_html_3.c:
	(super_html_print_problem) memory leak is plugged;
	(invoke_test_checker) new function to invoke the test checker;
	(invoke_compile_process) reworked;
	(invoke_make) test checker creation is checked;
	(super_html_check_tests) memory leak is plugged;
	  test checker is invoked, if configured for the problem.

2010-06-12 (r5873) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of `test_checker_cmd', `test_checker_env' problem
	configuration variables is supported.

	* prepare.c:
	`test_checker_cmd', `test_checker_env' problem configuration
	variables are added;
	(prepare_copy_problem) implementation is changed.

	* prepare_out.c:
	`test_checker_cmd', `test_checker_env' problem configuration
	variables are handled;
	(prepare_unparse_testers) handling of `tmp_prob' is changed;
	(prob_instr) handling of `tmp_prob' is changed.

	* super_html_2.c: copyright notice is updated;
	(super_html_commit_contest) a memory leak is plugged.

	* super_html_3.c:
	`test_checker_cmd', `test_checker_env' problem configuration
	variables are handled;
	(super_html_edit_languages) html armoring is reworked;
	(super_html_print_problem) html armoring is reworked;
	(super_html_check_tests) handling of `tmp_prob' is reworked.

	* serve-control.c, super_html_4.c:
	`test_checker_cmd', `test_checker_env' problem configuration
	variables are handled.

	* super-serve.c:
	editing of `test_checker_cmd', `test_checker_env' problem
	configuration variables is supported;
	(super_serve_clear_edited_contest) memory leak is plugged;

2010-06-12 (r5872) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(prepare_copy_problem) function prototype is changed.

2010-06-12 (r5870) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) new fields `test_checker_cmd',
	  `test_checker_env' are added.

2010-06-12 (r5868) Alexander Chernov  <cher@ejudge.ru>

	* parsecfg.c:
	(copy_param) "S" specification is supported - allocate string
	  on heap.

	* prepare.c:
	tables are fixed for `open_tests' parameter.

	* super_html_4.c:
	's' <-> 'S' in parameter specification to match specification in
	prepare.c.

2010-06-12 (r5866) Alexander Chernov  <cher@ejudge.ru>

	* super_html_3.c:
	(invoke_make) make is invoked with `ejudge_make_problem' target;
	(super_html_check_tests) checkers are recompiled before tests
	  are checked.

2010-06-12 (r5864) Alexander Chernov  <cher@ejudge.ru>

	* parsecfg.h:
	(sarray_merge_pp) new function prototype.

	* varsubst.h: copyright notice is updated;
	(config_var_substitute_heap) new function prototype;
	(config_var_substitute_buf) new function prototype.

	* lang_config_vis.c: copyright notice is updated;
	"varsubst.h" is included;
	(do_substitute) is moved to varsubst module.

	* new_server_html.c:
	(priv_submit_run) call of `serve_compile_request' is updated;
	(unpriv_submit_run) call of `serve_compile_request' is updated.

	* new_server_html_4.c:
	(cmd_submit_run) call of `serve_compile_request' is updated.

	* parsecfg.c:
	(sarray_merge_pp) new function.

	* prepare.c:
	(prepare_set_prob_value) `open_tests' is handled properly.

	* serve_2.c:
	"varsubst.h" is included;
	(serve_compile_request) `style_checker_cmd' is processed;
	  `style_checker_env' is processed;
	(serve_rejudge_run) call of `serve_compile_request' is updated.

	* varsubst.c: copyright notice is updated;
	"config.h" is included;
	<reuse/logger.h> is included;
	(do_substitute) moved here from `lang_config_vis.c';
	(config_var_substitute_heap) new function;
	(config_var_substitute_buf) new function.

2010-06-12 (r5861) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of `style_checker_cmd', `style_checker_env' problem
	  configuration parameters is supported.

	* prepare.c, prepare_out.c:
	`style_checker_cmd', `style_checker_env' problem configuration
	  parameters are supported.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of `style_checker_cmd', `style_checker_env' problem
	  configuration parameters is supported.

2010-06-12 (r5860) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) new fields `style_checker_cmd',
	  `style_checker_env'.

2010-06-12 (r5858) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of `style_checker_env' language configuration variable
	is supported.

	* prepare_out.c:
	(prepare_unparse_lang) `style_checker_env' support is improved.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of `style_checker_env' language configuration variable
	is supported.

2010-06-10 (r5854) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h:
	(serve_compile_request) parameters `style_check_only',
	  `style_checker_cmd', `style_checker_env' are added.

	* compile.c:
	(do_loop) correct error is reported, if style checker failed
	  to start.

	* new_server_html.c:
	(priv_submit_run) call of `serve_compile_request' is updated;
	(unpriv_submit_run) call of `serve_compile_request' is updated.

	* new_server_html_4.c:
	(cmd_submit_run) call of `serve_compile_request' is updated.

	* serve_2.c:
	(serve_compile_request) parameters `style_check_only',
	  `style_checker_cmd', `style_checker_env' are added;
	(serve_rejudge_run) call of `serve_compile_request' is updated.

2010-06-10 (r5852) Alexander Chernov  <cher@ejudge.ru>

	* compile_packet.h:
	(struct compile_request_packet) new fields: `style_check_only',
	  `sc_env_num', `sc_env_vars'.

	* compile_packet_priv.h:
	packet version is boosted to 3;
	(struct compile_request_bin_packet) new fields: `style_check_only',
	  `sc_env_num'.

	* compile.c:
	(do_loop) style checker environment setting is supported.

	* compile_packet_1.c:
	(compile_request_packet_read) `style_check_only', `sc_env_num',
	  `sc_env_vars' are handled.

	* compile_packet_2.c:
	(compile_request_packet_write) `style_check_only', `sc_env_num',
	  `sc_env_vars' are handled.

	* prepare.c:
	`style_checker_env' language parameter is added.

	* prepare_out.c:
	(prepare_unparse_lang) `style_checker_env' is supported.

2010-06-10 (r5851) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_language_data) `style_checker_env' field is added.

2010-06-09 (r5848) Alexander Chernov  <cher@ejudge.ru>

	* mime_type.h: copyright notice is updated;
	(mime_type_guess_file) new function prototype.

	* mime_type.c: copyright notice is updated;
	(mime_type_guess_file) new function is added.

2010-06-09 (r5847) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	rule for style_archive is added.

	* files.make:
	style_archive.c is added.

	* style_archive.c: initial revision.

2010-06-06 (r5846) Alexander Chernov  <cher@ejudge.ru>

	* super_html_3:
	(invoke_make) new function;
	(super_html_check_tests) make is invoked if Makefile is present.

2010-06-04 (r5836) Alexander Chernov  <cher@ejudge.ru>

	* html.h: copyright notice is updated;
	(write_xml_team_testing_report) `prob' parameter is added.

	* html.c:
	(write_xml_team_testing_report) `prob' parameter is added;
	  `open_tests' problem configuration variable is handled.

	* new_server_html.c:
	(unpriv_view_report) call of `write_xml_testing_report' is updated.

	* new_server_html_2.c:
	(ns_write_priv_report) call of `write_xml_testing_report' is updated.

2010-06-04 (r5834) Alexander Chernov  <cher@ejudge.ru>

	* reports.c:
	(ns_olympiad_final_user_report) number of columns for `short answer'
	  problems and for `select one' problems is decreased to 1.

2010-06-04 (r5831) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	`open_tests' problem configuration variable editing is supported.

	* prepare.c:
	`open_tests' problem configuration variable is supported;
	(prepare_parse_open_tests) new function;
	(set_defaults) `open_tests' is supported.

	* prepare_out.c:
	(prepare_unparse_prob) `open_tests' is supported.

	* reports.c:
	(ns_olympiad_final_user_report) `output-only' problems are handled
	  exactly as `text-answer' problems.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	`open_tests' problem configuration variable editing is supported.

2010-06-04 (r5830) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) new fields `open_tests', `open_tests_val'
	  are added.

2010-06-01 (r5822) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c:
	`check_cmd' handing is fixed in `advanced_layout' mode.

	* super_html_3.c:
	`check_cmd' handing is fixed in `advanced_layout' mode.

2010-05-31 (r5817) Alexander Chernov  <cher@ejudge.ru>

	* prepare_dflt.h: copyright notice is updated;
	defaults for advanced layout are specified.

	* run_packet.h:
	(struct run_request_packet) `advanced_layout' field is added.

	* run_packet_priv.h:
	FLAGS_ADVANCED_LAYOUT flag is added.

	* new_server_html.c:
	(load_problem_plugin) `advanced_layout' contest global
	  parameter is supported.

	* new_server_html_2.c:
	"prepare_dflt.h" is included;
	(write_from_contest_dir) new parameters `global', `prb', `entry'
	  are added;
	(ns_write_tests) calls of `write_from_contest_dir' are updated.

	* prepare.c:
	new global configuration variable `problems_dir' is added;
	(set_defaults) `advanced_layout' parameter is supported;
	(prepare_set_prob_value) `advanced_layout' parameter is supported;
	(get_advanced_layout_path) new function.

	* prepare_out.c:
	(prob_instr) `advanced_layout' parameter is supported.

	* run.c:
	"prepare_dflt.h" is included;
	(invoke_valuer) `advanced_layout' parameter is supported;
	(invoke_nwrun) `global' parameter is marked as const pointer;
	(run_tests) `advanced_layout' parameter is supported;
	(check_config) `advanced_layout' parameter is supported.

	* run_packet_1.c: copyright notice is updated;
	(run_request_packet_read) `FLAGS_ADVANCED_LAYOUT' is supported.

	* run_packet_2.c: copyright notice is updated;
	(run_request_packet_write) `FLAGS_ADVANCED_LAYOUT' is supported.

	* serve_2.c:
	(serve_compile_request) `advanced_layout' parameter is supported;
	(serve_run_request) `advanced_layout' parameter is supported.

	* super_html_3.c:
	(super_html_add_abstract_problem) `advanced_layout' global contest
	  parameter is supported;
	(super_html_check_tests) `advanced_layout' is supported.

2010-05-30 (r5816) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) `problems_dir' field is added.
	(get_advanced_layout_path) new function prototype.

2010-05-29 (r5814) Alexander Chernov  <cher@ejudge.ru>

	* userlist.h:
	(struct userlist_groupmember) `rights' field is added.

	* userlist_xml.c:
	(elem_free) `rights' is freed.

2010-05-28 (r5810) Alexander Chernov  <cher@ejudge.ru>

	* list_ops.h: copyright notice is updated;
	brackets are added around the parameters.

	* uldb_plugin.h:
	(struct uldb_plugin_iface::create_group) `created_by' parameter added.

	* userlist.h:
	(struct userlist_group) new fields `created_by', `create_time',
	  `last_change_time' are added.

	* uldb_plugin_xml.c:
	(create_group_func) `created_by' parameter is added.

	* userlist-server.c:
	(cmd_create_group) plugin call of `create_group' is updated.

2010-05-24 (r5804) Alexander Chernov  <cher@ejudge.ru>

	* edit-userlist.c:
	group operations on groups and group members are supported.

2010-05-23 (r5802) Alexander Chernov  <cher@ejudge.ru>

	* uldb_plugin.h:
	(struct uldb_plugin_iface) new fields `get_group',
	  `get_group_user_iterator', `get_group_member_iterator',
	  `create_group_member', `remove_group_member'.

	* userlist.h:
	(struct userlist_user) fields `group_first', `group_last' are added;
	(struct userlist_group) fields `user_first', `user_last' are added;
	(struct userlist_groupmember) fields `user_prev', `user_next',
	  `group_prev', `group_next', `group', `user' are added;
	(userlist_write_groups_xml_header) function prototype is removed;
	(userlist_write_groups_xml_footer) function prototype is removed;
	(userlist_write_groups_header) function prototype is added;
	(userlist_write_groups_footer) function prototype is added;
	(userlist_write_groupmembers_header) function prototype is added;
	(userlist_write_groupmembers_footer) function prototype is added;
	(userlist_unparse_usergroupmember) function prototype is added.

	* userlist_proto.h:
	commands `ULS_LIST_GROUP_USERS', `ULS_CREATE_GROUP_MEMBER',
	  `ULS_DELETE_GROUP_MEMBER' are added;
	error `ULS_ERR_BAD_GROUP_ID' is added.

	* edit-userlist.c:
	group member editing is supported.

	* uldb_plugin_xml.c:
	(get_group_func) new function;
	(get_group_user_iterator_func) new function;
	(get_group_member_iterator_func) new function;
	(create_group_member_func) new function;
	(remove_group_member_func) new function.

	* userlist_proto.c:
	new error message is added.

	* userlist-server.c:
	(check_pk_map_contest) new function;
	(check_pk_register_contest) new function;
	(cmd_list_group_users) new function;
	(cmd_create_group_member) new function;
	(cmd_delete_group_member) new function.

	* userlist_xml.c:
	(do_parse_usergroupmember) new function;
	(collect_usergroups) new function;
	(userlist_unparse_usergroupmember) new function.

2010-05-17 (r5798) Alexander Chernov  <cher@ejudge.ru>

	* userlist.h:
	(struct userlist_groupmember) new structure is added.

	* edit-userlist.c:
	some non-implemented code is commented out.

2010-05-15 (r5797) Alexander Chernov  <cher@ejudge.ru>

	* uldb_plugin.h: copyright notice is updated;
	(get_group_iterator) new field is added;
	(get_group_by_name) new field is added;
	(try_new_group_name) new field is added;
	(create_group) new field is added;
	(remove_group) new field is added;
	(edit_group_field) new field is added;
	(clear_group_field) new field is added.

	* userlist.h: copyright notice is updated;
	(struct userlist_group) new structure to store user groups;
	(struct userlist_list) new group-related fields;
	(userlist_write_groups_xml_header) new function prototype;
	(userlist_write_groups_xml_footer) new function prototype;
	(userlist_unparse_usergroup) new function prototype;
	(userlist_group_get_ptr) new function prototype;
	(userlist_group_get_ptr_nc) new function prototype.

	* userlist_clnt.h: copyright notice is updated;
	(userlist_clnt_edit_field) `cmd' parameter is added;
	(userlist_clnt_delete_field) `cmd' parameter is added;
	(userlist_clnt_create_user) `cmd' parameter is added.

	* userlist_proto.h: copyright notice is updated;
	new commands ULS_LIST_ALL_GROUPS, ULS_CREATE_GROUP, ULS_DELETE_GROUP,
	  ULS_EDIT_GROUP_FIELD, ULS_DELETE_GROUP_FIELD;
	new error code ULS_ERR_GROUP_NAME_USED.

	* edit-userlist.c: copyright notice is updated;
	calls of `userlist_clnt_delete_field',
	  `userlist_clnt_edit_field' are updated;
	(do_display_group_members_menu) new function;
	(display_group_members_menu) new function;
	(do_display_group_menu) new function;
	(display_group_menu) new function;
	(display_main_menu) group editing is added.

	* userlist.c:
	(userlist_group_get_ptr) new function;
	(userlist_group_get_ptr_nc) new function.

	* userlist_proto.c: copyright notice is updated;
	new error code is supported.

	* userlist-server.c:
	(check_pk_edit_field) new function;
	(check_pk_delete_info) new function;
	(cmd_list_all_groups) new function;
	(cmd_create_group) new function;
	(cmd_delete_group) new function;
	(cmd_edit_group_field) new function;
	(cmd_delete_group_field) new function.

	* userlist_xml.c:
	(do_parse_usergroups) new function;
	(do_parse_userlist) usergroups are supported;
	(xml_unparse_text_attr) new function;
	(userlist_unparse_usergroup) new function;
	(unparse_usergroup) new function;
	(userlist_write_groups_xml_header) new function;
	(userlist_write_groups_xml_footer) new function;
	(userlist_unparse) usergroups are unparsed.

	* uldb_plugin_xml.c: copyright notice is updated;
	(get_group_iterator_func) new function;
	(get_group_by_name_func) new function;
	(try_new_group_name_func) new function;
	(create_group_func) new function;
	(remove_group_func) new function;
	(edit_group_field_func) new function;
	(clear_group_field_func) new function.

2010-05-12 (r5794) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	(serve_run_request) crash if lang == null is fixed.

2010-03-07 (r5789) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of `disable_auto_refresh', `ignore_unmarked' is supported.

	* html.c:
	(do_write_kirov_standings) `ignore_unmarked' is supported.

	* new_server_html.c:
	(do_json_user_state) `disable_auto_refresh' global variable
	  is handled.

	* new_server_html_2.c:
	(ns_get_user_problems_summary) `ignore_unmarked' is supported.

	* prepare.c, prepare_out.c:
	`disable_auto_refresh' global configuration variable is supported;
	`ignore_unmarked' problem configuration variable is supported.

	* run.c:
	`static' is added where needed.

	* serve_2.c:
	(serve_run_request) tester-specific `run_dir' is handled.

	* serve-control.c, super-serve.c, super_html_3.c, super_html_4.c:
	editing of `disable_auto_refresh', `ignore_unmarked' is supported.

2010-03-07 (r5788) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) `disable_auto_refresh' field is added;
	(struct section_problem_data) `ignore_unmarked' field is added.

2010-03-06 (r5785) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of `advanced_layout' is supported.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of `advanced_layout' is supported.

2010-03-06 (r5784) Alexander Chernov  <cher@ejudge.ru>

	* run.c:
	(generate_xml_report) generation fixes.

2010-03-06 (r5783) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) `advanced_layout' field is added.

	* prepare.c, prepare_out.c:
	`advanced_layout' field is supported.

2010-03-03 (r5781) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_get_user_problems_summary) score_latest mode is supported for
	  KIROV contests.

2010-03-02 (r5779) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.c:
	SSERV_CMD_CNTS_CHANGE_SCHED_TIME handler is installed properly.

2010-03-01 (r5777) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	MARK_DISPLAYED_2, UNMARK_DISPLAYED_2 actions are added.

	* serve_state.h:
	(serve_mark_by_mask) new function prototype is added.

	* filter_eval.c:
	(is_latestmarked) bug is fixed.

	* new_server_html.c:
	(priv_clear_displayed) MARK_DISPLAYED_2, UNMARK_DISPLAYED_2
	commands are handled.

	* new_server_html_2.c:
	(ns_write_priv_all_runs) MARK_DISPLAYED_2, UNMARK_DISPLAYED_2
	  buttons are generated.

	* new_server_tables.c:
	MARK_DISPLAYED_2, UNMARK_DISPLAYED_2 buttons are added.

	* serve_2.c:
	(serve_mark_by_mask) new function.

2010-02-23 (r5775) Alexander Chernov  <cher@ejudge.ru>

	* rldb_plugin.h: copyright notice is updated;
	(struct rldb_plugin_iface) `change_status_2' member is added.

	* runlog.h:
	(run_change_status_2) new function prototype.

	* serve_2.c:
	(serve_read_run_packet) `marked_flag' is handled.

	* rldb_plugin_file.c:
	(change_status_2_func) new function prototype.

	* run.c:
	(generate_xml_report) `marked_flag' parameter is added;
	  "marked-flag" attribute is generated to XML;
	(read_valuer_score) new function;
	(invoke_valuer) `p_marked' parameter is added;
	(run_tests) `marked_flag' is retrieved from the valuer and written
	  to XML and reply packet.

	* runlog.c:
	(run_change_status_2) new function.

2010-02-23 (r5773) Alexander Chernov  <cher@ejudge.ru>

	* run_packet.h: copyright notice is updated;
	(struct run_reply_packet) `marked_flag' field is added.

	* run_packet_priv.h: copyright notice is updated;
	`FLAGS_MARKED' flag is added.

	* testing_report_xml.h:
	(struct testing_report_xml) `marked_flag' field is added.

	* run_packet_4.c, run_packet_5.c: copyright notice is updated;
	`marked_flag' field is added.

	* testing_report_xml.c:
	"marked-flag" attribute is supported.

2010-02-23 (r5772) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of `valuer_sets_marked' problem variable is supported.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of `valuer_sets_marked' problem variable is supported.

2010-02-23 (r5771) Alexander Chernov  <cher@ejudge.ru>

	* prepare.c, prepare_out.c:
	`valuer_sets_marked' problem configuration variable is supported.

2010-02-23 (r5770) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(section_problem_data) `valuer_sets_marked' field is added.

2010-02-23 (r5769) Alexander Chernov  <cher@ejudge.ru>

	* filter_eval.c, filter_expr.y, filter_scan.lex:
	`marked', `saved', and `latestmarked' predicates are supported.

2010-02-23 (r5768) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	editing of `is_marked' and `is_saved' run properties is handled.

	* new_server_html.c, new_server_html_2.c, new_server_tables.c:
	editing of `is_marked' and `is_saved' run properties is handled.

2010-02-23 (r5767) Alexander Chernov  <cher@ejudge.ru>

	* runlog.h, runlog.c:
	new fields `is_marked', `is_saved', `saved_status', `saved_score',
	`saved_test' are handled.

	* rldb_plugin_file.c: copyright notice is updated;
	new fields `is_marked', `is_saved', `saved_status', `saved_score',
	`saved_test' are handled.

2010-02-22 (r5763) Alexander Chernov  <cher@ejudge.ru>

	* nwrun.c:
	combined std/file input/output is properly supported.

2010-01-28 (r5755) Alexander Chernov  <cher@ejudge.ru>

	* teamdb.h: copyright notice is updated;
	(teamdb_get_user_map) new function prototype.

	* html.c:
	(do_write_kirov_standings) `teamdb_get_user_map' is used to optimize
	  speed;
	(do_write_moscow_standings) `teamdb_get_user_map' is used to optimize
	  speed;
	(do_write_standings) the same as above.

	* teamdb.c: copyright notice is updated;
	(teamdb_convert_flags) new function;
	(teamdb_get_flags) `teamdb_convert_flags' is called;
	(teamdb_get_user_map) new function.

2010-01-26 (r5750) Alexander Chernov  <cher@ejudge.ru>

	* filter_eval.c, filter_expr.y, filter_scan.lex:
	`arch' primitive is supported.

2010-01-26 (r5748) Alexander Chernov  <cher@ejudge.ru>

	* nwrun_packet.h:
	(struct nwrun_out_packet) `real_time_available' field is added.

	* master_html.c:
	(write_xml_testing_report) real time is reported only if available;
	  max memory used is reported is available.

	* nwrun.c:
	(run_program) `real_time_available' is set.

	* nwrun_packet.c:
	`real_time_available' output packet parameter is added.

	* reports.c:
	(write_xml_tex_testing_report) real time is reported only if available;
	  max memory used is reported is available.

	* run.c:
	(invoke_nwrun) `p_has_real_time' parameter is added;
	(run_tests) `has_real_time' parameter is passed to `invoke_nwrun'.

2010-01-25 (r5746) Alexander Chernov  <cher@ejudge.ru>

	* testing_report_xml.h:
	(struct testing_report_test) `max_memory_used' field is added;
	(struct testing_report_xml) `real_time_available',
	  `max_memory_used_available' fields are added.

	* nwrun.c:
	(run_program) `max_memory_used' is handled.

	* nwrun_packet.h:
	(struct nwrun_out_packet) `max_memory_used' field is added.

	* nwrun_packet.c:
	`max_memory_used' output packet parameter is supported.

	* run.c:
	(struct testinfo) `max_memory_used' field is added;
	(generate_xml_report) "real-time-available",
	  "max-memory-used-available", "max-memory-used" attributes
	  are generated;
	(invoke_nwrun) `max_memory_used' is handled;
	(run_tests) `max_memory_used' is handled.

	* testing_report_xml.c:
	"max-memory-used", "real-time-available", "max-memory-used-available"
	attributes are supported.

2010-01-25 (r5744) Alexander Chernov  <cher@ejudge.ru>

	* html.c:
	(write_xml_team_testing_report) `exit_comment' field is handled;
	(write_xml_team_output_only_acc_report) the same;
	(write_xml_team_accepting_report) the same.

	* master_html.c:
	(write_xml_testing_report) `exit_comment' field is handled.

	* reports.c:
	(write_xml_tex_testing_report) `exit_comment' field is handled.

2010-01-25 (r5743) Alexander Chernov  <cher@ejudge.ru>

	* nwrun_packet.h:
	(struct nwrun_out_packet) `exit_comment' field is added.

	* testing_report_xml.h: copyright notice is updated;
	(struct testing_report_test) `exit_comment' field is added.

	* nwrun.c:
	(run_program) `exit_comment' is supported.

	* nwrun_packet.c:
	`exit_comment' parameter is added.

	* run.c:
	(struct testinfo) `exit_comment' field is added;
	(generate_xml_report) `exit_comment' field is handled;
	(invoke_nwrun) `exit_comment' field is handled.

	* testing_report_xml.c: copyright notice is updated;
	new attribute "exit-comment" is handled.

2010-01-25 (r5742) Alexander Chernov  <cher@ejudge.ru>

	* pathutl.h: copyright notice is updated;
	"/" is used instead of "\\".

	* compile.c:
	(do_loop) `task_SetMaxRealTime' is used instead of `task_SetMaxTime';
	(main) "-c" option is supported.

	* nwrun.c:
	various fixes...

	* run.c:
	(invoke_nwrun) `combined_stdin' and `combined_stdout' problem
	  configuration variables are handled.

2010-01-25 (r5739) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of `combined_stdin', `combined_stdout' problem configuration
	parameters is supported.

	* prepare.c, prepare_out.c:
	`combined_stdin', `combined_stdout' problem configuration parameters
	are handed.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of `combined_stdin', `combined_stdout' problem configuration
	parameters is supported.

2010-01-25 (r5738) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) fields `combined_stdin',
	  `combined_stdout' are added.

2010-01-25 (r5737) Alexander Chernov  <cher@ejudge.ru>

	* nwrun_packet.h:
	(struct nwrun_in_packet) new fields `combined_stdin',
	  `combined_stdout' are added.

	* nwrun_packet.c:
	input packet parameters `combined_stdin', `combined_stdout'
	are added.

2010-01-23 (r5726) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_new_run_form) form type is changed to 2.

2010-01-23 (r5720) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	testing queue management actions are added;
	(ns_write_testing_queue) new function.

	* copyright.c: copyright notice is updated.

	* new_server_html.c:
	(priv_view_testing_queue) new function;
	(priv_testing_queue_operation) new function;
	(priv_whole_testing_queue_operation) new function;
	(priv_main_page) "View testing queue" link is added.

	* new_server_html_2.c:
	"run_packet.h" is included;
	<dirent.h> is included;
	(scan_run_sort_func) new function;
	(scan_run_queue) new function;
	(ns_write_testing_queue) new function.

	* new_server_tables.c:
	testing queue management actions are handled.

	* run.c:
	(invoke_nwrun) run_id field is checked on the output packet.

	* serve_2.c:
	<sys/stat.h> is included;
	<dirent.h> is included;
	(testing_queue_lock_entry) new function;
	(testing_queue_unlock_entry) new function;
	(get_priority_value) new function;
	(get_priority_code) new function;
	(serve_testing_queue_delete) new function;
	(serve_testing_queue_change_priority) new function;
	(serve_testing_queue_up) new function;
	(serve_testing_queue_down) new function;
	(collect_run_packets) new function;
	(serve_testing_queue_delete_all) new function;
	(serve_testing_queue_change_priority_all) new function;
	(serve_testing_queue_up_all) new function;
	(serve_testing_queue_down_all) new function.

	* userlist-server.c: copyright notice is updated;
	(update_userlist_table) all dependent contests are notified.

2010-01-23 (r5719) Alexander Chernov  <cher@ejudge.ru>

	* serve_state.h: copyright notice is updated;
	(serve_testing_queue_delete) new function prototype;
	(serve_testing_queue_up) new function prototype;
	(serve_testing_queue_down) new function prototype;
	(serve_testing_queue_delete_all) new function prototype;
	(serve_testing_queue_up_all) new function prototype;
	(serve_testing_queue_down_all) new function prototype.

2010-01-22 (r5717) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	(serve_run_request) language parameter `disable_security' is handled.

2010-01-22 (r5715) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of language `disable_security' variable is supported.

	* prepare.c:
	`disable_security' language configuration variable is supported.

	* prepare_out.c:
	(prepare_unparse_lang) `disable_security' is handled.

	* serve-control.c, super_html_3.c, super-serve.c:
	editing of language `disable_security' variable is supported.

2010-01-22 (r5714) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_language_data) `disable_security' field is added.

2010-01-20 (r5701) Alexander Chernov  <cher@ejudge.ru>

	* compile.c:
	substitutions /COMPILE_HOME_DIR and /CONTESTS_HOME_DIR are added;
	all necessary directories are created.

	* nwrun.c:
	(get_priority_code) new function;
	(read_packet) priority is added to the result packet;
	(do_loop) try harder to move out an incoming packet.

	* run.c:
	(invoke_nwrun) try harder to wait for the nwrun.

2010-01-20 (r5696) Alexander Chernov  <cher@ejudge.ru>

	* run.c:
	(invoke_nwrun) deadlocks are avoided.

2010-01-20 (r5694) Alexander Chernov  <cher@ejudge.ru>

	* filter_eval.c: copyright notice is updated;
	(do_eval) `group' expression is supported.

	* filter_expr.y: copyright notice is updated;
	`group' expression is supported.

	* filter_scan.lex:
	"group" token is supported.

2010-01-18 (r5670) Alexander Chernov  <cher@ejudge.ru>

	* serve_2.c:
	`compile_request_id' is never 0.

2010-01-17 (r5664) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	nwrun_packet.[ch] is added.

	* fileutl.h:
	(make_hardlink) new function prototype.

2010-01-17 (r5661) Alexander Chernov  <cher@ejudge.ru>

	* nwrun_packet.c, nwrun_packet.h:
	initial revision

2010-01-17 (r5659) Alexander Chernov  <cher@ejudge.ru>

	* fileutl.h:
	(get_tmp_dir) new function prototype.

	* compile.c:
	(main) "/TMPDIR" substitution is added.

	* prepare.c:
	(set_defaults) `compile_work_dir' is substituted.

2010-01-17 (r5656) Alexander Chernov  <cher@ejudge.ru>

	* compile.c:
	(main) `compile_home_dir' is undefined on Win32.

	* compile-control.c: copyright notice is updated;
	(main) call of `prepare' is updated.

	* fix-db.c:
	(process_contest) call of `prepare' is updated.

	* serve.c: copyright notice is updated;
	(main) call of `prepare' is updated.

	* serve_2.c:
	(serve_compile_request) lang parameters are used instead of global.

2010-01-17 (r5655) Alexander Chernov  <cher@ejudge.ru>

	* parsecfg.h:
	(param_subst) new function prototype.

	* compile.c:
	Win32 support is being implemented.

	* parsecfg.c:
	(is_prefix) new function is added;
	(param_subst) new function is added.

	* pathutl.c: copyright notice is updated;
	(path_normalize) win32 paths are handled.

	* prepare.c:
	(set_defaults) `subst_src', `subst_dst' parameters are accepted;
	  substitutions are applied for `root_dir', `lang_config_dir',
	  `lang->cmd';
	(prepare) call of `set_defaults' is updated.

	* run.c:
	(main) call of `prepare' is updated.

	* serve_state.c:
	(serve_state_load_contest) call of `prepare' is updated.

2010-01-17 (r5650) Alexander Chernov  <cher@ejudge.ru>

	* parsecfg.h: copyright notice is updated;
	(sarray_append) new function prototype.

	* super_proto.h:
	editing of `enable_win32_languages' is supported.

	* super-serve.h:
	(struct sid_state) `enable_win32_languages' field is added.

	* parsecfg.h: copyright notice is updated;
	(sarray_append) new function.

	* serve-control.c, super-serve.c:
	(super_serve_clear_edited_contest) `enable_win32_languages' is handled.

	* super_html_3.c, super_html_4.c:
	`enable_win32_languages' is handled.

2010-01-17 (r5649) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_tester_data) `nwrun_spool_dir' field is added.

	* super_html.h: copyright notice is updated;
	(super_load_cs_languages) `extra_compile_dirs' parameter is added.

	* prepare.c:
	`nwrun_spool_dir' tester configuration variable is added;
	handling of `extra_compile_dirs' is changed.

	* prepare_out.c:
	win32 architecture is supported.

	* super_html_3.c:
	(super_load_cs_languages) `extra_compile_dirs' parameter is added
	  and handled;
	(super_html_edit_languages) call of `super_load_cs_languages' updated;
	(super_html_lang_activate) `compile_dir_index' is copied;
	(super_html_read_serve) call of `super_load_cs_languages' updated;
	  file is successfully parsed without any testers.

	* super_html_4.c:
	(write_languages_page) call of `super_load_cs_languages' updated.

	* super-serve.c:
	(super_serve_clear_edited_contest) `extra_cs_cfgs' field is freed;
	(super_serve_move_edited_contest) `extra_cs_cfgs' is handled.

2010-01-16 (r5648) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.h: copyright notice is updated;
	(struct sid_state) `extra_cs_cfgs', `extra_cs_cfgs_total' fields are added.

2010-01-16 (r5647) Alexander Chernov  <cher@ejudge.ru>

	* ejudge-setup.c:
	(c_armor_2) the string is properly armored.

2010-01-16 (r5646) Alexander Chernov  <cher@ejudge.ru>

	* misctext.h: copyright notice is updated;
	(c_armored_memlen) new function prototype;
	(c_armored_strlen) new function prototype;
	(c_armor_needed) new function prototype;
	(c_armor_needed_bin) new function prototype;
	(c_armor_buf) new function prototype.

	* prepare_out.c:
	C output armoring is moved to misctext.

	* misctext.c:
	(c_armored_memlen) new function;
	(c_armored_strlen) new function;
	(c_armor_needed) new function;
	(c_armor_needed_bin) new function;
	(c_armor_string) new function;
	(c_armor_buf) new function.

2010-01-16 (r5645) Alexander Chernov  <cher@ejudge.ru>

	* ejudge-setup.c:
	(generate_ejudge_xml) fix.

	* prepare_out.c: copyright notice is updated;
	(prepare_unparse_global) `extra_compile_dirs' is supported;
	(prepare_unparse_lang) `compile_dir_index' is supported.

2010-01-16 (r5643) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) new field `extra_compile_dirs';
	(struct section_language_data) new field `compile_dir_index'.

	* prepare.c:
	`extra_compile_dirs' global configuration var is added;
	`compile_dir_index' language configuration var is added;
	(prepare_global_free_func) `extra_compile_dirs' is handled;
	(set_defaults) `compile_dir_index' is handled.

2010-01-12 (r5640) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	rule for `ej-nwrun' is added.

	* ejudge-configure-compilers.c: copyright notice is updated;
	remove_directory_recursively use is updated.

	* ejudge-setup.c: copyright notice is updated;
	remove_directory_recursively use is updated.

	* new_server_html_2.c:
	remove_directory_recursively use is updated.

	* new_server_html_4.c:
	(cmd_submit_run) `ignore_duplicated_runs' is honored.

2010-01-12 (r5638) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.win32.in:
	version handling is updated.

	* fileutl.h: copyright notice is updated;
	(fast_copy_file) new function prototype;
	(remove_directory_recursively) `preserve_root' parameter is added;
	(generic_truncate) new function prototype.

	* nwrun.c:
	mostly completed.

2010-01-11 (r5634) Alexander Chernov  <cher@ejudge.ru>

	* tsc.c, l10n.c, userlist.c, userlist_xml.c, sformat.c, files.make, prepare.c, misctext.c, Makefile.win32.in, filter_tree.c, run.c, serve_state.c, runlog.c:
	win32 MinGW fixes.

2010-01-11 (r5633) Alexander Chernov  <cher@ejudge.ru>

	* win32_compat.h:
	initial revision

2010-01-11 (r5631) Alexander Chernov  <cher@ejudge.ru>

	* run.c: copyright notice is updated;
	<sys/vfs.h> is not included for MinGW;
	(get_expected_free_space) a new functions, which returns
	  the free space amount in the working directory;
	(check_free_space) a new function which waits until
	  enough free space is available in the working directory.

2010-01-09 (r5621) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h: copyright notice is updated;
	editing of `style_checker_cmd' language variable is supported.

	* prepare.c:
	`style_checker_cmd' language configuration variable is handled.

	* serve_2.c:
	(serve_compile_request) `style_checker_cmd' is passed to
	  the compile server.

	* super_html_3.c:
	editing of `style_checker_cmd' language variable is supported.

	* serve-control.c, super_html_4.c, super-serve.c: copyright notice is updated;
	editing of `style_checker_cmd' language variable is supported.

2010-01-09 (r5618) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h: copyright notice is updated;
	(struct section_language_data) `style_checker_cmd' field is added.

2010-01-09 (r5616) Alexander Chernov  <cher@ejudge.ru>

	* compile.c: copyright notice is updated;
	(do_loop) `style_checker' is supported.

2010-01-09 (r5614) Alexander Chernov  <cher@ejudge.ru>

	* compile_packet.h: copyright notice is updated;
	(struct compile_request_packet) `style_checker' field is added.

	* compile_packet_priv.h: copyright notice is updated;
	EJ_COMPILE_PACKET_VERSION is used for the current packet version;
	(struct compile_request_bin_packet) `style_checker_len' field is added.

	* compile_packet_1.c: copyright notice is updated;
	<limits.h> is included;
	(compile_request_packet_read) EJ_COMPILE_PACKET_VERSION is used for
	  the current version of the compile packet;
	  `style_checker' field is supported.

	* compile_packet_2.c: copyright notice is updated;
	<limits.h> is included;
	(compile_request_packet_write) EJ_COMPILE_PACKET_VERSION is used for
	  the current version of the compile packet;
	  `style_checker' field is supported.

	* compile_packet_3.c: copyright notice is updated;
	(compile_request_packet_free) `style_checker' field is freed.

2010-01-09 (r5612) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h: copyright notice is updated;
	NEW_SRV_ACTION_PRIV_SET_RUN_STYLE_ERR is added.

	* new_server_html.c:
	(priv_set_run_style_error_status) new function to handle
	  PRIV_SET_RUN_STYLE_ERR command;
	PRIV_SET_RUN_STYLE_ERR command is handled.

	* new_server_html_2.c:
	button for PRIV_SET_RUN_STYLE_ERR is added.

	* new_server_tables.c: copyright notice is updated;
	button for PRIV_SET_RUN_STYLE_ERR is added.

2010-01-08 (r5610) Alexander Chernov  <cher@ejudge.ru>

	* runlog.h: copyright notice is updated;
	new run status RUN_STYLE_ERR is added.

	* compile_packet_4.c, compile_packet_5.c, filter_scan.lex, filter_tree.c, html.c, master_html.c, new_server_html.c, new_server_html_2.c, new_server_html_4.c, reports.c, runlog.c, runlog_static.c, serve_2.c: copyright notice is updated;
	new run status RUN_STYLE_ERR is supported.

2010-01-06 (r5605) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in: copyright notice is updated;
	rule for ej-fix-db program is added.

	* fix-db.c: initial revision.

	* super_html_3.c: copyright notice is updated;
	(super_html_find_lang_id) new function to allocate a suitable
	id for an activated language;
	(super_html_lang_activate) id allocation algorithm is changed.

2010-01-03 (r5603) Alexander Chernov  <cher@ejudge.ru>

	* ejudge_cfg.h: copyright notice is updated;
	new elements <default_clardb_plugin>, <default_rundb_plugin>
	are supported.

	* ejudge_cfg.c: copyright notice is updated;
	new elements <default_clardb_plugin>, <default_rundb_plugin>
	are supported.

	* ejudge-setup.c: copyright notice is updated;
	setting of <default_clardb_plugin>, <default_rundb_plugin>
	is supported.

	* prepare.c: copyright notice is updated;
	(set_defaults) `clardb_plugin', `rundb_plugin' default values
	are taken from ejudge.xml elements.

2009-11-25 (r5600) Alexander Chernov  <cher@ejudge.ru>

	* csv.c:
	(csv_parse) empty first field is supported.

2009-09-27 (r5596) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c:
	(priv_download_runs_confirmation) memory leak is fixed.

	* new_server_html_2.c:
	(ns_write_priv_source) memory leak is fixed.

	* run.c:
	(run_tests) input and output are not saved, if binary.

2009-09-13 (r5593) Alexander Chernov  <cher@ejudge.ru>

	* mischtml.h: copyright notice is updated;
	(html_start_form_id) new function prototype.

	* html_start_form.c: copyright notice is updated;
	(html_start_form_id) new function is implemented.

	* misctext.c:
	(text_table_number_lines) program output is rearranged.

	* new_server_html_2.c:
	(ns_write_priv_source) source code commenting controls are
	  rearranged;
	(ns_write_priv_clar) the user message is properly escaped.

	* new_server_html_3.c: copyright notice is updated;
	priv.js is included in the priveleged header.

2009-09-07 (r5590) Alexander Chernov  <cher@ejudge.ru>

	* misctext.h:
	(has_control_characters) new function prototype.

	* new_server_proto.h:
	NEW_SRV_ERR_INV_CHAR error code is added.

	* prepare.h:
	(struct section_problem_data) `disable_ctrl_chars' field is added.

	* super_proto.h:
	editing of the `disable_ctrl_chars' problem configuration variable
	  is supported.

	* misctext.c:
	(has_control_characters) new function.

	* new_server_html.c:
	(priv_submit_run) `disable_ctrl_chars' problem configuration variable
	  is supported;
	(unpriv_submit_run) the same.

	* new_server_proto.c: copyright notice is updated;
	NEW_SRV_ERR_INV_CHAR error code is supported.

	* prepare.c:
	`disable_ctrl_chars' problem configuration variable is supported.

	* prepare_out.c: copyright notice is updated;
	(prepare_unparse_prob) `disable_ctrl_chars' problem configuration
	  variable is supported.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of the `disable_ctrl_chars' problem configuration variable
	  is supported.

2009-09-01 (r5586) Alexander Chernov  <cher@ejudge.ru>

	* userlist-server.c:
	(cmd_import_csv_file) bugs fixes.

2009-08-27 (r5584) Alexander Chernov  <cher@ejudge.ru>

	* compile_packet_1.c:
	win32 compilation fixes.

	* contests.c:
	win32 compilation fixes.

	* errlog.c:
	win32 compilation fixes.

	* new_server_html.c:
	`NO_COOKIE' error is not reported as internal error;

	* runlog.c:
	win32 compilation fixes.

2009-08-12 (r5579) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	libplatform.a is linked to ejudge-control.

	* misctext.h:
	<stdio.h> is included;
	(text_table_number_lines) new function prototype.

	* new-server.h:
	new commands: PRIV_SUBMIT_RUN_JUST_IGNORE, PRIV_SUBMIT_RUN_JUST_OK;
	(ns_write_priv_all_runs) new parameters `first_run_set', `last_run_set' are added;
	(ns_cgi_param_int_opt_2) new function prototype.

	* serve_state.h:
	(struct user_filter_info) new fields `prev_first_run_set', `prev_last_run_set'.

	* filter_eval.c:
	(do_eval) REGEXP (~=) binary operation is supported.

	* filter_expr.y:
	"~=" operation is supported;
	handling of "start" token is fixed;
	(do_regexp) new function.

	* filter_scan.lex:
	"~=" operation is supported.

	* filter_tree.c: copyright notice is updated;
	regular expression matching is implemented;
	(filter_tree_delete) regular expressions are cleaned up;
	(filter_tree_regexp_match) new function to match regular expressions;
	(filter_tree_eval_node) REGEXP (~=) operation is supported.

	* master_html.c:
	(html_reset_filter) `prev_first_run_set', `prev_last_run_set' fields are cleared.

	* misctext.c:
	"compat.h" is included;
	(html_armor_to_file_nbsp) new function is implemented;
	(text_table_number_lines) new function is implemented.

	* new_server_html.c:
	(ns_cgi_param_int) check for empty parameter string is improved;
	(ns_cgi_param_int_opt_2) new function;
	(priv_simple_change_status) new function to handle JUST_OK and JUST_IGNORE commands;
	(priv_main_page) filter parameter handling is improved;
	  call of `ns_write_priv_all_runs' is updated.

	* new_server_html_2.c:
	(ns_write_priv_all_runs) new parameters `first_run_set', `last_run_set' are added;
	  run range display is improved.
	(ns_write_priv_source) the source code displaying is improved;
	  JUST_IGNORE and JUST_OK buttons are added.

	* new_server_html_4.c: copyright notice is updated;
	(do_dump_master_runs) new parameters `first_run_set', `last_run_set' are added;
	  run range handling is improved;
	(cmd_dump_master_runs) parameter handling is improved.

	* new_server_tables.c: buttons for JUST_IGNORE and JUST_OK are added.

	* testing_report_xml.c:
	(parse_test) "exit-code" attribute with negative values is accepted.

2009-07-20 (r5577) Alexander Chernov  <cher@ejudge.ru>

	* errlog.c, parsecfg.c, prepare.c, Makefile.win32.in, contests.c, compile.c:
	win32 compilation fixes.

2009-05-31 (r5573) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_download_runs) bad condition is fixed (gcc 4.4.0 warning).

	* runlog_import.c: copyright notice is updated;
	(runlog_import_xml) bad condition is fixed (gcc 4.4.0 warning).

2009-05-04 (r5571) Alexander Chernov  <cher@ejudge.ru>

	* html.c:
	(new_write_user_runs) problem-specific `team_enable_rep_view' variable
	  is considered.

2009-05-02 (r5569) Alexander Chernov  <cher@ejudge.ru>

	* clarlog.h: copyright notice is updated;
	(struct clar_entry_v1) `run_id' field is added;
	(clar_add_record) `run_id' parameter is added.

	* clarlog.c: copyright notice is updated;
	(clar_add_record) `run_id' parameter is added.

	* convert-clars.c, convert-runs.c: copyright notice is updated;
	"compat.h" is included;
	`close_memstream' is forced to link into the executable.

	* new_server_html.c:
	calls of `clar_add_record' are updated.

	* new_server_html_2.c:
	(ns_write_priv_source) run comment sending form is moved to
	  its proper place.

2009-05-02 (r5566) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	 `SUBMIT_RUN_COMMENT_AND_OK' command is added.

	* new_server_html.c:
	(priv_submit_run_comment) `SUBMIT_RUN_COMMENT_AND_OK' command is supported.

	* new_server_html_2.c:
	(ns_write_priv_source) binary runs may also be commented;
	  `SUBMIT_RUN_COMMENT_AND_OK' command is supported.

	* new_server_tables.c:
	`SUBMIT_RUN_COMMENT_AND_OK' command is supported.

2009-05-02 (r5564) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in: copyright notice is updated;
	file_perms.o is added.

	* files.make: copyright notice is updated;
	file_perms.[ch] module is added.

	* super_html_2.c: copyright notice is updated;
	"file_perms.h" is included;
	(rename_files) parameters `group', `mode' are added;
	  file permissions are changed to those defined by `group' and `mode';
	(super_html_commit_contest) `file_group', `file_mode', `dir_group', `dir_mode'
	  contest parameters are supported.

	* super_html_3.c:
	"file_perms.h" is included;
	(check_test_file) `file_group', `file_mode' parameters are added;
	(super_html_check_tests) `file_group', `file_mode', `dir_group', `dir_mode'
	  contest parameters are supported.

2009-05-02 (r5559) Alexander Chernov  <cher@ejudge.ru>

	* misctext.h:
	(is_empty_string) new function prototype.

	* new-server.h: copyright notice is updated;
	`CHANGE_FINISH_TIME' command is added.

	* new_server_html.c:
	(do_change_finish_time) new function;
	(priv_contest_operation) `CHANGE_FINISH_TIME' command is handled;
	(is_empty_string) moved to `misctext.[ch]';
	(unpriv_print_status) `finish_time' parameter is added;
	(priv_main_page) finish_time changing is supported;
	(unpriv_view_standings) no standings are shown if disabled in the
	  config file.

	* new_server_tables.c: copyright notice is updated;
	`CHANGE_FINISH_TIME' is handled.

	* misctext.c: copyright notice is updated;
	(is_empty_string) moved from `new_server_html.c'.

	* super_html_4.c:
	editing of `user_contest' is supported.

2009-03-24 (r5555) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h: copyright notice is updated;
	editing of `memoize_user_results' global variable is supported.

	* new_server_html.c:
	(unparse_statement) `is_submittable' parameter is added;
	  the statement output is slightly altered if the problem is not
	  submittable.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c: copyright notice is updated;
	editing of `memoize_user_results' global variable is supported.

2009-02-28 (r5551) Alexander Chernov  <cher@ejudge.ru>

	* contests.h: copyright notice is updated;
	(struct contest_field) `separator', `options' fields are added.

	* html.h: copyright notice is updated;
	(write_xml_testing_report) `user_mode' parameter is added.

	* misctext.h: copyright notice is updated;
	(allowed_list_parse) `separator' parameter is added;
	(allowed_list_map) `separator' parameter is added.

	* prepare.h: copyright notice is updated;
	(struct section_global_data) `memoize_user_results' field is added.

	* serve_state.h: copyright notice is updated;
	(struct serve_user_results) new structure to memoize the user results;
	(struct serve_state) new fields `user_result_a', `user_results'
	  are added;
	(serve_store_user_result) new function prototype;
	(serve_get_user_result_score) new function prototype.

	* testing_report_xml.h: copyright notice is updated;
	(struct testing_report_xml) `time_limit_ms', `real_time_limit_ms',
	  `host' fields added.

	* allowed_list.c: copyright notice is updated;
	(allowed_list_parse) `separator' parameter is added;
	  arbitrary field separator is supported;
	(allowed_list_map) `separator' parameter is added and passed to
	  `allowed_list_parse'.

	* contests.c: copyright notice is updated;
	  "separator" and "options" attributes are supported for
	  <field> element.

	* filter_eval.c: copyright notice is updated;
	`total_score' token is evaluated.

	* filter_expr.y: copyright notice is updated;
	`total_score' expression is parsed.

	* filter_scan.lex: copyright notice is updated;
	`total_score' token is handled.

	* html.c:
	(do_write_kirov_standings) the user result is memoized if
	  `memoize_user_results' mode is enabled;
	(write_xml_team_testing_report) the timings above the time limits
	  are reported better;
	(write_xml_team_accepting_report) the same.

	* master_html.c: copyright notice is updated;
	(write_xml_testing_report) `user_mode' parameter is added;
	  the timings above the time limit are reported differently
	  in the user mode.

	* new_server_html.c:
	(priv_view_users_page) the user score is reported in
	  `memoize_user_results' mode.

	* new_server_html_2.c:
	(ns_write_priv_report) call of `write_xml_testing_report'
	  is updated.

	* new_server_html_5.c: copyright notice is updated;
	(edit_general_form) "options", "separator" attributes are handled
	  for any field.

	* prepare.c:
	`memoize_user_results' global configuration variable is added.

	* serve_state.c: copyright notice is updated;
	memoized user results are supported;
	(serve_store_user_result) new function;
	(serve_get_user_result_score) new function.

	* run.c:
	(generate_xml_report) parameters `report_time_limit_ms',
	  `report_real_time_limit_ms' are added.
	  time limits are put to report;
	  the host name is also put to report;
	(run_tests) the time limit and real time limit are reported to
	  the server.

	* testing_report_xml.c: copyright notice is updated;
	  <host> element and "time-limit-ms" and "real-time-limit-ms"
	  attributes are supported.

2009-01-28 (r5548) Alexander Chernov  <cher@ejudge.ru>

	* run.c: copyright notice is updated;
	(run_tests) `pipe' is commented for win32.

2009-01-28 (r5545) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_write_olympiads_user_runs) number of passed test display
	  is fixed.

2009-01-17 (r5543) Alexander Chernov  <cher@ejudge.ru>

	* sformat.h: copyright notice is updated;
	(sformat_message) `html_escape_flag' parameter is added.

	* copyright.c: copyright notice is updated.

	* html.c, new_server_html.c, new_server_html_2.c:
	calls of `sformat_message' are updated.

	* prepare.c, reports.c, serve_2.c: copyright notice is updated;
	calls of `sformat_message' are updated.

	* sformat.c: copyright notice is updated;
	"misctext.h" is included;
	(sformat_message) `html_escape_flag' parameter is added;
	  html escaping is added.

	* userlist-server.c:
	calls of `sformat_message' are updated;
	(list_user_info) user-provided data is properly html-escaped;
	(do_list_users) the same.

2009-01-12 (r5542) Alexander Chernov  <cher@ejudge.ru>

	* html.c: copyright notice is updated;
	(do_write_kirov_standings) the user name is properly armored;
	(do_write_moscow_standings) the same;
	(do_write_standings) the same;
	(do_write_public_log) the same.

	* new_server_html.c: copyright notice is updated;
	(unpriv_view_clar) the user name is propery armored.

	* new_server_html_2.c: copyright notice is updated;
	(ns_write_priv_all_runs) the user name is propery armored;
	(ns_write_all_clars) the same.

	* userlist-server.c: copyright notice is updated;
	(cmd_team_check_cookie) access to outdated structure bug is fixed;
	(cmd_priv_cookie_login) the same;
	(cmd_get_cookie) the same.

2008-12-31 (r5540) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	missing ncurses is not fatal.

2008-12-31 (r5538) Alexander Chernov  <cher@ejudge.ru>

	* compat.h:
	(close_memstream) new function prototype is added;
	(fmemclose) new function prototype is added.

	* compile.c, contests_2.c, edit-userlist.c, ejudge-configure-compilers.c, ejudge-setup.c, job-server.c, lang_config_vis.c, new-server.c, new_server_html.c, new_server_html_2.c, new_server_html_4.c, new_server_html_5.c, opcaps_2.c, parsecfg_2.c, prepare.c, problem_plugin_impl.h, runlog_import.c, serve_2.c, serve-control.c, super_html.c, super_html_2.c, super_html_3.c, super_html_4.c, super-serve.c, uldb_plugin_xml.c, userlist-server.c, vcs.c:
	`close_memstream' is used to close memory streams opened
	with `open_memstream';
	`fmemclose' is used to close memory streams opened with
	`fmemopen'.

2008-12-29 (r5529) Alexander Chernov  <cher@ejudge.ru>

	* runlog_import.c:
	(runlog_import_xml) more debugging output is added.

2008-12-27 (r5519) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c:
	(priv_change_status) full score is set if run is RUN_OK.

2008-12-27 (r5503) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	`compat.h' is added.

	* compat.h: initial revision.

2008-12-26 (r5499) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	fmemopen.c is added.

	* files.make:
	fmemopen.c is added.

2008-12-26 (r5495) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	check for fmemopen is added.

	* config.h.in:
	`HAVE_FMEMOPEN' is added.

2008-12-26 (r5494) Alexander Chernov  <cher@ejudge.ru>

	* uudecode.c:
	`myerr' function implementation instead of `error'.

2008-12-26 (r5486) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	LIBINTL, LIBICONV are added;

	* job-server.c:
	(prepare_directory_notify) conditional compilation for F_NOTIFY
	  is added.

	* mime_type.c: copyright notice is updated;
	"config.h" is included;
	check for `ferror_unlocked' is added.

2008-12-26 (r5483) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	checks for ferror_unlocked, fgets_unlocked are added;
	check for F_NOTIFY is added;
	checks for -liconv, -lintl are added.

	* config.h.in:
	`HAVE_FERROR_UNLOCKED', `HAVE_FGETS_UNLOCKED', `HAVE_F_NOTIFY'
	are added.

2008-12-26 (r5481) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	`open_memstream.c' is added.

	* files.make:
	`open_memstream.c' is added.

2008-12-26 (r5475) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	check for SIOCINQ flag is added.

	* config.h.in:
	HAVE_SIOCINQ is added.

2008-12-26 (r5471) Alexander Chernov  <cher@ejudge.ru>

	* config.h.in:
	HAVE_SO_PASSCRED is added.

2008-12-26 (r5470) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	check for SO_PASSCRED flag is added.

2008-12-25 (r5468) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	libplatform.a library is added.

	* files.make:
	new files are added: sock_op.h, unix/sock_op_*.c, win32/sock_op_*.c.

	* server_framework.c:
	"sock_op.h" is included;
	(read_from_control_connection) `sock_op_get_creds', `sock_op_get_fds'
	  are used;
	(accept_new_connection) `sock_op_enable_creds' is used.

	* super-serve.c:
	"sock_op.h" is included;
	(accept_new_control_connection) `sock_op_enable_creds' is used;
	(read_from_control_connection) `sock_op_get_creds', `sock_op_get_fds'
	  are used.

	* userlist-server.c:
	"sock_op.h" is included;
	(do_work) `sock_op_enable_creds', `sock_op_get_creds',
	  `sock_op_get_fds' are used.

2008-12-25 (r5464) Alexander Chernov  <cher@ejudge.ru>

	* sock_op.h:
	initial revision

2008-12-23 (r5459) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.c:
	(do_loop) `STOP' command is handled much faster;
	  `pselect' system call is used.

2008-12-21 (r5451) Alexander Chernov  <cher@ejudge.ru>

	* run.c:
	(setup_environment) new function;
	(run_tests) interactive problems are supported.

2008-12-21 (r5449) Alexander Chernov  <cher@ejudge.ru>

	* config.h.in:
	`HAVE_TASK_GETPID', `HAVE_TASK_APPEND' are added.

2008-12-21 (r5448) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	checks for task_GetPid, TSK_APPEND are added;
	check for reuse version is improved.

2008-12-20 (r5444) Alexander Chernov  <cher@ejudge.ru>

	* userlist-server.c:
	(cmd_check_cookie) cookie fixes;
	(cmd_team_check_user) last_login_time is updated on cookie login.

2008-12-20 (r5442) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	(ns_upload_csv_results) `add_flag' parameter is added.

	* runlog.h:
	(run_add_record) `sha1' parameter is `const'.

	* new_server_html.c:
	(priv_upload_runlog_csv_1) three upload modes are implemented;
	(priv_upload_runlog_csv_2) three upload modes are implemented.

	* new_server_html_2.c:
	(do_add_row) new function moved out of `ns_upload_csv_runs';
	(ns_upload_csv_runs) refactored;
	(ns_upload_csv_results) `add_flag' parameter is added and handled.

	* runlog.c:
	(run_add_record) `sha1' parameter is `const'.

2008-12-19 (r5440) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) new fields `interactor_cmd',
	  `interactor_env' are added.

	* super_proto.h:
	editing of `interactor_cmd', `interactor_env' is supported.

	* prepare.c, prepare_out.c:
	`interactor_cmd', `interactor_env' problem configuration vars are
	added.

	* serve-control.c, super_html_3.c, super_html_4.c, super-serve.c:
	editing of `interactor_cmd', `interactor_env' is supported.

2008-12-18 (r5434) Alexander Chernov  <cher@ejudge.ru>

	* startstop.h: copyright notice is updated;
	stopping and restarting enumeration is added;
	(start_find_process) prototype is added;
	(start_kill) prototype is added.

	* compile.c, job-server.c, new-server.c, super-serve.c, userlist-server.c:
	(main) the server process is never started, if another process
	  is already running.

	* compile-control.c, job-server-control.c, new-server-control.c, super-serve-control.c, userlist-server-control.c:
	"startstop.h" is included;
	(main) the server process discovery is improved.

2008-12-18 (r5430) Alexander Chernov  <cher@ejudge.ru>

	* compile-control.c, ejudge-control.c, ejudge-setup.c, job-server.c, job-server-control.c, new-server.c, new-server-cmd.c, new-server-control.c, super-serve.c, super-serve-control.c, userlist-server.c, userlist-server-control.c :
	programs are renamed:
	  `userlist-server' -> `ej-users';
	  `super-serve' -> `ej-super-server';
	  `compile' -> `ej-compile';
	  `job-server' -> `ej-jobs-server';
	  `new-server' -> `ej-contests'.

2008-12-18 (r5429) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	files are renamed:
	  `compile' -> `ej-compile';
	  `compile-control' -> `ej-compile-control';
	  `run' -> `ej-run';
	  `serve' -> `ej-serve';
	  `userlist-server' -> `ej-users';
	  `userlist-server-control' -> `ej-users-control';
	  `job-server' -> `ej-jobs';
	  `job-server-control' -> `ej-jobs-control';
	  `job-server-cmd' -> `ejudge-jobs-cmd';
	  `super-serve' -> `ej-super-server';
	  `super-serve-control' -> `ej-super-server-control';
	  `convert-clars' -> `ej-convert-clars';
	  `convert-runs' -> `ej-convert-runs';
	  `edit-userlist' -> `ejudge-edit-users';
	  `execute' -> `ejudge-execute';
	  `new-server' -> `ej-contests';
	  `new-server-cmd' -> `ejudge-contests-cmd';
	  `new-server-control' -> `ej-contests-control';
	`collect-emails', `slice-userlist' are no longer compiled.

2008-12-18 (r5428) Alexander Chernov  <cher@ejudge.ru>

	* ejudge_cfg.c:
	(ejudge_cfg_parse) values of `serve_path' and `run_path' are ignored
	  and always replaced with the default.

	* new_server_html.c:
	(ns_handle_http_request) client program is renamed:
	  `new-server-cmd' -> `ejudge-contests-cmd'.

2008-12-18 (r5426) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	files renamed:
	  `serve' -> `ej-serve';
	  `runs' -> `ej-runs'.

2008-12-17 (r5424) Alexander Chernov  <cher@ejudge.ru>

	* super_html_5.c:
	initial revision

2008-12-17 (r5423) Alexander Chernov  <cher@ejudge.ru>

	* files.make:
	`super_html_5.c' is added.

	* prepare.h:
	(cntsprob_clear_field) new function prototype;
	(cntsprob_is_settable_field) new function prototype;
	(cntsprob_is_inheritable_field) new function prototype.

	* super_html.h:
	(ss_cgi_param) prototype is added;
	(ss_write_html_header) prototype is added;
	(ss_write_html_footer) prototype is added;
	(ss_dojo_button) prototype is added;
	(super_serve_op_browse_problem_packages) prototype is added;
	(super_serve_op_package_operation) prototype is added;
	(super_serve_op_edit_problem) prototype is added;
	(super_html_add_problem) prototype is added;
	(super_html_add_abstract_problem) prototype is added.

	* super_proto.h:
	new operations are added.

	* prepare.c:
	(cntsprob_copy_and_set_default) fixed;
	(cntsprob_clear_field) new function;
	(cntsprob_is_settable_field) new function;
	(cntsprob_is_inheritable_field) new function.

	* super_html.c:
	(super_html_main_page) link to problem editor is added.

	* super_html_3.c:
	`std_checkers' -> `super_html_std_checkers';
	(super_html_add_problem) moved out of `super_html_prob_cmd';
	(super_html_add_abstract_problem) moved out of `super_html_prob_cmd'.

	* super_html_4.c:
	progress...

2008-12-14 (r5414) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	  `score_system_val' -> `score_system';
	  `rounding_mode_val' -> `rounding_mode'.

	* html.c, master_html.c, new_server_html.c, new_server_html_2.c, new_server_html_4.c, prepare.c, prepare_out.c, serve.c, serve_2.c, serve_state.c, super_html_3.c, super_html_4.c, reports.c, run.c:
	global configuration variables are renamed:
	  `score_system_val' -> `score_system';
	  `rounding_mode_val' -> `rounding_mode'.

2008-12-12 (r5411) Alexander Chernov  <cher@ejudge.ru>

	* parsecfg.h: copyright notice is updated;
	(struct config_parse_info) `parse_func' field is added.

	* prepare.h:
	(struct section_problem_data) `type_val' -> `type'.

	* html.c, new_server_html.c, new_server_html_2.c, new_server_html_4.c, prepare.c, prepare_out.c, reports.c, run.c, serve_2.c, super_html_3.c:
	struct section_problem_data field is renamed:
	  type_val -> type.

	* parsecfg.c:
	(copy_param) "f" parse specification is supported.

2008-12-12 (r5409) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) fields are renamed:
	  contest_finish_time_d -> contest_finish_time;
	  stand_ignore_after_d -> stand_ignore_after;
	  appeal_deadline_d -> appeal_deadline;
	(struct section_problem_data) fields are renamed:
	  t_start_date -> start_date;
	  t_deadline -> deadline.

	* html.c, new_server_html.c, new_server_html_2.c, new_server_html_4.c, prepare.c, prepare_out.c, serve.c, serve_2.c, serve_state.c, super_html_3.c, super_html_4.c:
	fields are renamed:
	  contest_finish_time_d -> contest_finish_time;
	  stand_ignore_after_d -> stand_ignore_after;
	  appeal_deadline_d -> appeal_deadline;
	  t_start_date -> start_date;
	  t_deadline -> deadline.

	* parsecfg.c:
	"xml_utils.h" is included;
	(copy_param) "t" type specifier is supported.

2008-12-12 (r5407) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(cntsprob_is_undefined) new function prototype.

	* super_proto.h:
	new operations are added.

	* super-serve.h:
	(struct sid_state) `prob_show_adv' field is added.

	* prepare.c:
	(cntsprob_is_undefined) new function.

	* super_html_4.c: in progress...

2008-12-10 (r5406) Alexander Chernov  <cher@ejudge.ru>

	* html.c:
	large tables are allocated on heap in standings functions.

2008-12-07 (r5404) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_write_ip_users) implemented.

2008-12-07 (r5402) Alexander Chernov  <cher@ejudge.ru>

	* new-server.h:
	new requests `VIEW_USER_IPS', `VIEW_IP_USERS' are added;
	(ns_write_user_ips) new function prototype;
	(ns_write_ip_users) new function prototype.

	* new_server_html.c:
	(priv_view_user_ips) new function;
	(priv_view_ip_users) new function;
	(priv_main_page) IP addresses statistics page links are added;
	`VIEW_USER_IPS', `VIEW_IP_USERS' requests are handled.

	* new_server_html_2.c:
	(ns_write_user_ips) new function;
	(ns_write_ip_users) new function (not yet implemented).

2008-12-06 (r5400) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	editing of the new problem configuration variables
	  `stand_name', `stand_column', `internal_name' is supported.

	* serve-control.c, super_html_3.c, super-serve.c:
	editing of the new problem configuration variables
	  `stand_name', `stand_column', `internal_name' is supported.

	* sformat.c:
	(sformat_message) format conversions `PS', `PL' for
	  `stand_name' and `internal_name' problem configuration
	  variables are added.

2008-12-06 (r5398) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html_2.c:
	(ns_write_user_problems_summary) bug in olympiad accepting mode
	  summary display is fixed.

2008-12-06 (r5396) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c:
	variable substitution is added for XML answers.

2008-12-06 (r5394) Alexander Chernov  <cher@ejudge.ru>

	* html.h:
	(struct section_problem_data) new fields `stand_name', `stand_column',
	  `internal_name' are added.

	* html.c:
	`stand_name', `stand_column' problem configuration variables
	are supported.

	* prepare.c:
	`stand_name', `stand_column', `internal_name' problem configuration
	variables are added.

2008-12-05 (r5392) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_problem_data) `unhandled_vars' is not private;
	(struct section_language_data) `unhandled_vars' is not private.

	* super_html.h:
	(super_load_cs_languages) new function prototype;
	(super_html_lang_activate) new function prototype;
	(super_html_lang_deactivate) new function prototype.

	* super_proto.h:
	operations for language editing are added.

	* super-serve.h:
	(struct sid_state) `cur_lang', `cur_prob' fields are added.

	* super_html_3.c:
	(super_load_cs_languages) renamed from `load_cs_languages';
	(super_html_lang_activate) function is outlined from
	  `super_html_lang_cmd';
	(super_html_lang_deactivate) the same.

	* super_html_4.c:
	language editing is implemented.

2008-12-02 (r5384) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.win32.in: copyright notice is updated;
	WIN32_CFILES, WIN32_RUNFILES are added;
	use of `revinfo' is updated.

	* files.make:
	contests_2.c, opcaps_2.c are added.

	* interrupt.h: copyright notice is updated;
	(interrupt_flag_interrupt) new function prototype;
	(interrupt_flag_sighup) new function prototype.

	* uldb_plugin.h:
	<time.h> is included.

	* charsets.c:
	<malloc.h> is included on MinGW;
	(charset_decode_buf) two variants of `iconv' are supported: the linux
	  (char ** as the second arg), and the MinGW (const char** as the
	  second arg).

	* compile.c:
	Win32 portability fixes.

	* contests.c:
	functions, which change the `contest_desc' structure are moved to
	  `contests_2.c'.

	* contests_2.c: initial revision.

	* ejudge_cfg.c:
	conditional inclusion of <pwd.h>;
	<malloc.h> included on MinGW;
	(parse_user_map) user mapping is skipped, if <pwd.h> is missing.

	* filehash.c: copyright notice is updated;
	<malloc.h> is included on MinGW.

	* expat_iface.c, filter_tree.c, userlist.c, userlist_xml.c:
	<malloc.h> is included on MinGW.

	* opcaps.c:
	<malloc.h> is included on MinGW;
	(opcaps_unparse) moved to `opcaps_2.c'.

	* opcaps_2.c: initial revision.

	* prepare.c:
	(prepare_parse_variant_map) `open_memstream' is used only if
	  exists on the platform.

	* random.c: copyright notice is updated;
	`rand()' is used instead of `random()'.

	* run.c:
	"startstop.h" is included;
	(set_self_args) removed;
	(main) `start_set_self_args' is used instead of `set_self_args';
	  `start_restart' is used.

	* team_extra.c:
	<malloc.h> is included on MinGW;
	various portability fixes.

2008-12-02 (r5379) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac, config.h.in:
	check for pwd.h is added;
	checks for truncate, setsid are added.

2008-12-02 (r5377) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	check for `open_memstream' is added.

	* config.h.in:
	`HAVE_OPEN_MEMSTREAM' is added.

2008-12-01 (r5375) Alexander Chernov  <cher@ejudge.ru>

	* config.h.in:
	HAVE_ICONV_H, HAVE_STRNLEN, CONF_ICONV_NEEDS_CONST are added.

2008-12-01 (r5374) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	checks for iconv.h, strnlen are added;
	check for `const' argument of iconv is added.

2008-11-30 (r5372) Alexander Chernov  <cher@ejudge.ru>

	* problem_plugin.h: copyright notice is updated;
	problem plugin version number is increased to 2;
	(struct problem_plugin_iface) new fields `sizes_array',
	  `sizes_array_size'.

	* serve_state.h:
	new exported variables (constants): `serve_struct_sizes_array',
	  `serve_struct_sizes_array_size', `serve_struct_sizes_array_num'.

	* new_server_html.c:
	(load_problem_plugin) structure sizes checking is implemented.

2008-11-30 (r5370) Alexander Chernov  <cher@ejudge.ru>

	* contest_plugin.h: copyright notice is updated;
	plugin interface version number is increased to 2;
	(struct contest_plugin_iface) new fields `sizes_array',
	  `sizes_array_size' are added.

	* serve_state.c:
	(serve_state_load_contest) structure sizes check is performed upon
	  loading a contest plugin.

2008-11-30 (r5367) Alexander Chernov  <cher@ejudge.ru>

	* ej_types.h:
	new types `ejstrlist_t' and `ejenvlist_t' are added.

	* misctext.h:
	(split_to_lines) new function prototype;
	(num_to_size_str) new function prototype;
	(size_t_to_size_str) new function prototype.

	* prepare.h:
	(struct section_global_data) `unhandled_vars' is not marked as
	  meta_private;
	(struct section_problem_data) the types of `checker_env' and
	  `valuer_env' fields are changed;
	(struct section_language_data) the type of `compiler_env' is
	  changed;
	(struct section_tester_data) the types of `start_env', `checker_env'
	  are changed.

	* super_proto.h: new operations are added.

	* misctext.c:
	(split_to_lines) new function;
	(num_to_size_str) function moved here from `super_html_3.c';
	(size_t_to_size_str) function moved here from `super_html_3.c'.

	* super_html_3.c:
	(num_to_size) moved to `misctext.c' as `num_to_size_str';
	(size_t_to_size) moved to `misctext.c' as `size_t_to_size_str'.

	* super_html_4.c: progress...

2008-11-23 (r5363) Alexander Chernov  <cher@ejudge.ru>

	* meta_generic.h:
	(struct meta_methods) new structure to collect all access functions
	  in one place.

	* prepare.h:
	(struct section_global_data) `score_system_val' is not marked as
	  `meta_private'.

	* super_proto.h:
	new operations for new contest edit are added.

	* super-serve.h:
	(struct sid_state) `edit_page' field is added.

	* super_html_4.c: in progress...

	* super-serve.c:
	(super_serve_clear_edited_contest) `edit_page' is cleared.

2008-11-21 (r5360) Alexander Chernov  <cher@ejudge.ru>

	* runlog.h:
	(run_get_all_statistics) new function prototype.

	* new_server_html.c:
	(priv_view_users_page) the number of user's submits and the total size
	  of user's submits is displayed for each user.

	* runlog.c:
	(run_get_all_statistics) new function.

2008-11-20 (r5354) Alexander Chernov  <cher@ejudge.ru>

	* new-client.c: copyright notice is updated;
	(struct client_section_global_data) renamed from
	  `struct section_global_data'.

2008-11-20 (r5352) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	rules for `prepare_meta.[ch]' are added.

	* ej_types.h:
	`ejintsize_t' type is added.

	* prepare.h:
	metageneration-related changes;
	doxygen comments are added for `struct section_global_data'.

	* meta_generic.c:
	(meta_build_automaton) NULL name is allowed and skipped.

2008-11-18 (r5339) Alexander Chernov  <cher@ejudge.ru>

	* new_server_html.c:
	(priv_submit_clar) URL generation is fixed;
	(priv_submit_run_comment) the same;
	(priv_clar_reply) the same.

	* serve_2.c:
	(serve_notify_user_run_status_change) URL generation is fixed.

2008-11-18 (r5338) Alexander Chernov  <cher@ejudge.ru>

	* super_html.h:
	(super_html_locked_cnts_dialog) new function prototype.

	* super_proto.h:
	new actions are added.

	* super-serve.h:
	(super_serve_move_edited_contest) new function prototype;
	(super_serve_sid_state_get_cnts_editor_nc) new function prototype.

	* super_html.c:
	(super_html_locked_cnts_dialog) new function;
	(super_html_create_contest_2) checked if the new contest number
	  is already used.

	* super_html_4.c:
	(cmd_locked_cnts_forget) new function;
	(cmd_locked_cnts_continue) new function;
	(cmd_edit_contest_page) `super_html_locked_cnts_dialog' is used.

	* super-serve.c:
	"super-serve_meta.h" is included;
	(prepare_serve_serving) does nothing;
	(sid_state_add) new parameters `user_id', `user_login', `user_name'
	  are added;
	(sid_state_get) new parameters `user_id', `user_login', `user_name'
	  are added;
	(super_serve_sid_state_get_cnts_editor_nc) new function;
	(super_serve_move_edited_contest) new function;
	(cmd_main_page) contest edited in another session situations are
	  supported.

2008-11-18 (r5336) Alexander Chernov  <cher@ejudge.ru>

	* super-serve.h:
	(struct sid_state) new fields `user_id', `user_login', `user_name'.

	* super-serve.c:
	(sid_state_clear) `user_login', `user_name' are freed.

2008-11-17 (r5326) Alexander Chernov  <cher@ejudge.ru>

	* Makefile.unix.in:
	icons are installed;
	ejudge-upgrade-web script is installed.

	* ejudge-setup.c:
	(generate_install_script) `priv.js' is symlinked, and `actions.js'
	  is not.

2008-11-17 (r5324) Alexander Chernov  <cher@ejudge.ru>

	* configure.ac:
	`ac_cv_httpd_cgi_bin_dir', `ac_cv_httpd_htdocs_dir' are exported;
	style/ejudge-upgrade-web script is supported.

2008-11-17 (r5321) Alexander Chernov  <cher@ejudge.ru>

	* super_proto.h:
	`xml_file' editing is supported instead of `statement_file'.

	* prepare_out.c:
	(prepare_unparse_prob) `xml_file' variable is handled;
	  `statement_file' variable is no longer handled.
	(prepare_unparse_unhandled_prob) `xml_file' variable is no longer
	  handled;
	  `statement_file' variable is handled.
	(prob_instr) `xml_file' is handled instead of `statement_file'.

	* serve-control.c, super_html_3.c, super-serve.c:
	`xml_file' editing is supported instead of `statement_file'.

	* userlist_xml.c:
	(do_parse_user) empty e-mails are handled.

2008-11-17 (r5315) Alexander Chernov  <cher@ejudge.ru>

	* run_packet.h: copyright notice is updated;
	(struct run_request_packet) the `notify_flag' field is added;
	(struct run_reply_packet) the `notify_flag' field is added.

	* run_packet_priv.h:
	FLAGS_NOTIFY is added;
	(struct run_reply_bin_packet) `flags' field is added.

	* run.c:
	(do_loop) `notify_flag' copied from the input to the output packet.

	* new_server_html.c:
	calls of `serve_compile_request' and `serve_run_request' are updated;
	`serve_send_clar_reply_email' renamed to `serve_send_email_to_user';
	(priv_change_status) change status e-mail notifications are supported.

	* new_server_html_4.c:
	(cmd_submit_run) calls of `serve_compile_request' and
	  `serve_run_request' are updated.

	* run_packet_1.c, run_packet_2.c, run_packet_4.c, run_packet_5.c:
	`notify_flag' is supported.

	* serve_2.c:
	<libintl.h> is included;
	(serve_compile_request) the `notify_flag' parameter is added;
	(serve_run_request) the `notify_flag' parameter is added;
	(serve_send_email_to_user) renamed from `serve_send_clar_reply_email';
	(serve_notify_user_run_status_change) new function;
	(serve_read_compile_packet) status change notifications are supported;
	(serve_read_run_packet) status change notifications are supported.

	* serve_state.h:
	(struct compile_run_extra) the `notify_flag' field is added;
	(serve_compile_request) the `notify_flag' parameter is added;
	(serve_run_request) the `notify_flag' parameter is added;
	(serve_send_email_to_user) renamed from `serve_send_clar_reply_email';
	(serve_notify_user_run_status_change) new function prototype.

2008-11-16 (r5313) Alexander Chernov  <cher@ejudge.ru>

	* prepare.h:
	(struct section_global_data) new fields `notify_clar_reply',
	  `notify_status_change'.

	* serve_state.h:
	(serve_send_clar_reply_email) new function.

	* super_proto.h:
	editing of the `notify_clar_reply', `notify_status_change' global
	configuration variables is supported.

	* new_server_html.c:
	(priv_submit_clar) user e-mail notification is supported;
	(priv_submit_run_comment) the same;
	(priv_clar_reply) the same.

	* prepare.c, prepare_out.c:
	new global variables `notify_clar_reply', `notify_status_change'
	are supported.

	* serve_2.c:
	(serve_send_clar_reply_email) new function.

	* serve-control.c, super_html_3.c, super-serve.c:
	editing of the `notify_clar_reply', `notify_status_change' global
	configuration variables is supported.

2008-11-15 (r5311) Alexander Chernov  <cher@ejudge.ru>

	* rldb_plugin_file.c, runlog.c:
	(reset) parameters are renamed:
	  `new_duration' -> `init_duration',
	  `new_sched_time' -> `init_sched_time',
	  `new_finish_time' -> `init_finish_time'.

2008-11-15 (r5309) Alexander Chernov  <cher@ejudge.ru>

	* contests.h, super_proto.h:
	<start_date> is renamed to <sched_time>.

	* rldb_plugin.h:
	(rldb_plugin_iface::open) `init_sched_time' parameter is added;
	(rldb_plugin_iface::reset) `new_sched_time' parameter is added.

	* runlog.h:
	(run_open) `init_sched_time' parameter is added;
	(run_reset) `new_sched_time' parameter is added.

	* serve_state.h:
	(serve_reset_contest) `cnts' parameter is added.

	* contests.c, serve-control.c, super_html.c, super_html_2.c, super_html_4.c, super-serve.c:
	<start_date> is renamed to <sched_time>.

	* convert-runs.c:
	(main) calls of `run_open' are updated.

	* new_server_html.c:
	(priv_contest_operation) call of `serve_reset_contest' is updated.

	* rldb_plugin_file.c:
	(read_runlog) `init_sched_time' parameter is added;
	  `init_sched_time' is written to empty runlog;
	(do_run_open) `init_sched_time' parameter is added;
	  call of `read_runlog' is updated;
	(open_func) `init_sched_time' parameter is added;
	  call of `do_run_open' is updated;
	(reset_func) `new_sched_time' parameter is added.

	* runlog.c:
	(run_open) `init_sched_time' parameter is added;
	  call of `iface->open' is updated;
	(run_reset) `new_sched_time' parameter is added;
	  call of `iface->reset' is updated.

	* serve.c:
	(main) call of `run_open' is updated.

	* serve_2.c:
	(serve_reset_contest) `cnts' parameter is added;
	  call of `run_reset' is updated.

	* serve_state.c:
	(serve_state_load_contest) call of `run_open' is updated.

2008-11-15 (r5306) Alexander Chernov  <cher@ejudge.ru>

	* contests.h:
	support for <start_date> element is added.

	* super_proto.h:
	editing of <start_date> contest element is supported.

	* contests.c:
	support for <start_date> element is added.

	* new_server_proto.c:
	`printing error' message is changed.

	* serve-control.c, super_html.c, super_html_2.c, super_html_4.c, super-serve.c:
	editing of <start_date> element is supported.

2008-11-15 (r5304) Alexander Chernov  <cher@ejudge.ru>

	* filter_tree.c: copyright notice is updated;
	"xml_utils.h" is included;
	(filter_tree_eval_node) `xml_parse_date' is used.

	* new_server_html.c, new_server_html_4.c:
	(do_schedule) `xml_parse_date' is used;
